SystemOrganization addCategory: #'SmaCCDev-ParserGenerator'!
SystemOrganization addCategory: #'SmaCCDev-ScannerGenerator'!
SystemOrganization addCategory: #'SmaCCDev-UI'!
SystemOrganization addCategory: #'SmaCCDev-Tests'!
SystemOrganization addCategory: #'SmaCCDev-Parsers'!

SmaCCParser subclass: #CParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Parsers'!

!CParser class methodsFor: 'generated-comments' stamp: 'jmb 1/23/2003 16:18'!
parserDefinitionComment

	"%id <TYPENAME> <IDENTIFIER> <CONSTANT> ;

translation_unit
	: external_declaration
	| translation_unit external_declaration
	;

primary_expression
	: <IDENTIFIER>
	| <CONSTANT>
	| <STRINGLITERAL>
	| ""("" expression "")""
	;

postfix_expression
	: primary_expression
	| postfix_expression <LEFTBLOCK> expression <RIGHTBLOCK>
	| postfix_expression ""("" "")""
	| postfix_expression ""("" argument_expression_list "")""
	| postfix_expression ""."" <IDENTIFIER>
	| postfix_expression ""->"" <IDENTIFIER>
	| postfix_expression ""++""
	| postfix_expression ""--""
	;

argument_expression_list
	: assignment_expression
	| argument_expression_list "","" assignment_expression
	;

unary_expression
	: postfix_expression
	| ""++"" unary_expression
	| ""--"" unary_expression
	| unary_operator cast_expression
	| ""sizeof"" unary_expression
	| ""sizeof"" ""("" type_name "")""
	;

unary_operator
	: ""&""
	| ""*""
	| ""+""
	| ""-""
	| ""~""
	| ""!!""
	;

cast_expression
	: unary_expression
	| ""("" type_name "")"" cast_expression
	;

multiplicative_expression
	: cast_expression
	| multiplicative_expression ""*"" cast_expression
	| multiplicative_expression ""/"" cast_expression
	| multiplicative_expression ""%"" cast_expression
	;

additive_expression
	: multiplicative_expression
	| additive_expression ""+"" multiplicative_expression
	| additive_expression ""-"" multiplicative_expression
	;

shift_expression
	: additive_expression
	| shift_expression ""<<"" additive_expression
	| shift_expression "">>"" additive_expression
	;

relational_expression
	: shift_expression
	| relational_expression ""<"" shift_expression
	| relational_expression "">"" shift_expression
	| relational_expression ""<="" shift_expression
	| relational_expression "">="" shift_expression
	;

equality_expression
	: relational_expression
	| equality_expression ""=="" relational_expression
	| equality_expression ""!!="" relational_expression
	;

and_expression
	: equality_expression
	| and_expression ""&"" equality_expression
	;

exclusive_or_expression
	: and_expression
	| exclusive_or_expression ""^"" and_expression
	;

inclusive_or_expression
	: exclusive_or_expression
	| inclusive_or_expression ""|"" exclusive_or_expression
	;

logical_and_expression
	: inclusive_or_expression
	| logical_and_expression ""&&"" inclusive_or_expression
	;

logical_or_expression
	: logical_and_expression
	| logical_or_expression ""||"" logical_and_expression
	;

conditional_expression
	: logical_or_expression
	| logical_or_expression ""?"" expression "":"" conditional_expression
	;

assignment_expression
	: conditional_expression
	| unary_expression assignment_operator assignment_expression
	;

assignment_operator
	: ""=""
	| ""*=""
	| ""/=""
	| ""%=""
	| ""+=""
	| ""-=""
	| ""<<=""
	| "">>=""
	| ""&=""
	| ""^=""
	| ""|=""
	;

expression
	: assignment_expression
	| expression "","" assignment_expression
	;

constant_expression
	: conditional_expression
	;

declaration
	: declaration_specifiers "";""
	| declaration_specifiers init_declarator_list "";""
	;

declaration_specifiers
	: storage_class_specifier
	| storage_class_specifier declaration_specifiers
	| type_specifier
	| type_specifier declaration_specifiers
	| type_qualifier
	| type_qualifier declaration_specifiers
	;

init_declarator_list
	: init_declarator
	| init_declarator_list "","" init_declarator
	;

init_declarator
	: declarator
	| declarator ""="" initializer
	;

storage_class_specifier
	: ""typedef""
	| ""extern""
	| ""static""
	| ""auto""
	| ""register""
	;

type_specifier
	: ""void""
	| ""char""
	| ""short""
	| ""int""
	| ""long""
	| ""float""
	| ""double""
	| ""signed""
	| ""unsigned""
	| struct_or_union_specifier
	| enum_specifier
	| <TYPENAME>
	;

struct_or_union_specifier
	: struct_or_union <IDENTIFIER> <LEFTBRACE> struct_declaration_list <RIGHTBRACE> {self addTypeName: '2' value. self reduceFor: nodes}
	| struct_or_union <LEFTBRACE> struct_declaration_list <RIGHTBRACE>
	| struct_or_union <IDENTIFIER> {self addTypeName: '2' value. self reduceFor: nodes}
	;

struct_or_union
	: ""struct""
	| ""union""
	;

struct_declaration_list
	: struct_declaration
	| struct_declaration_list struct_declaration
	;

struct_declaration
	: specifier_qualifier_list struct_declarator_list "";""
	;

specifier_qualifier_list
	: type_specifier specifier_qualifier_list
	| type_specifier
	| type_qualifier specifier_qualifier_list
	| type_qualifier
	;

struct_declarator_list
	: struct_declarator
	| struct_declarator_list "","" struct_declarator
	;

struct_declarator
	: declarator
	| "":"" constant_expression
	| declarator "":"" constant_expression
	;

enum_specifier
	: ""enum"" <LEFTBRACE> enumerator_list <RIGHTBRACE>
	| ""enum"" <IDENTIFIER> <LEFTBRACE> enumerator_list <RIGHTBRACE>  {self addTypeName: '2' value. self reduceFor: nodes}
	| ""enum"" <IDENTIFIER>  {self addTypeName: '2' value. self reduceFor: nodes}
	;

enumerator_list
	: enumerator
	| enumerator_list "","" enumerator
	;

enumerator
	: <IDENTIFIER>
	| <IDENTIFIER> ""="" constant_expression
	;

type_qualifier
	: ""const""
	| ""volatile""
	;

declarator
	: pointer direct_declarator
	| direct_declarator
	;

direct_declarator
	: <IDENTIFIER>
	| ""("" declarator "")""
	| direct_declarator <LEFTBLOCK> constant_expression <RIGHTBLOCK>
	| direct_declarator <LEFTBLOCK> <RIGHTBLOCK>
	| direct_declarator ""("" parameter_type_list "")""
	| direct_declarator ""("" identifier_list "")""
	| direct_declarator ""("" "")""
	;

pointer
	: ""*""
	| ""*"" type_qualifier_list
	| ""*"" pointer
	| ""*"" type_qualifier_list pointer
	;

type_qualifier_list
	: type_qualifier
	| type_qualifier_list type_qualifier
	;


parameter_type_list
	: parameter_list
	| parameter_list "","" <ELLIPSIS>
	;

parameter_list
	: parameter_declaration
	| parameter_list "","" parameter_declaration
	;

parameter_declaration
	: declaration_specifiers declarator
	| declaration_specifiers abstract_declarator
	| declaration_specifiers
	;

identifier_list
	: <IDENTIFIER>
	| identifier_list "","" <IDENTIFIER>
	;

type_name
	: specifier_qualifier_list
	| specifier_qualifier_list abstract_declarator
	;

abstract_declarator
	: pointer
	| direct_abstract_declarator
	| pointer direct_abstract_declarator
	;

direct_abstract_declarator
	: ""("" abstract_declarator "")""
	| <LEFTBLOCK> <RIGHTBLOCK>
	| <LEFTBLOCK> constant_expression <RIGHTBLOCK>
	| direct_abstract_declarator <LEFTBLOCK> <RIGHTBLOCK>
	| direct_abstract_declarator <LEFTBLOCK> constant_expression <RIGHTBLOCK>
	| ""("" "")""
	| ""("" parameter_type_list "")""
	| direct_abstract_declarator ""("" "")""
	| direct_abstract_declarator ""("" parameter_type_list "")""
	;

initializer
	: assignment_expression
	| <LEFTBRACE> initializer_list <RIGHTBRACE>
	| <LEFTBRACE> initializer_list "","" <RIGHTBRACE>
	;

initializer_list
	: initializer
	| initializer_list "","" initializer
	;

statement
	: labeled_statement
	| compound_statement
	| expression_statement
	| selection_statement
	| iteration_statement
	| jump_statement
	;

labeled_statement
	: <IDENTIFIER> "":"" statement
	| ""case"" constant_expression "":"" statement
	| ""default"" "":"" statement
	;

compound_statement
	: <LEFTBRACE> <RIGHTBRACE>
	| <LEFTBRACE> statement_list <RIGHTBRACE>
	| <LEFTBRACE> declaration_list <RIGHTBRACE>
	| <LEFTBRACE> declaration_list statement_list <RIGHTBRACE>
	;

declaration_list
	: declaration
	| declaration_list declaration
	;

statement_list
	: statement
	| statement_list statement
	;

expression_statement
	: "";""
	| expression "";""
	;

selection_statement
	: ""if"" ""("" expression "")"" statement
	| ""if"" ""("" expression "")"" statement ""else"" statement
	| ""switch"" ""("" expression "")"" statement
	;

iteration_statement
	: ""while"" ""("" expression "")"" statement
	| ""do"" statement ""while"" ""("" expression "")"" "";""
	| ""for"" ""("" expression_statement expression_statement "")"" statement
	| ""for"" ""("" expression_statement expression_statement expression "")"" statement
	;

jump_statement
	: ""goto"" <IDENTIFIER> "";""
	| ""continue"" "";""
	| ""break"" "";""
	| ""return"" "";""
	| ""return"" expression "";""
	;

external_declaration
	: function_definition
	| declaration
	;

function_definition
	: declaration_specifiers declarator declaration_list compound_statement
	| declaration_specifiers declarator compound_statement
	| declarator declaration_list compound_statement
	| declarator compound_statement
	;

"! !

!CParser class methodsFor: 'generated-accessing' stamp: 'jmb 1/23/2003 16:18'!
scannerClass
	^CScanner! !

!CParser class methodsFor: 'generated-starting states' stamp: 'jmb 1/23/2003 16:18'!
startingStateFortranslationXunit
	^1! !

!CParser methodsFor: 'scanning' stamp: ''!
addTypeName: aString 
	scanner addTypeName: aString! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:18'!
reduceActionForenumXspecifier2: nodes 
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:18'!
reduceActionForenumXspecifier3: nodes 
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:18'!
reduceActionForstructXorXunionXspecifier1: nodes 
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:18'!
reduceActionForstructXorXunionXspecifier3: nodes 
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes! !

!CParser methodsFor: 'generated-tables' stamp: 'jmb 1/23/2003 16:18'!
reduceTable
	^#(
#(84 1 #reduceFor:)
#(84 4 #reduceFor:)
#(84 3 #reduceFor:)
#(84 4 #reduceFor:)
#(84 3 #reduceFor:)
#(84 3 #reduceFor:)
#(84 2 #reduceFor:)
#(84 2 #reduceFor:)
#(85 1 #reduceFor:)
#(85 1 #reduceFor:)
#(85 1 #reduceFor:)
#(85 3 #reduceFor:)
#(86 1 #reduceFor:)
#(86 3 #reduceFor:)
#(87 1 #reduceFor:)
#(87 3 #reduceFor:)
#(88 1 #reduceFor:)
#(88 2 #reduceFor:)
#(88 2 #reduceFor:)
#(88 2 #reduceFor:)
#(88 2 #reduceFor:)
#(88 4 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(90 1 #reduceFor:)
#(90 4 #reduceFor:)
#(91 1 #reduceFor:)
#(91 2 #reduceFor:)
#(92 1 #reduceFor:)
#(92 3 #reduceFor:)
#(92 3 #reduceFor:)
#(92 3 #reduceFor:)
#(93 1 #reduceFor:)
#(93 3 #reduceFor:)
#(93 3 #reduceFor:)
#(94 1 #reduceFor:)
#(94 3 #reduceFor:)
#(94 3 #reduceFor:)
#(95 1 #reduceFor:)
#(95 3 #reduceFor:)
#(95 3 #reduceFor:)
#(95 3 #reduceFor:)
#(95 3 #reduceFor:)
#(96 1 #reduceFor:)
#(96 3 #reduceFor:)
#(96 3 #reduceFor:)
#(97 1 #reduceFor:)
#(97 3 #reduceFor:)
#(98 1 #reduceFor:)
#(98 3 #reduceFor:)
#(99 1 #reduceFor:)
#(99 3 #reduceFor:)
#(100 1 #reduceFor:)
#(100 3 #reduceFor:)
#(101 1 #reduceFor:)
#(101 3 #reduceFor:)
#(102 1 #reduceFor:)
#(102 5 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(104 1 #reduceFor:)
#(105 1 #reduceFor:)
#(105 2 #reduceFor:)
#(105 1 #reduceFor:)
#(105 2 #reduceFor:)
#(105 1 #reduceFor:)
#(105 2 #reduceFor:)
#(106 1 #reduceFor:)
#(106 3 #reduceFor:)
#(107 2 #reduceFor:)
#(107 3 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(110 1 #reduceFor:)
#(110 1 #reduceFor:)
#(111 1 #reduceFor:)
#(111 3 #reduceFor:)
#(112 2 #reduceFor:)
#(112 1 #reduceFor:)
#(113 1 #reduceFor:)
#(113 3 #reduceFor:)
#(114 5 #reduceActionForstructXorXunionXspecifier1:)
#(114 4 #reduceFor:)
#(114 2 #reduceActionForstructXorXunionXspecifier3:)
#(115 4 #reduceFor:)
#(115 5 #reduceActionForenumXspecifier2:)
#(115 2 #reduceActionForenumXspecifier3:)
#(116 1 #reduceFor:)
#(116 1 #reduceFor:)
#(117 1 #reduceFor:)
#(118 1 #reduceFor:)
#(118 2 #reduceFor:)
#(119 1 #reduceFor:)
#(119 2 #reduceFor:)
#(120 3 #reduceFor:)
#(121 2 #reduceFor:)
#(121 1 #reduceFor:)
#(121 2 #reduceFor:)
#(121 1 #reduceFor:)
#(122 1 #reduceFor:)
#(122 3 #reduceFor:)
#(123 1 #reduceFor:)
#(123 2 #reduceFor:)
#(123 3 #reduceFor:)
#(124 1 #reduceFor:)
#(124 3 #reduceFor:)
#(125 1 #reduceFor:)
#(125 3 #reduceFor:)
#(126 1 #reduceFor:)
#(126 2 #reduceFor:)
#(126 2 #reduceFor:)
#(126 3 #reduceFor:)
#(127 1 #reduceFor:)
#(127 3 #reduceFor:)
#(127 4 #reduceFor:)
#(127 3 #reduceFor:)
#(127 4 #reduceFor:)
#(127 4 #reduceFor:)
#(127 3 #reduceFor:)
#(128 1 #reduceFor:)
#(128 3 #reduceFor:)
#(129 1 #reduceFor:)
#(129 3 #reduceFor:)
#(130 1 #reduceFor:)
#(130 2 #reduceFor:)
#(131 1 #reduceFor:)
#(131 3 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(133 2 #reduceFor:)
#(133 2 #reduceFor:)
#(133 1 #reduceFor:)
#(134 1 #reduceFor:)
#(134 1 #reduceFor:)
#(134 2 #reduceFor:)
#(135 3 #reduceFor:)
#(135 2 #reduceFor:)
#(135 3 #reduceFor:)
#(135 3 #reduceFor:)
#(135 4 #reduceFor:)
#(135 2 #reduceFor:)
#(135 3 #reduceFor:)
#(135 3 #reduceFor:)
#(135 4 #reduceFor:)
#(136 1 #reduceFor:)
#(136 3 #reduceFor:)
#(137 3 #reduceFor:)
#(137 4 #reduceFor:)
#(137 3 #reduceFor:)
#(138 2 #reduceFor:)
#(138 3 #reduceFor:)
#(138 3 #reduceFor:)
#(138 4 #reduceFor:)
#(139 1 #reduceFor:)
#(139 2 #reduceFor:)
#(140 5 #reduceFor:)
#(140 7 #reduceFor:)
#(140 5 #reduceFor:)
#(141 5 #reduceFor:)
#(141 7 #reduceFor:)
#(141 6 #reduceFor:)
#(141 7 #reduceFor:)
#(142 3 #reduceFor:)
#(142 2 #reduceFor:)
#(142 2 #reduceFor:)
#(142 2 #reduceFor:)
#(142 3 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(144 1 #reduceFor:)
#(144 2 #reduceFor:)
#(145 1 #reduceFor:)
#(145 2 #reduceFor:)
#(146 4 #reduceFor:)
#(146 3 #reduceFor:)
#(146 3 #reduceFor:)
#(146 2 #reduceFor:)
#(150 1 #reduceFor:)
#(150 3 #reduceFor:)
#(150 4 #reduceFor:)
)! !

!CParser methodsFor: 'generated-tables' stamp: 'jmb 1/23/2003 16:18'!
transitionTable
	^#(
#(3 9 25 13 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 93 76 97 105 101 107 105 108 109 109 113 110 117 112 121 114 125 115 129 116 133 119 137 126 141 127 145 132 149 146 153 149)
#(3 9 25 13 34 93 76 157 112 137 126 141 127)
#(3 550 21 550 25 550 26 13 34 17 40 21 41 550 76 550 79 161 110 165 126 169 130)
#(2 410 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 414 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 466 76 81)
#(2 470 76 81)
#(3 173 76 177 81)
#(2 390 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 394 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 342 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 346 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 386 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 350 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 378 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 382 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 370 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 374 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 354 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 366 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 358 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 362 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 566 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(3 9 25 13 34 181 60 93 76 185 106 189 111 193 112 137 126 141 127)
#(2 630 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(3 302 21 302 25 302 26 302 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 302 60 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 302 76 302 79 197 105 105 108 109 109 113 110 121 114 125 115 129 116 153 149)
#(3 310 21 310 25 310 26 310 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 310 60 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 310 76 310 79 201 105 105 108 109 109 113 110 121 114 125 115 129 116 153 149)
#(3 318 21 318 25 318 26 318 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 318 60 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 318 76 318 79 205 105 105 108 109 109 113 110 121 114 125 115 129 116 153 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 209 81 213 105 217 107 105 108 109 109 113 110 121 114 125 115 129 116 221 138 225 145 153 149)
#(2 398 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 402 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(3 229 76 233 81)
#(3 9 25 13 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 93 76 97 105 101 107 105 108 109 109 113 110 117 112 121 114 125 115 129 116 137 126 141 127 237 132 149 146 0 147 153 149)
#(3 9 25 93 76 241 127)
#(3 430 16 430 17 430 21 245 25 430 26 430 40 430 41 430 43 430 44 430 45 430 51 430 55 430 57 430 58 430 60 430 61 430 65 430 66 430 67 430 68 430 69 430 70 430 71 430 72 430 73 249 79 430 81 430 149)
#(2 486 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(2 626 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(2 406 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 253 26)
#(2 610 21 25 26 34 40 41 76 79)
#(2 558 21 25 26 76 79)
#(3 554 21 554 25 554 26 13 34 17 40 21 41 554 76 554 79 257 110 261 126)
#(3 462 16 462 21 462 25 462 26 462 34 462 40 462 41 462 43 462 44 462 45 462 51 462 55 462 57 462 58 462 60 462 61 462 65 462 66 462 67 462 68 462 69 462 70 462 71 462 72 462 73 462 76 462 79 265 81 462 149)
#(3 269 76 273 124 277 125)
#(2 334 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 147 149)
#(3 281 21 285 60)
#(2 326 21 60)
#(3 289 17 418 21 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 418 60 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 209 81 213 105 217 107 105 108 109 109 113 110 121 114 125 115 129 116 293 138 297 145 153 149)
#(2 306 21 25 26 34 60 76 79)
#(2 314 21 25 26 34 60 76 79)
#(2 322 21 25 26 34 60 76 79)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 17 40 21 41 353 42 25 43 29 44 33 45 357 47 361 48 365 49 369 50 37 51 373 52 377 53 381 54 41 55 45 57 49 58 385 60 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 389 76 393 77 397 78 209 81 401 82 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 213 105 217 107 105 108 109 109 113 110 473 113 121 114 125 115 129 116 477 137 481 138 485 139 489 140 493 141 497 142 501 143 505 144 509 145 153 149)
#(3 9 25 13 34 181 60 93 76 185 106 189 111 513 112 137 126 141 127)
#(2 818 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 149)
#(2 838 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 209 81 213 105 517 107 105 108 109 109 113 110 121 114 125 115 129 116 521 138 153 149)
#(3 450 16 450 21 450 25 450 26 450 34 450 40 450 41 450 43 450 44 450 45 450 51 450 55 450 57 450 58 450 60 450 61 450 65 450 66 450 67 450 68 450 69 450 70 450 71 450 72 450 73 450 76 450 79 525 81 450 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 529 109 533 110 121 114 125 115 129 116 537 118 541 120 545 121 153 149)
#(2 490 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(3 426 16 426 17 426 21 245 25 426 26 426 40 426 41 426 43 426 44 426 45 426 51 426 55 426 57 426 58 426 60 426 61 426 65 426 66 426 67 426 68 426 69 426 70 426 71 426 72 426 73 249 79 426 81 426 149)
#(3 549 26 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 553 76 557 105 105 108 109 109 113 110 121 114 125 115 129 116 561 128 565 129 569 131 573 133 153 149)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 581 80 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 593 104)
#(2 570 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(2 614 21 25 26 34 40 41 76 79)
#(2 562 21 25 26 76 79)
#(3 269 76 597 124 277 125)
#(3 601 17 542 21 542 82)
#(3 605 21 609 82)
#(2 534 21 82)
#(3 9 25 13 34 93 76 613 111 513 112 137 126 141 127)
#(2 338 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 147 149)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 617 81 405 84 409 85 621 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 625 150)
#(2 830 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 209 81 213 105 517 107 105 108 109 109 113 110 121 114 125 115 129 116 629 138 153 149)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 633 60 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 637 113)
#(3 305 20 309 23 313 24 641 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 645 88 421 89)
#(3 305 20 309 23 313 24 641 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 649 88 421 89)
#(3 305 20 309 23 313 24 653 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 657 88 421 89)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 661 91 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 529 109 533 110 665 113 121 114 125 115 129 116 669 121 153 149)
#(2 94 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 110 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 114 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 98 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 102 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 106 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 673 104)
#(2 677 16)
#(2 681 25)
#(2 685 60)
#(2 689 60)
#(2 693 25)
#(2 697 76)
#(2 701 25)
#(2 705 25)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 709 143)
#(2 730 19 20 23 24 25 26 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 38 1 38 2 38 3 38 4 38 5 38 6 38 7 38 8 38 9 38 10 38 11 38 12 38 13 38 14 38 15 713 16 38 17 38 18 38 20 38 21 38 22 38 23 38 25 38 27 38 28 38 29 38 30 38 33 38 34 38 35 38 36 38 37 38 56 38 59 38 60 38 62 38 63 38 64 38 79)
#(2 42 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 46 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 714 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 147 149)
#(3 70 1 70 2 70 3 70 4 70 5 70 6 70 7 70 8 70 9 70 10 70 11 70 12 70 13 70 14 70 15 70 16 70 17 70 18 717 20 70 21 721 22 725 23 729 25 70 26 733 27 70 28 70 29 70 30 70 33 70 34 70 35 70 36 70 37 70 56 70 59 70 60 70 62 70 63 70 64 737 79 70 80 70 82)
#(2 6 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 434 16 21 26 60 80)
#(3 118 1 118 2 118 3 118 4 118 5 118 6 118 7 118 8 118 9 741 10 745 11 749 12 753 13 118 14 118 15 118 16 757 17 118 18 118 21 118 26 118 28 118 29 118 30 118 33 118 34 118 35 118 36 761 37 765 56 769 59 118 60 773 62 777 63 781 64 118 80 118 82 785 103)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 789 90)
#(2 134 1 2 3 4 5 6 7 8 9 14 15 16 18 21 26 28 29 30 33 34 35 36 60 80 82)
#(3 150 1 150 2 150 3 150 4 150 5 150 6 150 7 150 8 150 9 150 14 150 15 150 16 150 18 150 21 150 26 150 28 793 29 797 30 150 33 801 34 150 35 150 36 150 60 150 80 150 82)
#(3 162 1 162 2 162 3 162 4 162 5 162 6 162 7 162 8 162 9 162 14 162 15 162 16 162 18 162 21 162 26 162 28 162 33 805 35 809 36 162 60 162 80 162 82)
#(3 174 1 174 2 174 3 174 4 174 5 174 6 174 7 174 8 174 9 813 14 174 15 174 16 174 18 174 21 174 26 174 28 817 33 174 60 174 80 174 82)
#(3 194 1 194 2 194 3 194 4 194 5 821 6 825 7 829 8 194 9 194 15 194 16 833 18 194 21 194 26 194 28 194 60 194 80 194 82)
#(3 206 1 206 2 837 3 841 4 206 5 206 9 206 15 206 16 206 21 206 26 206 28 206 60 206 80 206 82)
#(3 214 1 214 2 214 5 214 9 214 15 214 16 214 21 214 26 845 28 214 60 214 80 214 82)
#(3 849 1 222 2 222 5 222 9 222 15 222 16 222 21 222 26 222 60 222 80 222 82)
#(3 853 2 230 5 230 9 230 15 230 16 230 21 230 26 230 60 230 80 230 82)
#(3 857 5 238 9 238 15 238 16 238 21 238 26 238 60 238 80 238 82)
#(3 861 9 865 15 246 16 246 21 246 26 246 60 246 80 246 82)
#(2 62 16 21 26 60 80 82)
#(3 869 21 873 60)
#(2 786 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 790 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 794 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 798 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 802 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 806 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 810 19 20 23 24 25 28 31 32 34 35 36 38 39 42 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 877 82 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 881 143)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 17 40 21 41 353 42 25 43 29 44 33 45 357 47 361 48 365 49 369 50 37 51 373 52 377 53 381 54 41 55 45 57 49 58 385 60 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 389 76 393 77 397 78 209 81 885 82 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 213 105 517 107 105 108 109 109 113 110 473 113 121 114 125 115 129 116 477 137 481 138 485 139 489 140 493 141 497 142 501 143 889 144 153 149)
#(3 289 17 418 21 418 60)
#(2 822 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 149)
#(2 834 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 529 109 533 110 121 114 125 115 129 116 893 118 541 120 545 121 153 149)
#(3 502 16 502 25 502 26 502 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 502 76 502 79 529 109 533 110 121 114 125 115 129 116 897 121 153 149)
#(3 510 16 510 25 510 26 510 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 510 76 510 79 529 109 533 110 121 114 125 115 129 116 901 121 153 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 905 82 529 109 533 110 121 114 125 115 129 116 909 120 545 121 153 149)
#(2 478 40 41 43 44 45 51 55 61 66 67 68 69 71 73 82 149)
#(3 913 16 9 25 13 34 93 76 917 112 921 122 925 123 137 126 141 127)
#(2 590 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(2 602 21 26)
#(3 642 21 929 25 642 26 13 34 93 76 933 79 937 112 941 126 141 127 945 134 949 135)
#(2 953 26)
#(3 957 21 961 26)
#(3 965 21 594 26)
#(2 618 21 26)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 578 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(2 118 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(2 298 16 21 60 80 82)
#(2 969 80)
#(3 605 21 973 82)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 977 104)
#(3 269 76 981 125)
#(2 454 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 330 21 60)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 617 81 405 84 409 85 621 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 985 136 989 150)
#(2 842 21 60 82)
#(2 422 21 60)
#(2 826 25 34 40 41 43 44 45 51 55 57 58 61 65 66 67 68 69 70 71 72 73 76 147 149)
#(2 778 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 869 21 993 60)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 665 113)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 997 91 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 529 109 533 110 665 113 121 114 125 115 129 116 669 121 153 149)
#(2 86 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(2 1001 26)
#(3 869 21 1005 26)
#(3 1009 25 126 26 13 34 933 79 1013 126 1017 134 949 135)
#(2 1021 16)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1025 143)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1029 113)
#(2 770 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 774 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 385 60 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 1033 139)
#(2 1037 60)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1041 113)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1045 113)
#(2 1049 53)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1053 143)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 1057 76)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(3 305 20 309 23 313 24 317 25 1061 26 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 1065 86 1069 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102)
#(2 1073 76)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1077 113)
#(2 266 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 270 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 258 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 262 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 254 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 274 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 278 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 294 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 282 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 286 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(2 290 20 23 24 25 28 31 32 34 35 36 76 77 78)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 1081 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102)
#(2 82 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 1085 90)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 1089 90)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 1093 90)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 1097 92)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 1101 92)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 1105 93)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 1109 93)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 1113 94)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 1117 94)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 1121 94)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 1125 94)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 1129 95)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 1133 95)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 1137 96)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 1141 97)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 1145 98)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 1149 99)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 1153 100)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1157 113)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 1161 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102)
#(2 734 19 20 23 24 25 26 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 718 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 147 149)
#(2 814 19 20 23 24 25 28 31 32 34 35 36 38 39 42 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 722 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 147 149)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 1165 82 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 881 143)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 53 61 61 66 65 67 69 68 73 69 81 71 89 73 1169 82 529 109 533 110 121 114 125 115 129 116 909 120 545 121 153 149)
#(2 498 16 25 26 34 76 79)
#(2 506 16 25 26 34 76 79)
#(2 446 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 482 40 41 43 44 45 51 55 61 66 67 68 69 71 73 82 149)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 1173 104)
#(3 1177 16 522 21 522 60)
#(3 1181 21 1185 60)
#(2 514 21 60)
#(3 929 25 1189 26 13 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 93 76 933 79 557 105 105 108 109 109 113 110 157 112 121 114 125 115 129 116 941 126 141 127 1193 128 569 131 573 133 1197 134 949 135 153 149)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 1201 80 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 1205 104)
#(2 634 21 26)
#(3 646 21 929 25 646 26 93 76 933 79 241 127 1209 135)
#(2 638 21 26)
#(3 650 21 1213 25 650 26 1217 79)
#(2 582 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(2 1221 76)
#(2 586 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(3 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 1225 74 557 105 105 108 109 109 113 110 121 114 125 115 129 116 1229 133 153 149)
#(2 574 16 17 21 25 26 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 79 81 149)
#(2 458 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 546 21 82)
#(2 538 21 82)
#(3 1233 21 1237 82)
#(2 694 21 82)
#(2 782 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 1241 26)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 1245 90)
#(2 50 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(3 1009 25 1189 26 13 34 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 933 79 557 105 105 108 109 109 113 110 121 114 125 115 129 116 1013 126 1193 128 569 131 573 133 1197 134 949 135 153 149)
#(3 1009 25 646 26 933 79 1209 135)
#(2 130 26)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1249 143)
#(2 710 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 869 21 1253 26)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 385 60 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 1257 139)
#(2 766 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 869 21 1261 26)
#(3 869 21 1265 26)
#(2 1269 25)
#(2 702 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 14 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(3 1273 21 1277 26)
#(2 54 21 26)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(3 869 21 1281 80)
#(2 66 16 21 26 60 80 82)
#(2 142 1 2 3 4 5 6 7 8 9 14 15 16 18 21 26 28 29 30 33 34 35 36 60 80 82)
#(2 146 1 2 3 4 5 6 7 8 9 14 15 16 18 21 26 28 29 30 33 34 35 36 60 80 82)
#(2 138 1 2 3 4 5 6 7 8 9 14 15 16 18 21 26 28 29 30 33 34 35 36 60 80 82)
#(3 154 1 154 2 154 3 154 4 154 5 154 6 154 7 154 8 154 9 154 14 154 15 154 16 154 18 154 21 154 26 154 28 793 29 797 30 154 33 801 34 154 35 154 36 154 60 154 80 154 82)
#(3 158 1 158 2 158 3 158 4 158 5 158 6 158 7 158 8 158 9 158 14 158 15 158 16 158 18 158 21 158 26 158 28 793 29 797 30 158 33 801 34 158 35 158 36 158 60 158 80 158 82)
#(3 170 1 170 2 170 3 170 4 170 5 170 6 170 7 170 8 170 9 170 14 170 15 170 16 170 18 170 21 170 26 170 28 170 33 805 35 809 36 170 60 170 80 170 82)
#(3 166 1 166 2 166 3 166 4 166 5 166 6 166 7 166 8 166 9 166 14 166 15 166 16 166 18 166 21 166 26 166 28 166 33 805 35 809 36 166 60 166 80 166 82)
#(3 182 1 182 2 182 3 182 4 182 5 182 6 182 7 182 8 182 9 813 14 182 15 182 16 182 18 182 21 182 26 182 28 817 33 182 60 182 80 182 82)
#(3 186 1 186 2 186 3 186 4 186 5 186 6 186 7 186 8 186 9 813 14 186 15 186 16 186 18 186 21 186 26 186 28 817 33 186 60 186 80 186 82)
#(3 190 1 190 2 190 3 190 4 190 5 190 6 190 7 190 8 190 9 813 14 190 15 190 16 190 18 190 21 190 26 190 28 817 33 190 60 190 80 190 82)
#(3 178 1 178 2 178 3 178 4 178 5 178 6 178 7 178 8 178 9 813 14 178 15 178 16 178 18 178 21 178 26 178 28 817 33 178 60 178 80 178 82)
#(3 198 1 198 2 198 3 198 4 198 5 821 6 825 7 829 8 198 9 198 15 198 16 833 18 198 21 198 26 198 28 198 60 198 80 198 82)
#(3 202 1 202 2 202 3 202 4 202 5 821 6 825 7 829 8 202 9 202 15 202 16 833 18 202 21 202 26 202 28 202 60 202 80 202 82)
#(3 210 1 210 2 837 3 841 4 210 5 210 9 210 15 210 16 210 21 210 26 210 28 210 60 210 80 210 82)
#(3 218 1 218 2 218 5 218 9 218 15 218 16 218 21 218 26 845 28 218 60 218 80 218 82)
#(3 849 1 226 2 226 5 226 9 226 15 226 16 226 21 226 26 226 60 226 80 226 82)
#(3 853 2 234 5 234 9 234 15 234 16 234 21 234 26 234 60 234 80 234 82)
#(3 857 5 242 9 242 15 242 16 242 21 242 26 242 60 242 80 242 82)
#(3 1285 16 869 21)
#(2 438 16 21 26 60 80)
#(2 726 19 20 23 24 25 28 31 32 34 35 36 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 77 78 81 82 147 149)
#(2 442 16 21 25 26 34 40 41 43 44 45 51 55 57 58 60 61 65 66 67 68 69 70 71 72 73 76 79 149)
#(2 526 21 60)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 1289 104)
#(3 913 16 9 25 13 34 93 76 917 112 1293 123 137 126 141 127)
#(2 494 40 41 43 44 45 51 55 61 66 67 68 69 71 73 82 149)
#(2 678 21 25 26 79)
#(2 1297 26)
#(2 1301 26)
#(2 662 21 25 26 79)
#(2 1305 80)
#(3 654 21 1213 25 654 26 1217 79)
#(3 1309 26 17 40 21 41 25 43 29 44 33 45 37 51 41 55 45 57 49 58 53 61 57 65 61 66 65 67 69 68 73 69 77 70 81 71 85 72 89 73 557 105 105 108 109 109 113 110 121 114 125 115 129 116 1313 128 569 131 573 133 153 149)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 1317 80 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 589 102 1321 104)
#(2 606 21 26)
#(2 598 26)
#(2 622 21 26)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 617 81 1325 82 405 84 409 85 621 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1329 150)
#(2 846 21 60 82)
#(2 90 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(2 122 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 21 26 28 29 30 33 34 35 36 37 56 59 60 62 63 64 80 82)
#(2 706 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1333 143)
#(3 305 20 309 23 313 24 317 25 1337 26 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1341 113)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1345 143)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1349 143)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 1353 113)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 1357 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(2 10 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 20 21 22 23 25 26 27 28 29 30 33 34 35 36 37 56 59 60 62 63 64 79 80 82)
#(3 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 577 76 393 77 397 78 405 84 409 85 585 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 1361 102)
#(2 530 21 60)
#(2 518 21 60)
#(2 682 21 25 26 79)
#(2 658 21 25 26 79)
#(2 666 21 25 26 79)
#(2 686 21 25 26 79)
#(2 1365 26)
#(2 670 21 25 26 79)
#(2 1369 80)
#(2 850 21 60 82)
#(2 698 21 82)
#(3 738 19 738 20 738 23 738 24 738 25 738 28 738 31 738 32 738 34 738 35 738 36 738 38 738 39 738 42 1373 46 738 47 738 48 738 49 738 50 738 52 738 53 738 54 738 60 738 76 738 77 738 78 738 81 738 82)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1377 143)
#(3 869 21 1381 26)
#(2 746 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 750 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 869 21 1385 26)
#(2 58 21 26)
#(2 250 16 21 26 60 80 82)
#(2 690 21 25 26 79)
#(2 674 21 25 26 79)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1389 143)
#(2 758 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(3 301 19 305 20 309 23 313 24 317 25 321 28 325 31 329 32 333 34 337 35 341 36 345 38 349 39 353 42 357 47 361 48 365 49 369 50 373 52 377 53 381 54 385 60 389 76 393 77 397 78 209 81 405 84 409 85 413 87 417 88 421 89 425 90 429 92 433 93 437 94 441 95 445 96 449 97 453 98 457 99 461 100 465 101 469 102 473 113 477 137 481 138 485 139 489 140 493 141 497 142 1393 143)
#(2 1397 60)
#(2 742 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 762 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
#(2 754 19 20 23 24 25 28 31 32 34 35 36 38 39 42 46 47 48 49 50 52 53 54 60 76 77 78 81 82)
)! !

SmaCCParser subclass: #JavaParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Parsers'!

!JavaParser class methodsFor: 'generated-comments' stamp: 'jmb 1/23/2003 16:21'!
parserDefinitionComment

	"goal :	compilation_unit
	;

# 19.3) Lexical Structure.
literal :	<INTEGERLITERAL>
	|	<FLOATINGPOINTLITERAL>
	|	<BOOLEANLITERAL>
#	| 	""true""
#	| 	""false""
	|	<CHARACTERLITERAL>
	|	<STRINGLITERAL>
	|	<NULLLITERAL>
	;

# 19.4) Types, Values, and Variables
type	:	primitive_type
	|	reference_type
	;
primitive_type :
		numeric_type
	|	""boolean""
	;
numeric_type:	integral_type
	|	floating_point_type
	;
integral_type : 
		""byte"" 
	|	""short"" 
	|	""int"" 
	|	""long"" 
	|	""char"" 
	;
floating_point_type : 
		""float"" 
	|	""double""
	;

reference_type :
		class_or_interface_type
	|	array_type
	;
class_or_interface_type : name;

class_type :	class_or_interface_type;
interface_type : class_or_interface_type;		

array_type :	primitive_type dims
	|	name dims
	;

# 19.5) Names
name	:	simple_name
	|	qualified_name
	;
simple_name :	<IDENTIFIER>
	;
qualified_name :
		name ""."" <IDENTIFIER>
	;

# 19.6) ""package""s
compilation_unit :
		package_declaration_opt 
		import_declarations_opt
		type_declarations_opt
		;
package_declaration_opt : package_declaration | ;
import_declarations_opt : import_declarations | ;
type_declarations_opt   : type_declarations   | ;

import_declarations : 
		import_declaration
	|	import_declarations import_declaration
	;
type_declarations : 
		type_declaration
	|	type_declarations type_declaration
	;
package_declaration : 
		""package"" name "";""
	;
import_declaration : 
		single_type_import_declaration
	|	type_import_on_demand_declaration
	;
single_type_import_declaration : 
		""import"" name "";""
	;
type_import_on_demand_declaration :
		""import"" name ""."" ""*"" "";""
	;
type_declaration :
		class_declaration
	|	interface_declaration
	|	"";""
	;

# 19.7) Productions used only in the LALR(1) grammar
modifiers_opt:
	|	modifiers
	;
modifiers : 	modifier
	|	modifiers modifier
	;
modifier :	""public"" | ""protected"" | ""private""
	|	""static""
	|	""abstract"" | ""final"" | ""native"" | ""synchronized"" | ""transient"" | ""volatile""
	|	""strictfp"" # note that semantic analysis must check that the
	                 # context of the modifier allows strictfp.
	;

# 19.8) Classes

# 19.8.1) Class Declaration:
class_declaration : 
	modifiers_opt ""class"" <IDENTIFIER> super_opt interfaces_opt class_body
	;
super :	""extends"" class_type
	;
super_opt :	
	|	super
	;
interfaces :	""implements"" interface_type_list
	;
interfaces_opt:
	|	interfaces 
	;
interface_type_list : 
		interface_type
	|	interface_type_list "","" interface_type
	;
class_body :	""{"" class_body_declarations_opt ""}"" 
	;
class_body_declarations_opt : 
	|	class_body_declarations ;
class_body_declarations : 
		class_body_declaration
	|	class_body_declarations class_body_declaration
	;
class_body_declaration :
		class_member_declaration
	|	static_initializer
	|	constructor_declaration
	|	block
	;
class_member_declaration :
		field_declaration
	|	method_declaration
	# repeat the prod for 'class_declaration' here: 
	|	modifiers_opt ""class"" <IDENTIFIER> super_opt interfaces_opt class_body
	|	interface_declaration
	|	"";""
	;

# 19.8.2) Field Declarations
field_declaration : 
		modifiers_opt type variable_declarators "";""
	;
variable_declarators :
		variable_declarator
	|	variable_declarators "","" variable_declarator
	;
variable_declarator :
		variable_declarator_id
	|	variable_declarator_id ""="" variable_initializer
	;
variable_declarator_id :
		<IDENTIFIER>
	|	variable_declarator_id ""["" ""]""
	;
variable_initializer :
		expression
	|	array_initializer
	;

# 19.8.3) Method Declarations
method_declaration :
		method_header method_body
	;
method_header :
		modifiers_opt type method_declarator throws_opt
	|	modifiers_opt ""void"" method_declarator throws_opt
	;
method_declarator :
		<IDENTIFIER> ""("" formal_parameter_list_opt "")""
	|	method_declarator ""["" ""]"" # deprecated
	# be careful; the above production also allows 'void foo() []'
	;
formal_parameter_list_opt :
	|	formal_parameter_list
	;
formal_parameter_list :
		formal_parameter
	|	formal_parameter_list "","" formal_parameter
	;
formal_parameter :
		type variable_declarator_id
	|	""final"" type variable_declarator_id
	;
throws_opt :	
	|	throws
	;
throws :	""throws"" class_type_list
	;
class_type_list :
		class_type
	|	class_type_list "","" class_type
	;
method_body :	block
	|	"";""
	;

# 19.8.4) Static Initializers
static_initializer :
		""static"" block
	;

# 19.8.5) Constructor Declarations
constructor_declaration :
		modifiers_opt constructor_declarator throws_opt 
			constructor_body
	;
constructor_declarator :
		simple_name ""("" formal_parameter_list_opt "")""
	;
constructor_body :
		""{"" explicit_constructor_invocation
			block_statements ""}""
	|	""{"" explicit_constructor_invocation ""}""
	|	""{"" block_statements ""}""
	|	""{"" ""}""
	;
explicit_constructor_invocation :
		""this"" ""("" argument_list_opt "")"" "";""
	|	""super"" ""("" argument_list_opt "")"" "";""
	|	primary ""."" ""this"" ""("" argument_list_opt "")"" "";""
	|	primary ""."" ""super"" ""("" argument_list_opt "")"" "";""
	;

# 19.9) Interfaces

# 19.9.1) Interface Declarations
interface_declaration :
		modifiers_opt ""interface"" <IDENTIFIER> extends_interfaces_opt 
			interface_body
	;
extends_interfaces_opt :
	|	extends_interfaces
	;
extends_interfaces :
		""extends"" interface_type
	|	extends_interfaces "","" interface_type
	;
interface_body :
		""{"" interface_member_declarations_opt ""}""
	;
interface_member_declarations_opt :
	|	interface_member_declarations
	;
interface_member_declarations :
		interface_member_declaration
	|	interface_member_declarations interface_member_declaration
	;
interface_member_declaration :
		constant_declaration
	|	abstract_method_declaration
	|	class_declaration
	|	interface_declaration
	;
constant_declaration :
		field_declaration
	# need to semantically check that modifiers of field declaration
	# include only PUBLIC, ""static"", or ""final"".  Other modifiers are
	# disallowed.
	;
abstract_method_declaration :
		method_header "";""
	;

# 19.10) Arrays
array_initializer :
		""{"" variable_initializers "","" ""}""
	|	""{"" variable_initializers ""}""
	|	""{"" "","" ""}""
	|	""{"" ""}""
	;
variable_initializers :
		variable_initializer
	|	variable_initializers "","" variable_initializer
	;

# 19.11) Blocks and Statements
block :	""{"" block_statements_opt ""}""
	;
block_statements_opt :
	|	block_statements
	;
block_statements :
		block_statement
	|	block_statements block_statement
	;
block_statement :
		local_variable_declaration_statement
	|	statement
	|	class_declaration
	|	interface_declaration
	;
local_variable_declaration_statement :
		local_variable_declaration "";""
	;
local_variable_declaration :
		type variable_declarators
	|	""final"" type variable_declarators
	;
statement :	statement_without_trailing_substatement
	|	labeled_statement
	|	if_then_statement
	|	if_then_else_statement
	|	while_statement
	|	for_statement
	;
statement_no_short_if :
		statement_without_trailing_substatement
	|	labeled_statement_no_short_if
	|	if_then_else_statement_no_short_if
	|	while_statement_no_short_if
	|	for_statement_no_short_if
	;
statement_without_trailing_substatement :
		block
	|	empty_statement
	|	expression_statement
	|	switch_statement
	|	do_statement
	|	break_statement
	|	continue_statement
	|	return_statement
	|	synchronized_statement
	|	throw_statement
	|	try_statement
	;
empty_statement :
		"";""
	;
labeled_statement :
		<IDENTIFIER> "":"" statement
	;
labeled_statement_no_short_if :
		<IDENTIFIER> "":"" statement_no_short_if
	;
expression_statement :
		statement_expression "";""
	;
statement_expression :
		assignment
	|	preincrement_expression
	|	predecrement_expression
	|	postincrement_expression
	|	postdecrement_expression
	|	method_invocation
	|	class_instance_creation_expression
	;
if_then_statement :
		""if"" ""("" expression "")"" statement
	;
if_then_else_statement :
		""if"" ""("" expression "")"" statement_no_short_if 
			""else"" statement
	;
if_then_else_statement_no_short_if :
		""if"" ""("" expression "")"" statement_no_short_if
			""else"" statement_no_short_if
	;
switch_statement :
		""switch"" ""("" expression "")"" switch_block
	;
switch_block :
		""{"" switch_block_statement_groups switch_labels ""}""
	|	""{"" switch_block_statement_groups ""}""
	|	""{"" switch_labels ""}""
	|	""{"" ""}""
	;
switch_block_statement_groups :
		switch_block_statement_group
	|	switch_block_statement_groups switch_block_statement_group
	;
switch_block_statement_group :
		switch_labels block_statements
	;
switch_labels :
		switch_label
	|	switch_labels switch_label
	;
switch_label :
		""case"" constant_expression "":""
	|	""default"" "":""
	;

while_statement :
		""while"" ""("" expression "")"" statement
	;
while_statement_no_short_if :
		""while"" ""("" expression "")"" statement_no_short_if
	;
do_statement :
		""do"" statement ""while"" ""("" expression "")"" "";""
	;
for_statement :
		""for"" ""("" for_init_opt "";"" expression_opt "";""
			for_update_opt "")"" statement
	;
for_statement_no_short_if :
		""for"" ""("" for_init_opt "";"" expression_opt "";""
			for_update_opt "")"" statement_no_short_if
	;
for_init_opt :
	|	for_init
	;
for_init :	statement_expression_list
	|	local_variable_declaration
	;
for_update_opt :
	|	for_update
	;
for_update :	statement_expression_list
	;
statement_expression_list :
		statement_expression
	|	statement_expression_list "","" statement_expression
	;

identifier_opt : 
	|	<IDENTIFIER>
	;

break_statement :
		""break"" identifier_opt "";""
	;

continue_statement :
		""continue"" identifier_opt "";""
	;
return_statement :
		""return"" expression_opt "";""
	;
throw_statement :
		""throw"" expression "";""
	;
synchronized_statement :
		""synchronized"" ""("" expression "")"" block
	;
try_statement :
		""try"" block catches
	|	""try"" block catches_opt finally
	;
catches_opt :
	|	catches
	;
catches :	catch_clause
	|	catches catch_clause
	;
catch_clause :
		""catch"" ""("" formal_parameter "")"" block
	;
finally :	""finally"" block
	;

# 19.12) Expressions
primary :	primary_no_new_array
	|	array_creation_expression
	;
primary_no_new_array :
		literal
	|	""this""
	|	""("" expression "")""
	|	class_instance_creation_expression
	|	field_access
	|	method_invocation
	|	array_access
	|	primitive_type ""."" ""class""
	|	""void"" ""."" ""class""
	|	array_type ""."" ""class""
	|	name ""."" ""class""
	|	name ""."" ""this""
	;
class_instance_creation_expression :
		""new"" class_type ""("" argument_list_opt "")""
	|	""new"" class_type ""("" argument_list_opt "")"" class_body
	|	primary ""."" ""new"" <IDENTIFIER>
			""("" argument_list_opt "")""
	|	primary ""."" ""new"" <IDENTIFIER>
			""("" argument_list_opt "")"" class_body
	;
argument_list_opt :
	|	argument_list
	;
argument_list :
		expression
	|	argument_list "","" expression
	;
array_creation_expression :
		""new"" primitive_type dim_exprs dims_opt
	|	""new"" class_or_interface_type dim_exprs dims_opt
	|	""new"" primitive_type dims array_initializer
	|	""new"" class_or_interface_type dims array_initializer
	;
dim_exprs :	dim_expr
	|	dim_exprs dim_expr
	;
dim_expr :	""["" expression ""]""
	;
dims_opt :
	|	dims
	;
dims :	""["" ""]""
	|	dims ""["" ""]""
	;
field_access :
		primary ""."" <IDENTIFIER>
	|	""super"" ""."" <IDENTIFIER>
	|	name ""."" ""super"" ""."" <IDENTIFIER>
	;
method_invocation :
		name ""("" argument_list_opt "")""
	|	primary ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	|	""super"" ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	|	name ""."" ""super"" ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	;
array_access :
		name ""["" expression ""]""
	|	primary_no_new_array ""["" expression ""]""
	;
postfix_expression :
		primary
	|	name
	|	postincrement_expression
	|	postdecrement_expression
	;
postincrement_expression :
		postfix_expression ""++""
	;
postdecrement_expression :
		postfix_expression ""--""
	;
unary_expression :
		preincrement_expression
	|	predecrement_expression
	|	""+"" unary_expression
	|	""-"" unary_expression
	|	unary_expression_not_plus_minus
	;
preincrement_expression :
		""++"" unary_expression
	;
predecrement_expression :
		""--"" unary_expression
	;
unary_expression_not_plus_minus :
		postfix_expression
	|	""~"" unary_expression
	|	""!!"" unary_expression
	|	cast_expression
	;
cast_expression :
		""("" primitive_type dims_opt "")"" unary_expression
	|	""("" expression "")"" unary_expression_not_plus_minus
	|	""("" name dims "")"" unary_expression_not_plus_minus
	;
multiplicative_expression :
		unary_expression
	|	multiplicative_expression ""*"" unary_expression
	|	multiplicative_expression ""/"" unary_expression
	|	multiplicative_expression ""%"" unary_expression
	;
additive_expression :
		multiplicative_expression
	|	additive_expression ""+"" multiplicative_expression
	|	additive_expression ""-"" multiplicative_expression
	;
shift_expression :
		additive_expression
	|	shift_expression ""<<"" additive_expression
	|	shift_expression "">>"" additive_expression
	|	shift_expression "">>>"" additive_expression
	;
relational_expression :
		shift_expression
	|	relational_expression ""<"" shift_expression
	|	relational_expression "">"" shift_expression
	|	relational_expression ""<="" shift_expression
	|	relational_expression "">="" shift_expression
	|	relational_expression ""instanceof"" reference_type
	;
equality_expression :
		relational_expression
	|	equality_expression ""=="" relational_expression
	|	equality_expression ""!!="" relational_expression
	;
and_expression :
		equality_expression
	|	and_expression ""&"" equality_expression
	;
exclusive_or_expression :
		and_expression
	|	exclusive_or_expression ""^"" and_expression
	;
inclusive_or_expression :
		exclusive_or_expression
	|	inclusive_or_expression ""|"" exclusive_or_expression
	;
conditional_and_expression :
		inclusive_or_expression
	|	conditional_and_expression ""&&"" inclusive_or_expression
	;
conditional_or_expression :
		conditional_and_expression
	|	conditional_or_expression ""||"" conditional_and_expression
	;
conditional_expression :
		conditional_or_expression
	|	conditional_or_expression ""?"" expression 
			"":"" conditional_expression
	;
assignment_expression :
		conditional_expression
	|	assignment
	;
assignment :	left_hand_side assignment_operator assignment_expression
	;
left_hand_side :
		name
	|	field_access
	|	array_access
	;
assignment_operator :
		""=""
	|	""*=""
	|	""/=""
	|	""%=""
	|	""+=""
	|	""-=""
	|	""<<=""
	|	"">>=""
	|	"">>>=""
	|	""&=""
	|	""^=""
	|	""|=""
	;
expression_opt :
	|	expression
	;
expression :	assignment_expression
	;
constant_expression :
		expression
	;"! !

!JavaParser class methodsFor: 'generated-accessing' stamp: 'jmb 1/23/2003 16:21'!
scannerClass
	^JavaScanner! !

!JavaParser class methodsFor: 'generated-starting states' stamp: 'jmb 1/23/2003 16:21'!
startingStateForgoal
	^1! !

!JavaParser methodsFor: 'generated-tables' stamp: 'jmb 1/23/2003 16:21'!
reduceTable
	^#(
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(104 1 #reduceFor:)
#(104 1 #reduceFor:)
#(105 1 #reduceFor:)
#(105 1 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(109 1 #reduceFor:)
#(110 2 #reduceFor:)
#(110 2 #reduceFor:)
#(111 1 #reduceFor:)
#(111 1 #reduceFor:)
#(112 1 #reduceFor:)
#(113 1 #reduceFor:)
#(114 2 #reduceFor:)
#(114 3 #reduceFor:)
#(115 1 #reduceFor:)
#(116 3 #reduceFor:)
#(117 1 #reduceFor:)
#(118 1 #reduceFor:)
#(118 0 #reduceFor:)
#(119 1 #reduceFor:)
#(119 0 #reduceFor:)
#(120 1 #reduceFor:)
#(120 0 #reduceFor:)
#(121 3 #reduceFor:)
#(122 1 #reduceFor:)
#(122 2 #reduceFor:)
#(123 1 #reduceFor:)
#(123 2 #reduceFor:)
#(124 1 #reduceFor:)
#(124 1 #reduceFor:)
#(125 1 #reduceFor:)
#(125 1 #reduceFor:)
#(125 1 #reduceFor:)
#(126 3 #reduceFor:)
#(127 5 #reduceFor:)
#(128 6 #reduceFor:)
#(129 5 #reduceFor:)
#(130 3 #reduceFor:)
#(131 0 #reduceFor:)
#(131 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(133 0 #reduceFor:)
#(133 1 #reduceFor:)
#(134 0 #reduceFor:)
#(134 1 #reduceFor:)
#(135 3 #reduceFor:)
#(136 2 #reduceFor:)
#(137 1 #reduceFor:)
#(137 3 #reduceFor:)
#(138 2 #reduceFor:)
#(139 0 #reduceFor:)
#(139 1 #reduceFor:)
#(140 1 #reduceFor:)
#(140 2 #reduceFor:)
#(141 1 #reduceFor:)
#(141 1 #reduceFor:)
#(141 1 #reduceFor:)
#(141 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 6 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(143 2 #reduceFor:)
#(144 4 #reduceFor:)
#(145 3 #reduceFor:)
#(146 4 #reduceFor:)
#(147 2 #reduceFor:)
#(148 1 #reduceFor:)
#(148 3 #reduceFor:)
#(149 1 #reduceFor:)
#(149 3 #reduceFor:)
#(150 1 #reduceFor:)
#(150 3 #reduceFor:)
#(151 1 #reduceFor:)
#(151 1 #reduceFor:)
#(152 1 #reduceFor:)
#(153 4 #reduceFor:)
#(153 3 #reduceFor:)
#(153 3 #reduceFor:)
#(153 2 #reduceFor:)
#(154 4 #reduceFor:)
#(154 4 #reduceFor:)
#(155 1 #reduceFor:)
#(155 1 #reduceFor:)
#(156 4 #reduceFor:)
#(156 3 #reduceFor:)
#(157 0 #reduceFor:)
#(157 1 #reduceFor:)
#(158 0 #reduceFor:)
#(158 1 #reduceFor:)
#(159 1 #reduceFor:)
#(159 3 #reduceFor:)
#(160 2 #reduceFor:)
#(160 3 #reduceFor:)
#(161 2 #reduceFor:)
#(162 1 #reduceFor:)
#(162 3 #reduceFor:)
#(163 4 #reduceFor:)
#(164 4 #reduceFor:)
#(164 3 #reduceFor:)
#(164 3 #reduceFor:)
#(164 2 #reduceFor:)
#(165 5 #reduceFor:)
#(165 5 #reduceFor:)
#(165 7 #reduceFor:)
#(165 7 #reduceFor:)
#(166 1 #reduceFor:)
#(166 2 #reduceFor:)
#(167 0 #reduceFor:)
#(167 1 #reduceFor:)
#(168 1 #reduceFor:)
#(168 1 #reduceFor:)
#(169 0 #reduceFor:)
#(169 1 #reduceFor:)
#(170 3 #reduceFor:)
#(171 2 #reduceFor:)
#(171 3 #reduceFor:)
#(172 0 #reduceFor:)
#(172 1 #reduceFor:)
#(173 1 #reduceFor:)
#(173 2 #reduceFor:)
#(174 1 #reduceFor:)
#(174 1 #reduceFor:)
#(174 1 #reduceFor:)
#(174 1 #reduceFor:)
#(175 1 #reduceFor:)
#(176 2 #reduceFor:)
#(177 1 #reduceFor:)
#(177 3 #reduceFor:)
#(178 0 #reduceFor:)
#(178 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(180 2 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(182 2 #reduceFor:)
#(182 3 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(184 3 #reduceFor:)
#(185 5 #reduceFor:)
#(186 7 #reduceFor:)
#(187 5 #reduceFor:)
#(188 9 #reduceFor:)
#(189 3 #reduceFor:)
#(190 7 #reduceFor:)
#(191 5 #reduceFor:)
#(192 9 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(194 1 #reduceFor:)
#(195 2 #reduceFor:)
#(196 5 #reduceFor:)
#(197 7 #reduceFor:)
#(198 3 #reduceFor:)
#(199 3 #reduceFor:)
#(200 3 #reduceFor:)
#(201 5 #reduceFor:)
#(202 3 #reduceFor:)
#(203 3 #reduceFor:)
#(203 4 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(205 3 #reduceFor:)
#(206 2 #reduceFor:)
#(207 2 #reduceFor:)
#(208 2 #reduceFor:)
#(209 2 #reduceFor:)
#(210 4 #reduceFor:)
#(210 6 #reduceFor:)
#(210 6 #reduceFor:)
#(210 8 #reduceFor:)
#(211 5 #reduceFor:)
#(211 6 #reduceFor:)
#(211 7 #reduceFor:)
#(211 8 #reduceFor:)
#(212 4 #reduceFor:)
#(212 3 #reduceFor:)
#(212 3 #reduceFor:)
#(212 2 #reduceFor:)
#(213 1 #reduceFor:)
#(213 2 #reduceFor:)
#(214 1 #reduceFor:)
#(214 2 #reduceFor:)
#(215 2 #reduceFor:)
#(216 3 #reduceFor:)
#(216 2 #reduceFor:)
#(217 1 #reduceFor:)
#(218 0 #reduceFor:)
#(218 1 #reduceFor:)
#(219 0 #reduceFor:)
#(219 1 #reduceFor:)
#(220 0 #reduceFor:)
#(220 1 #reduceFor:)
#(221 1 #reduceFor:)
#(221 1 #reduceFor:)
#(222 1 #reduceFor:)
#(222 3 #reduceFor:)
#(223 1 #reduceFor:)
#(224 0 #reduceFor:)
#(224 1 #reduceFor:)
#(225 1 #reduceFor:)
#(225 2 #reduceFor:)
#(226 0 #reduceFor:)
#(226 1 #reduceFor:)
#(227 2 #reduceFor:)
#(228 5 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 3 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(230 4 #reduceFor:)
#(230 4 #reduceFor:)
#(230 4 #reduceFor:)
#(230 4 #reduceFor:)
#(231 3 #reduceFor:)
#(231 3 #reduceFor:)
#(231 5 #reduceFor:)
#(232 4 #reduceFor:)
#(232 4 #reduceFor:)
#(233 1 #reduceFor:)
#(233 3 #reduceFor:)
#(234 1 #reduceFor:)
#(234 2 #reduceFor:)
#(235 0 #reduceFor:)
#(235 1 #reduceFor:)
#(236 3 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(238 1 #reduceFor:)
#(238 1 #reduceFor:)
#(238 2 #reduceFor:)
#(238 2 #reduceFor:)
#(238 1 #reduceFor:)
#(239 1 #reduceFor:)
#(239 2 #reduceFor:)
#(239 2 #reduceFor:)
#(239 1 #reduceFor:)
#(240 5 #reduceFor:)
#(240 4 #reduceFor:)
#(240 5 #reduceFor:)
#(241 1 #reduceFor:)
#(241 3 #reduceFor:)
#(241 3 #reduceFor:)
#(241 3 #reduceFor:)
#(242 1 #reduceFor:)
#(242 3 #reduceFor:)
#(242 3 #reduceFor:)
#(243 1 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(244 1 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(245 1 #reduceFor:)
#(245 3 #reduceFor:)
#(245 3 #reduceFor:)
#(246 1 #reduceFor:)
#(246 3 #reduceFor:)
#(247 1 #reduceFor:)
#(247 3 #reduceFor:)
#(248 1 #reduceFor:)
#(248 3 #reduceFor:)
#(249 1 #reduceFor:)
#(249 3 #reduceFor:)
#(250 1 #reduceFor:)
#(250 3 #reduceFor:)
#(251 1 #reduceFor:)
#(251 5 #reduceFor:)
#(252 1 #reduceFor:)
#(252 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(257 1 #reduceFor:)
#(257 1 #reduceFor:)
#(257 1 #reduceFor:)
#(257 1 #reduceFor:)
#(258 1 #reduceFor:)
#(259 1 #reduceFor:)
#(259 2 #reduceFor:)
)! !

!JavaParser methodsFor: 'generated-tables' stamp: 'jmb 1/23/2003 16:21'!
transitionTable
	^#(
#(3 118 7 118 8 118 12 118 16 118 18 9 29 118 32 118 36 118 37 118 38 118 39 118 40 118 43 118 44 118 45 118 46 13 117 17 118 21 121 25 130 118 255)
#(3 29 99 33 111 37 115 41 116)
#(2 0 255)
#(3 126 7 126 8 126 12 126 16 126 18 126 32 126 36 126 37 126 38 126 39 126 40 126 43 45 44 126 45 126 46 49 119 53 122 57 124 61 126 65 127 126 255)
#(2 114 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(2 110 255)
#(2 102 1 2 3 4 5 6 10 14 15 19 21 28 32 42 48 49 50 51 52 53 54 55 56 57 59 60 61 62 63 64 65 66 67 68 69 70 72 82 83 84 85 86 87 88 90 91 99)
#(3 69 28 73 32)
#(2 78 1 2 3 4 5 6 10 14 15 19 21 28 32 42 48 49 50 51 52 53 54 55 56 57 59 60 61 62 63 64 65 66 67 68 69 70 72 82 83 84 85 86 87 88 90 91 99)
#(2 82 1 2 3 4 5 6 10 14 15 19 21 28 32 42 48 49 50 51 52 53 54 55 56 57 59 60 61 62 63 64 65 66 67 68 69 70 72 82 83 84 85 86 87 88 90 91 99)
#(3 29 99 77 111 37 115 41 116)
#(3 81 7 198 8 85 12 198 16 89 18 93 32 97 36 101 37 105 38 109 39 113 40 117 43 121 45 125 46 129 120 133 123 137 125 141 128 145 129 149 131 153 132 134 255 157 259)
#(3 122 7 122 8 122 12 122 16 122 18 122 32 122 36 122 37 122 38 122 39 122 40 122 43 45 44 122 45 122 46 161 124 61 126 65 127 122 255)
#(2 142 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(2 158 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(2 162 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(2 165 99)
#(2 138 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(3 169 28 173 32)
#(2 246 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 242 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 238 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 174 7 8 12 16 18 32 36 37 38 39 40 43 45 46 255)
#(2 226 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 230 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 222 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 218 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 234 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 206 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 214 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 210 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 194 255)
#(3 81 7 198 8 85 12 198 16 89 18 93 32 97 36 101 37 105 38 109 39 113 40 117 43 121 45 125 46 177 125 141 128 145 129 149 131 153 132 130 255 157 259)
#(2 150 7 8 12 16 18 32 36 37 38 39 40 43 45 46 255)
#(2 166 7 8 12 16 18 32 36 37 38 39 40 43 45 46 255)
#(2 170 7 8 12 16 18 32 36 37 38 39 40 43 45 46 255)
#(3 181 8 185 16)
#(2 1414 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(3 81 7 202 8 202 9 85 12 202 16 89 18 202 24 202 25 202 26 202 27 202 30 202 31 202 33 202 34 97 36 101 37 105 38 109 39 113 40 117 43 121 45 125 46 202 99 189 132)
#(2 146 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(2 106 1 2 3 4 5 6 10 14 15 19 21 28 32 42 48 49 50 51 52 53 54 55 56 57 59 60 61 62 63 64 65 66 67 68 69 70 72 82 83 84 85 86 87 88 90 91 99)
#(3 193 42 165 99)
#(2 178 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(2 154 7 8 12 16 18 32 36 37 38 39 40 43 45 46 255)
#(2 197 99)
#(2 201 99)
#(2 1418 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 205 32)
#(3 250 3 250 10 209 11 213 133 217 136)
#(3 538 3 221 11 225 169 229 171)
#(2 182 7 8 12 16 18 32 36 37 38 39 40 43 44 45 46 255)
#(3 29 99 233 109 237 111 241 112 37 115 41 116)
#(3 258 3 245 10 249 134 253 138)
#(2 254 3 10)
#(3 29 99 257 109 237 111 261 113 37 115 41 116)
#(3 265 3 269 170)
#(3 542 3 273 4)
#(2 86 3 4 10 32)
#(3 66 3 66 4 66 5 66 10 66 21 69 28 66 32)
#(2 270 3 10)
#(3 29 99 257 109 237 111 277 113 37 115 41 116 281 137)
#(3 285 3 289 135)
#(2 262 3)
#(2 90 3 4)
#(2 550 3 4)
#(3 558 1 81 7 198 8 198 9 85 12 198 16 89 18 198 24 198 25 198 26 198 27 198 30 198 31 198 33 198 34 97 36 101 37 105 38 109 39 113 40 117 43 121 45 125 46 198 99 293 128 297 129 301 131 153 132 305 146 309 154 313 172 317 173 321 174 325 175 329 176 157 259)
#(2 190 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99 255)
#(3 29 99 257 109 237 111 333 113 37 115 41 116)
#(2 274 3 4)
#(3 282 3 337 4)
#(3 286 1 341 3 81 7 198 8 198 9 85 12 198 16 89 18 198 24 198 25 198 26 198 27 198 30 198 31 345 32 198 33 198 34 97 36 101 37 105 38 349 39 113 40 117 43 121 45 125 46 198 99 353 129 357 131 153 132 361 139 365 140 369 141 373 142 377 143 381 144 385 145 389 146 393 147 397 154 157 259)
#(2 186 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99 255)
#(2 582 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 586 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(3 181 8 401 9 185 16 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 29 99 437 103 441 104 445 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116)
#(2 590 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 473 32)
#(2 477 1)
#(3 562 1 81 7 198 8 198 9 85 12 198 16 89 18 198 24 198 25 198 26 198 27 198 30 198 31 198 33 198 34 97 36 101 37 105 38 109 39 113 40 117 43 121 45 125 46 198 99 293 128 297 129 301 131 153 132 305 146 309 154 481 174 325 175 329 176 157 259)
#(2 566 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 574 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 578 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 554 3 4)
#(3 29 99 257 109 237 111 485 113 37 115 41 116)
#(3 606 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 117 43 121 45 125 46 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 625 166 629 168 633 178 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 773 257 157 259)
#(2 334 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 341 3 218 7 218 8 218 9 218 12 218 16 218 18 218 24 218 25 218 26 218 27 218 30 218 31 218 33 218 34 218 36 218 37 218 38 218 39 218 40 218 43 218 45 218 46 218 99 777 145)
#(2 330 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 781 8 401 9 185 16 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 29 99 437 103 441 104 445 105 449 106 453 107 457 108 461 109 465 110 469 111 785 115 41 116 789 163)
#(2 793 1)
#(3 290 1 341 3 81 7 198 8 198 9 85 12 198 16 89 18 198 24 198 25 198 26 198 27 198 30 198 31 345 32 198 33 198 34 97 36 101 37 105 38 349 39 113 40 117 43 121 45 125 46 198 99 353 129 357 131 153 132 797 141 373 142 377 143 381 144 385 145 389 146 393 147 397 154 157 259)
#(2 294 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 302 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 306 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 310 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 314 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 318 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 322 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 341 3 801 32 805 145 809 155)
#(3 813 99 817 156)
#(2 58 5 19 28 99)
#(2 62 5 19 28 99)
#(2 54 5 19 28 99)
#(2 50 5 19 28 99)
#(2 10 5 19 28 99)
#(2 38 5 19 28 99)
#(2 46 5 19 28 99)
#(2 42 5 19 28 99)
#(3 821 5 22 99 825 114)
#(2 26 99)
#(3 829 99 833 148 837 149 841 150 845 156)
#(2 6 5 19 28 99)
#(2 30 5 19 28 99)
#(2 34 5 19 28 99)
#(2 14 1 4 6 15 19 32 48 49 50 51 52 53 54 55 56 57 59 65 72 99)
#(2 18 1 4 6 15 19 32 48 49 50 51 52 53 54 55 56 57 59 65 72 99)
#(3 66 1 66 4 821 5 66 6 66 15 66 19 69 28 66 32 66 48 66 49 66 50 66 51 66 52 66 53 66 54 66 55 66 56 66 57 66 59 66 65 66 72 66 99 849 114)
#(2 594 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 546 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99 255)
#(2 570 1 7 8 9 12 16 18 24 25 26 27 30 31 33 34 36 37 38 39 40 43 45 46 99)
#(2 278 3 4)
#(2 853 28)
#(2 857 21)
#(2 861 21)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 897 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 993 28)
#(2 1026 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 774 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 226 7 226 8 226 12 226 16 226 18 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 226 36 226 37 226 38 226 39 226 40 226 43 226 45 226 46 29 99 437 103 441 104 997 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116)
#(3 234 7 234 8 234 12 234 16 234 18 1001 21 234 36 234 37 234 38 234 39 234 40 234 43 234 45 234 46)
#(2 1005 21)
#(3 341 3 1009 145)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1013 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 954 32 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1017 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 1021 219 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 29 99 1025 103 449 106 453 107 457 108 1029 109 237 111 1033 112 37 115 41 116)
#(3 341 3 489 9 493 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1041 181 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 1045 21)
#(3 990 32 1049 99 1053 224)
#(3 990 32 1049 99 1057 224)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1073 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1077 238 937 239 941 240)
#(2 614 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 618 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 622 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 626 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 630 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 634 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 102 2 102 5 102 14 1081 15 102 21 102 28 102 60 102 61 102 62 102 63 102 64 102 66 102 67 102 68 102 69 102 70 102 82 102 84 102 99)
#(3 821 5 1085 28 22 99 825 114)
#(3 1089 99 1093 148 837 149 841 150)
#(3 1097 28 18 99)
#(3 1334 2 1101 5 1334 14 1105 21 1109 28 1334 60 1334 61 1334 62 1334 63 1334 64 1334 66 1334 67 1334 68 1334 69 1334 70 1138 82 1138 84 66 99 849 114)
#(2 1402 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1406 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 674 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 610 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 117 43 121 45 125 46 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 1113 257 157 259)
#(3 1134 1 1134 4 1134 6 1134 15 1134 19 1117 28 1134 32 1134 42 1134 48 1134 49 1134 50 1134 51 1134 52 1134 53 1134 54 1134 55 1134 56 1134 57 1134 59 1134 65 1134 72 1134 82 1134 83 1134 84 1134 85 1134 86 1134 87 1134 88 1134 90 1134 91)
#(2 1121 1)
#(2 1022 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1394 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1398 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1125 32)
#(2 642 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 646 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 650 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 654 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 658 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 662 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 678 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 682 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 686 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 690 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 694 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 698 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 702 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 706 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 710 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 714 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1129 32)
#(2 818 4 19 32)
#(2 822 4 19 32)
#(2 826 4 19 32)
#(3 830 4 830 19 830 32 1142 82 1142 84)
#(3 834 4 834 19 834 32 1146 82 1146 84)
#(3 838 4 1042 5 838 19 1042 28 838 32 1042 82 1042 84)
#(3 842 4 1034 5 842 19 1034 28 842 32 1034 82 1034 84)
#(3 530 1 530 4 1133 5 530 6 530 15 530 19 530 28 530 32 530 42 530 48 530 49 530 50 530 51 530 52 530 53 530 54 530 55 530 56 530 57 530 59 530 65 530 72 530 82 530 83 530 84 530 85 530 86 530 87 530 88 530 90 530 91)
#(2 534 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 1038 1 1338 2 1038 4 1038 5 1038 6 1338 14 1038 15 1038 19 1038 28 1038 32 1038 42 1038 48 1038 49 1038 50 1038 51 1038 52 1038 53 1038 54 1038 55 1038 56 1038 57 1038 59 1338 60 1338 61 1338 62 1338 63 1338 64 1038 65 1338 66 1338 67 1338 68 1338 69 1338 70 1038 72 1038 82 1038 83 1038 84 1038 85 1038 86 1038 87 1038 88 1038 90 1038 91)
#(3 1046 1 1342 2 1046 4 1046 5 1046 6 1342 14 1046 15 1046 19 1046 28 1046 32 1046 42 1046 48 1046 49 1046 50 1046 51 1046 52 1046 53 1046 54 1046 55 1046 56 1046 57 1046 59 1342 60 1342 61 1342 62 1342 63 1342 64 1046 65 1342 66 1342 67 1342 68 1342 69 1342 70 1046 72 1046 82 1046 83 1046 84 1046 85 1046 86 1046 87 1046 88 1046 90 1046 91)
#(3 1137 82 1141 84)
#(3 1145 2 1149 14 1153 60 1157 61 1161 62 1165 63 1169 64 1173 66 1177 67 1181 68 1185 69 1189 70 1193 254)
#(2 514 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 338 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 1197 99)
#(3 78 5 1201 21 78 28 78 99)
#(3 434 3 1205 20 1209 157 1213 161)
#(2 266 1 3 4 5 6 7 8 9 12 13 15 16 17 18 19 21 22 23 24 25 26 27 28 30 31 32 33 34 36 37 38 39 40 41 42 43 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 65 71 72 73 74 76 77 78 80 81 82 83 84 85 86 87 88 90 91 93 94 95 96 97 98 99 255)
#(2 298 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 422 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 418 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 354 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 1217 21)
#(3 434 3 1221 5 1205 20 434 32 1225 157 1213 161)
#(2 1229 6)
#(3 70 1 70 4 1233 5 70 6 70 15 70 19 70 28 70 32 70 48 70 49 70 50 70 51 70 52 70 53 70 54 70 55 70 56 70 57 70 59 70 65 70 72 70 99)
#(3 374 2 374 4 374 5 1217 21 374 32)
#(3 1237 4 1241 32)
#(2 358 4 32)
#(3 1245 2 366 4 1249 5 366 32)
#(3 434 3 1221 5 1205 20 434 32 1253 157 1213 161)
#(3 74 1 74 4 1233 5 74 6 74 15 74 19 74 28 74 32 74 48 74 49 74 50 74 51 74 52 74 53 74 54 74 55 74 56 74 57 74 59 74 65 74 72 74 99)
#(2 1257 8)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1261 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1265 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 1269 103 449 106 453 107 457 108 889 110 1273 111 37 115 41 116 1277 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1281 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1285 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1289 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1293 238 937 239 941 240)
#(3 821 5 1085 28 825 114)
#(2 1097 28)
#(3 1138 1 1334 2 1138 4 1101 5 1138 6 1334 14 1138 15 1138 19 1105 21 1109 28 1138 32 1138 42 1138 48 1138 49 1138 50 1138 51 1138 52 1138 53 1138 54 1138 55 1138 56 1138 57 1138 59 1334 60 1334 61 1334 62 1334 63 1334 64 1138 65 1334 66 1334 67 1334 68 1334 69 1334 70 1138 72 1138 82 1138 83 1138 84 1138 85 1138 86 1138 87 1138 88 1138 90 1138 91 849 114)
#(2 1297 19)
#(2 1330 1 4 6 15 19 32)
#(2 1150 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1154 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1142 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1146 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1042 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1034 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 1170 1 1170 4 1170 6 1170 15 1170 19 1170 32 1170 42 1170 48 1170 49 1170 50 1170 51 1170 52 1170 53 1170 54 1170 55 1170 56 1170 57 1170 59 1170 65 1170 72 1137 82 1170 83 1141 84 1170 85 1170 86 1170 87 1170 88 1170 90 1170 91)
#(2 1198 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1166 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1182 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(3 1214 1 1214 4 1214 6 1214 15 1214 19 1214 32 1301 42 1214 48 1214 49 1214 50 1214 51 1214 52 1214 53 1214 54 1214 55 1214 56 1214 57 1214 59 1214 65 1214 72 1214 83 1305 85 1214 86 1214 87 1309 88 1214 90 1214 91)
#(3 1226 1 1226 4 1226 6 1226 15 1226 19 1226 32 1226 48 1226 49 1226 50 1226 51 1226 52 1226 53 1226 54 1226 55 1226 56 1226 57 1226 59 1226 65 1226 72 1226 83 1226 86 1226 87 1313 90 1317 91)
#(3 1242 1 1242 4 1242 6 1242 15 1242 19 1242 32 1242 48 1242 49 1242 50 1242 51 1242 52 1242 53 1242 54 1242 55 1242 56 1242 57 1242 59 1242 65 1242 72 1321 83 1325 86 1329 87)
#(3 1266 1 1266 4 1266 6 1266 15 1266 19 1266 32 1266 48 1266 49 1266 50 1266 51 1266 52 1266 53 1333 54 1337 55 1266 56 1266 57 1341 59 1345 65 1349 72)
#(3 1278 1 1278 4 1278 6 1278 15 1278 19 1278 32 1278 48 1278 49 1278 50 1353 51 1278 52 1278 53 1278 56 1357 57)
#(3 1286 1 1286 4 1286 6 1286 15 1286 19 1286 32 1286 48 1286 49 1361 50 1286 52 1286 53 1286 56)
#(3 1294 1 1294 4 1294 6 1294 15 1294 19 1294 32 1365 48 1294 49 1294 52 1294 53 1294 56)
#(3 1302 1 1302 4 1302 6 1302 15 1302 19 1302 32 1369 49 1302 52 1302 53 1302 56)
#(3 1310 1 1310 4 1310 6 1310 15 1310 19 1310 32 1373 52 1310 53 1310 56)
#(3 1318 1 1318 4 1318 6 1318 15 1318 19 1318 32 1377 53 1381 56)
#(2 1326 1 4 6 15 19 32)
#(2 390 1 4 6 15 19 32)
#(2 1385 99)
#(3 1089 99 1389 148 837 149 841 150)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1393 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1397 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 1006 75 1401 79 1405 225 1409 226 1413 228)
#(2 1417 32)
#(2 958 32)
#(2 1421 32)
#(3 1425 5 1429 114 1433 234 1437 236)
#(3 1425 5 86 21 1441 114 1445 234 1437 236)
#(2 1449 21)
#(2 1001 21)
#(2 1453 58)
#(3 489 9 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 946 32 429 33 433 34 1457 36 541 76 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 29 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 629 168 637 179 1461 182 1465 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 1469 218 1473 221 1477 222 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 994 32)
#(2 1481 32)
#(2 1485 32)
#(3 1138 1 1138 4 1101 5 1138 6 1138 15 1138 19 1105 21 1109 28 1138 32 1138 42 1138 48 1138 49 1138 50 1138 51 1138 52 1138 53 1138 54 1138 55 1138 56 1138 57 1138 59 1138 65 1138 72 1138 82 1138 83 1138 84 1138 85 1138 86 1138 87 1138 88 1138 90 1138 91 849 114)
#(2 1038 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1046 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 850 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 854 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(3 341 3 489 9 493 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1489 181 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 1493 8)
#(2 374 2 4 5 19 32)
#(3 1237 4 666 32)
#(2 1497 8)
#(3 1229 6 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1501 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 1509 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 1517 8 1521 22 1525 23 165 99)
#(2 518 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 1529 76 1533 99)
#(2 346 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 75 76 77 78 79 80 81 82 84 93 94 95 96 97 98 99)
#(2 638 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 778 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1537 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 858 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 862 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1346 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1390 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1378 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1382 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1374 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1370 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1386 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1354 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1358 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1350 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1366 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(2 1362 9 21 22 23 24 25 26 27 30 31 33 34 76 82 84 89 90 91 92 93 94 95 96 97 98 99)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 1541 252 769 253)
#(3 250 3 250 10 209 11 1545 133 217 136)
#(3 442 19 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 1549 36 29 99 437 103 441 104 1553 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116 1557 158 1561 159 1565 160)
#(3 29 99 233 109 237 111 1569 112 37 115 41 116 1573 162)
#(3 1577 3 1581 164)
#(2 438 3 32)
#(3 442 19 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 1549 36 29 99 437 103 441 104 1553 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116 1585 158 1561 159 1565 160)
#(2 1589 6)
#(2 414 3 32)
#(2 94 1 3 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91 99)
#(2 1593 6)
#(3 1089 99 1597 149 841 150)
#(2 350 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 1601 3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1605 151 1609 152 1613 153 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 1617 6)
#(2 410 3 32)
#(2 1054 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1621 19)
#(2 1625 19)
#(3 821 5 1122 19 1085 28 1629 114 1633 235)
#(3 1334 2 1101 5 1334 14 1138 19 1105 21 1109 28 1138 42 1138 48 1138 49 1138 50 1138 51 1138 52 1138 53 1138 54 1138 55 1138 56 1138 57 1138 59 1334 60 1334 61 1334 62 1334 63 1334 64 1138 65 1334 66 1334 67 1334 68 1334 69 1334 70 1138 72 1138 82 1138 83 1138 84 1138 85 1138 86 1138 87 1138 88 1138 90 1138 91 1637 114)
#(2 1641 19)
#(2 1178 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1158 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1162 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1174 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1030 5 28 82 84)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1645 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1649 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1653 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 1657 241)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 1661 241)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 1665 242)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 1669 242)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 1673 242)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 1677 243)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 1681 243)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 1685 243)
#(3 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 29 99 1689 103 1693 104 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 1697 243)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 1701 244)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 1705 244)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 1709 245)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 1713 246)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 1717 247)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 1721 248)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 1725 249)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1729 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 1090 1 1090 2 1090 4 1090 5 1090 6 1090 14 1090 15 1090 19 1733 21 1090 28 1090 32 1090 42 1090 48 1090 49 1090 50 1090 51 1090 52 1090 53 1090 54 1090 55 1090 56 1090 57 1090 59 1090 60 1090 61 1090 62 1090 63 1090 64 1090 65 1090 66 1090 67 1090 68 1090 69 1090 70 1090 72 1090 82 1090 83 1090 84 1090 85 1090 86 1090 87 1090 88 1090 90 1090 91)
#(3 1237 4 670 32)
#(2 1737 19)
#(2 1741 19)
#(2 1745 21)
#(3 810 1 810 3 810 7 810 8 810 9 810 12 810 13 810 16 810 17 810 18 810 21 810 22 810 23 810 24 810 25 810 26 810 27 810 30 810 31 810 32 810 33 810 34 810 35 810 36 810 37 810 38 810 39 810 40 810 41 810 43 810 45 810 46 810 47 810 58 810 71 810 73 810 74 1010 75 810 76 810 77 810 78 1401 79 810 80 810 81 810 82 810 84 810 93 810 94 810 95 810 96 810 97 810 98 810 99 1749 228)
#(3 1753 75 1757 227)
#(2 998 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 75 76 77 78 79 80 81 82 84 93 94 95 96 97 98 99)
#(2 806 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 798 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 1229 6 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1761 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 1601 3 1233 5 1765 153)
#(3 1122 1 1122 4 1425 5 1122 6 1122 15 1122 19 1122 28 1122 32 1122 42 1122 48 1122 49 1122 50 1122 51 1122 52 1122 53 1122 54 1122 55 1122 56 1122 57 1122 59 1122 65 1122 72 1122 82 1122 83 1122 84 1122 85 1122 86 1122 87 1122 88 1122 90 1122 91 1769 114 1773 235 1777 236)
#(2 1114 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 1601 3 1233 5 1781 153)
#(3 1122 1 1122 4 1425 5 1122 6 1122 15 1122 19 1122 28 1122 32 1122 42 1122 48 1122 49 1122 50 1122 51 1122 52 1122 53 1122 54 1122 55 1122 56 1122 57 1122 59 1122 65 1122 72 1122 82 1122 83 1122 84 1122 85 1122 86 1122 87 1122 88 1122 90 1122 91 1769 114 1785 235 1777 236)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 1789 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 1793 21)
#(3 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 29 99 437 103 441 104 997 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116)
#(2 974 32)
#(2 978 4 19 32)
#(2 1797 32)
#(2 950 32)
#(3 1801 4 970 32)
#(2 794 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 790 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 718 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1050 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1058 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1805 6)
#(2 1106 4 19)
#(2 1809 19)
#(3 1813 4 526 19)
#(2 1062 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1817 28)
#(2 1066 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1821 99)
#(3 1086 1 1086 2 1086 4 1086 5 1086 6 1086 14 1086 15 1086 19 1825 21 1086 28 1086 32 1086 42 1086 48 1086 49 1086 50 1086 51 1086 52 1086 53 1086 54 1086 55 1086 56 1086 57 1086 59 1086 60 1086 61 1086 62 1086 63 1086 64 1086 65 1086 66 1086 67 1086 68 1086 69 1086 70 1086 72 1086 82 1086 83 1086 84 1086 85 1086 86 1086 87 1086 88 1086 90 1086 91)
#(2 1829 6)
#(2 846 1 4 6 15 19 32)
#(3 258 3 245 10 1833 134 253 138)
#(3 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 29 99 437 103 441 104 1837 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116)
#(3 1089 99 1841 150)
#(2 1845 19)
#(3 1849 4 446 19)
#(2 450 4 19)
#(2 470 3 4 32)
#(3 466 3 1853 4 466 32)
#(3 1857 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 1861 22 1865 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 117 43 121 45 125 46 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 1869 165 1873 166 1877 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 773 257 157 259)
#(2 342 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 1881 19)
#(2 430 3 5 20 32)
#(2 98 1 3 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91 99)
#(2 362 4 32)
#(3 1885 1 1601 3 1889 4 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1893 151 1609 152 1613 153 629 168 1897 177 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 370 4 32)
#(2 382 1 4 32)
#(2 386 1 4 32)
#(2 378 2 4 5 19 32)
#(3 341 3 489 9 1901 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 1905 58 529 71 533 73 537 74 541 76 545 77 1909 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 1913 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1917 181 1921 183 657 184 661 185 665 186 669 187 673 188 1925 189 1929 190 1933 191 1937 192 1941 193 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 1945 3 1949 212)
#(3 1233 5 1126 19 70 28)
#(2 1953 19)
#(3 1233 5 1957 19 74 28)
#(3 1030 1 1030 4 1030 5 1030 6 489 9 1030 15 1030 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 1030 28 421 30 425 31 1030 32 429 33 433 34 1030 42 1030 48 1030 49 1030 50 1030 51 1030 52 1030 53 1030 54 1030 55 1030 56 1030 57 1030 59 1030 65 1030 72 541 76 1030 82 1030 83 1030 84 1030 85 1030 86 1030 87 1030 88 869 89 1030 90 1030 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 1961 239 941 240)
#(2 1202 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1210 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1206 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(3 1218 1 1218 4 1218 6 1218 15 1218 19 1218 32 1301 42 1218 48 1218 49 1218 50 1218 51 1218 52 1218 53 1218 54 1218 55 1218 56 1218 57 1218 59 1218 65 1218 72 1218 83 1305 85 1218 86 1218 87 1309 88 1218 90 1218 91)
#(3 1222 1 1222 4 1222 6 1222 15 1222 19 1222 32 1301 42 1222 48 1222 49 1222 50 1222 51 1222 52 1222 53 1222 54 1222 55 1222 56 1222 57 1222 59 1222 65 1222 72 1222 83 1305 85 1222 86 1222 87 1309 88 1222 90 1222 91)
#(3 1230 1 1230 4 1230 6 1230 15 1230 19 1230 32 1230 48 1230 49 1230 50 1230 51 1230 52 1230 53 1230 54 1230 55 1230 56 1230 57 1230 59 1230 65 1230 72 1230 83 1230 86 1230 87 1313 90 1317 91)
#(3 1234 1 1234 4 1234 6 1234 15 1234 19 1234 32 1234 48 1234 49 1234 50 1234 51 1234 52 1234 53 1234 54 1234 55 1234 56 1234 57 1234 59 1234 65 1234 72 1234 83 1234 86 1234 87 1313 90 1317 91)
#(3 1238 1 1238 4 1238 6 1238 15 1238 19 1238 32 1238 48 1238 49 1238 50 1238 51 1238 52 1238 53 1238 54 1238 55 1238 56 1238 57 1238 59 1238 65 1238 72 1238 83 1238 86 1238 87 1313 90 1317 91)
#(3 1254 1 1254 4 1254 6 1254 15 1254 19 1254 32 1254 48 1254 49 1254 50 1254 51 1254 52 1254 53 1254 54 1254 55 1254 56 1254 57 1254 59 1254 65 1254 72 1321 83 1325 86 1329 87)
#(3 1258 1 1258 4 1258 6 1258 15 1258 19 1258 32 1258 48 1258 49 1258 50 1258 51 1258 52 1258 53 1258 54 1258 55 1258 56 1258 57 1258 59 1258 65 1258 72 1321 83 1325 86 1329 87)
#(3 1250 1 1250 4 1250 6 1250 15 1250 19 1250 32 1250 48 1250 49 1250 50 1250 51 1250 52 1250 53 1250 54 1250 55 1250 56 1250 57 1250 59 1250 65 1250 72 1321 83 1325 86 1329 87)
#(3 821 5 825 114)
#(2 1262 1 4 6 15 19 32 48 49 50 51 52 53 54 55 56 57 59 65 72)
#(3 1246 1 1246 4 1246 6 1246 15 1246 19 1246 32 1246 48 1246 49 1246 50 1246 51 1246 52 1246 53 1246 54 1246 55 1246 56 1246 57 1246 59 1246 65 1246 72 1321 83 1325 86 1329 87)
#(3 1274 1 1274 4 1274 6 1274 15 1274 19 1274 32 1274 48 1274 49 1274 50 1274 51 1274 52 1274 53 1333 54 1337 55 1274 56 1274 57 1341 59 1345 65 1349 72)
#(3 1270 1 1270 4 1270 6 1270 15 1270 19 1270 32 1270 48 1270 49 1270 50 1270 51 1270 52 1270 53 1333 54 1337 55 1270 56 1270 57 1341 59 1345 65 1349 72)
#(3 1282 1 1282 4 1282 6 1282 15 1282 19 1282 32 1282 48 1282 49 1282 50 1353 51 1282 52 1282 53 1282 56 1357 57)
#(3 1290 1 1290 4 1290 6 1290 15 1290 19 1290 32 1290 48 1290 49 1361 50 1290 52 1290 53 1290 56)
#(3 1298 1 1298 4 1298 6 1298 15 1298 19 1298 32 1365 48 1298 49 1298 52 1298 53 1298 56)
#(3 1306 1 1306 4 1306 6 1306 15 1306 19 1306 32 1369 49 1306 52 1306 53 1306 56)
#(3 1314 1 1314 4 1314 6 1314 15 1314 19 1314 32 1373 52 1314 53 1314 56)
#(2 1965 15)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 1969 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 341 3 1973 145)
#(3 341 3 489 9 493 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1977 181 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 1549 36 29 99 437 103 441 104 1553 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116 1981 160)
#(2 1002 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 75 76 77 78 79 80 81 82 84 93 94 95 96 97 98 99)
#(3 341 3 1985 145)
#(2 814 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1989 6)
#(2 1078 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 1126 1 1126 4 1233 5 1126 6 1126 15 1126 19 1126 28 1126 32 1126 42 1126 48 1126 49 1126 50 1126 51 1126 52 1126 53 1126 54 1126 55 1126 56 1126 57 1126 59 1126 65 1126 72 1126 82 1126 83 1126 84 1126 85 1126 86 1126 87 1126 88 1126 90 1126 91)
#(2 1070 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1118 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1082 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1074 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 1993 19)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1997 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 954 32 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1017 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 2001 219 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 629 168 637 179 2005 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 1098 1 2 4 5 6 14 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 60 61 62 63 64 65 66 67 68 69 70 72 82 83 84 85 86 87 88 90 91)
#(2 866 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 2009 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 2013 99)
#(2 2017 21)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2021 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 1102 1 2 4 5 6 14 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 60 61 62 63 64 65 66 67 68 69 70 72 82 83 84 85 86 87 88 90 91)
#(3 285 3 2025 135)
#(3 1089 99 2029 150)
#(3 458 4 1249 5 458 19)
#(2 478 3 20)
#(3 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 1549 36 29 99 437 103 441 104 1553 105 449 106 453 107 457 108 461 109 465 110 469 111 37 115 41 116 2033 160)
#(3 29 99 233 109 237 111 2037 112 37 115 41 116)
#(2 494 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 2041 21 993 28)
#(3 1026 5 2045 21 1026 28 1026 82 1026 84)
#(3 2049 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 117 43 121 45 125 46 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 2053 166 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 773 257 157 259)
#(3 2057 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 117 43 121 45 125 46 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 1113 257 157 259)
#(3 2061 28 1134 82 1134 84)
#(2 426 3 5 20 32)
#(2 406 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 2065 1)
#(2 598 1 4)
#(3 2069 1 2073 4)
#(2 2077 21)
#(2 2081 21)
#(2 2085 21)
#(3 102 2 102 5 102 14 2089 15 102 21 102 28 102 60 102 61 102 62 102 63 102 64 102 66 102 67 102 68 102 69 102 70 102 82 102 84)
#(2 722 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 642 1 642 3 642 7 642 8 642 9 642 12 642 13 642 16 642 17 642 18 642 21 642 22 642 23 642 24 642 25 642 26 642 27 642 30 642 31 642 32 642 33 642 34 754 35 642 36 642 37 642 38 642 39 642 40 642 41 642 43 642 45 642 46 642 47 642 58 642 71 642 73 642 74 642 76 642 77 642 78 642 80 642 81 642 82 642 84 642 93 642 94 642 95 642 96 642 97 642 98 642 99)
#(2 758 35)
#(2 762 35)
#(2 766 35)
#(2 770 35)
#(2 2093 35)
#(3 2097 1 2101 41 2105 47 2109 213 2113 214 2117 215 2121 216)
#(2 782 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 2125 238 937 239 941 240)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 869 89 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 2129 239 941 240)
#(2 1190 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 1061 111 37 115 41 116 629 168 637 179 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 1065 231 1069 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 2133 251)
#(2 2137 19)
#(2 802 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 730 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 2141 19)
#(2 1014 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1130 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 882 1 285 3 882 4 882 5 882 6 882 15 882 19 882 28 882 32 882 42 882 48 882 49 882 50 882 51 882 52 882 53 882 54 882 55 882 56 882 57 882 59 882 65 882 72 882 82 882 83 882 84 882 85 882 86 882 87 882 88 882 90 882 91 2145 135)
#(2 2149 19)
#(2 2153 32)
#(2 982 4 19 32)
#(2 1110 4 19)
#(3 1094 1 1094 2 1094 4 1094 5 1094 6 1094 14 1094 15 1094 19 2157 21 1094 28 1094 32 1094 42 1094 48 1094 49 1094 50 1094 51 1094 52 1094 53 1094 54 1094 55 1094 56 1094 57 1094 59 1094 60 1094 61 1094 62 1094 63 1094 64 1094 65 1094 66 1094 67 1094 68 1094 69 1094 70 1094 72 1094 82 1094 83 1094 84 1094 85 1094 86 1094 87 1094 88 1094 90 1094 91)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2161 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 2165 19)
#(2 326 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 462 4 1249 5 462 19)
#(2 454 4 19)
#(2 474 3 4 32)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2169 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2173 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 486 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 2177 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 117 43 121 45 125 46 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 1113 257 157 259)
#(2 490 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(3 2181 22 2185 23 1529 76 1533 99)
#(2 402 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 398 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 2189 1 1601 3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 2193 151 1609 152 1613 153 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 2197 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 2201 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 946 32 429 33 433 34 1457 36 541 76 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 29 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 629 168 637 179 1461 182 1465 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 2205 218 1473 221 1477 222 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 341 3 489 9 1901 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 1905 58 529 71 533 73 537 74 541 76 545 77 1909 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 1913 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1489 181 1921 183 657 184 661 185 665 186 669 187 673 188 1925 189 1929 190 1933 191 1937 192 2209 193 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 341 3 489 9 493 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 2213 181 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 910 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 2217 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 2221 217 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 2225 15)
#(3 2229 1 2101 41 2105 47 2233 214 2237 215 2121 216)
#(3 2241 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 2101 41 117 43 121 45 125 46 2105 47 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 2245 166 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 2249 216 749 229 753 230 757 231 761 232 765 237 769 253 773 257 157 259)
#(2 914 1 41 47)
#(2 922 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1186 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1194 1 4 6 15 19 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 83 85 86 87 88 90 91)
#(2 1322 1 4 6 15 19 32)
#(2 874 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(3 341 3 2253 145)
#(2 886 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 2257 32)
#(3 489 9 962 19 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 629 168 637 179 1465 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 2261 220 2265 222 2269 223 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2273 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 2277 19)
#(2 870 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 2281 19)
#(2 2285 19)
#(2 482 1 3 7 8 9 12 16 18 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 99)
#(2 2289 21)
#(2 2293 21)
#(2 394 1 4 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 602 1 4)
#(2 2297 19)
#(2 2301 19)
#(2 2305 32)
#(2 738 35)
#(2 726 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 942 15)
#(2 2309 15)
#(2 938 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 902 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 2313 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 2101 41 117 43 121 45 125 46 2105 47 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 2245 166 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 2249 216 749 229 753 230 757 231 761 232 765 237 769 253 773 257 157 259)
#(2 918 1 41 47)
#(2 906 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 930 1 341 3 81 7 198 8 489 9 85 12 493 13 198 16 497 17 89 18 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 517 36 101 37 105 38 109 39 521 40 930 41 117 43 121 45 125 46 930 47 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 597 103 441 104 601 105 449 106 453 107 457 108 461 109 605 110 609 111 37 115 41 116 613 128 617 129 149 131 153 132 621 145 629 168 637 179 641 180 645 181 649 182 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253 1113 257 157 259)
#(2 926 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 1018 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 75 76 77 78 79 80 81 82 84 93 94 95 96 97 98 99)
#(2 786 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 2317 19)
#(3 1801 4 986 19)
#(2 966 19)
#(2 2321 19)
#(3 890 1 285 3 890 4 890 5 890 6 890 15 890 19 890 28 890 32 890 42 890 48 890 49 890 50 890 51 890 52 890 53 890 54 890 55 890 56 890 57 890 59 890 65 890 72 890 82 890 83 890 84 890 85 890 86 890 87 890 88 890 90 890 91 2325 135)
#(2 2329 32)
#(2 2333 32)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2337 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 489 9 522 19 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1505 152 2341 167 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 749 229 753 230 757 231 761 232 1513 233 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(3 341 3 489 9 1901 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 1905 58 529 71 533 73 537 74 541 76 545 77 1909 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 1913 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1917 181 1921 183 657 184 661 185 665 186 669 187 673 188 1925 189 1929 190 1933 191 1937 192 2345 193 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 341 3 489 9 1901 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 1905 58 529 71 533 73 537 74 541 76 545 77 1909 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 1913 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 1977 181 1921 183 657 184 661 185 665 186 669 187 673 188 1925 189 1929 190 1933 191 1937 192 2349 193 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 489 9 865 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 954 32 429 33 433 34 541 76 561 82 565 84 869 89 873 90 877 91 881 92 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 1017 152 629 168 637 179 901 205 905 206 909 207 913 208 917 209 921 210 925 211 2353 219 749 229 753 230 757 231 761 232 929 237 933 238 937 239 941 240 945 241 949 242 953 243 957 244 961 245 965 246 969 247 973 248 977 249 981 250 985 251 989 252 769 253)
#(2 934 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 898 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 35 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(3 341 3 489 9 493 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 525 58 529 71 533 73 537 74 541 76 545 77 549 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 593 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 2357 181 653 183 657 184 661 185 665 186 669 187 673 188 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 878 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 894 1 4 5 6 15 19 28 32 42 48 49 50 51 52 53 54 55 56 57 59 65 72 82 83 84 85 86 87 88 90 91)
#(2 502 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 498 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 2361 19)
#(2 2365 19)
#(2 2369 35)
#(2 746 35)
#(2 2373 32)
#(2 734 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 41 43 45 46 47 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 2377 32)
#(2 2381 32)
#(3 341 3 489 9 1901 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 1905 58 529 71 533 73 537 74 541 76 545 77 1909 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 1913 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 2213 181 1921 183 657 184 661 185 665 186 669 187 673 188 1925 189 1929 190 1933 191 1937 192 2385 193 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(3 489 9 962 19 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 429 33 433 34 541 76 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 29 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 629 168 637 179 1465 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 2389 220 2265 222 2269 223 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 510 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 506 1 3 7 8 9 12 13 16 17 18 21 22 23 24 25 26 27 30 31 32 33 34 36 37 38 39 40 43 45 46 58 71 73 74 76 77 78 80 81 82 84 93 94 95 96 97 98 99)
#(2 742 35)
#(2 2393 19)
#(3 341 3 489 9 1901 13 497 17 501 21 505 22 509 23 405 24 409 25 413 26 417 27 421 30 425 31 513 32 429 33 433 34 1037 40 1905 58 529 71 533 73 537 74 541 76 545 77 1909 78 553 80 557 81 561 82 565 84 569 93 573 94 577 95 581 96 585 97 589 98 1913 99 885 103 449 106 453 107 457 108 889 110 893 111 37 115 41 116 621 145 629 168 637 179 2357 181 1921 183 657 184 661 185 665 186 669 187 673 188 1925 189 1929 190 1933 191 1937 192 2397 193 677 194 681 195 685 196 689 197 693 198 697 199 701 200 705 201 709 202 713 203 717 204 721 205 725 206 729 207 733 208 737 209 741 210 745 211 749 229 753 230 757 231 761 232 765 237 769 253)
#(2 750 35)
)! !

SmaCCParser subclass: #SmaCCGrammarParser
	instanceVariableNames: 'grammar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammarParser commentStamp: 'jmb' prior: 0!
SmaCCGrammarParser is a parser for grammars.

Instance Variables:
	grammar	<SmaCCGrammar>	the grammar we are producing
!

!SmaCCGrammarParser class methodsFor: 'generated-comments' stamp: 'jmb 1/21/2003 17:17'!
itemSetsComment

	"
1	[NonAssociativeLine : .  ""%nonassoc"" TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[ProductionRule : .  <symbolname> <production> ParserRules "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  StartLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[StartLine : .  ""%start"" StartingTokens "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  NonAssociativeLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[LeftLine : .  ""%left"" TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[B e g i n : .  File;E O F]
	[File : .  Parser;E O F]
	[Parser : .  Parser Rule;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[RightLine : .  ""%right"" TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  RightLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  ProductionRule;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  IdMethodLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Parser : .  Rule;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[IdMethodLine : .  ""%id"" IdTokens "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  LeftLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

2	[StartingTokens : .  StartingTokens <symbolname>;<symbolname> "";""]
	[StartLine : ""%start"" .  StartingTokens "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[StartingTokens : .  <symbolname>;<symbolname> "";""]

3	[Term : .  <tokenname>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[TokenList : .  TokenList Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" "";""]
	[TokenList : .  Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" "";""]
	[NonAssociativeLine : ""%nonassoc"" .  TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Term : .  <keyword>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""error"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  <symbolname>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]

4	[IdTokens : .  <tokenname>;<tokenname> "";""]
	[IdTokens : .  IdTokens <tokenname>;<tokenname> "";""]
	[IdMethodLine : ""%id"" .  IdTokens "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

5	[Term : .  <symbolname>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  <tokenname>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[TokenList : .  TokenList Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" "";""]
	[TokenList : .  Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" "";""]
	[Term : .  <keyword>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""error"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[LeftLine : ""%left"" .  TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

6	[Term : .  <tokenname>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[RightLine : ""%right"" .  TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[TokenList : .  TokenList Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" "";""]
	[TokenList : .  Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" "";""]
	[Term : .  <keyword>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""error"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]
	[Term : .  <symbolname>;<symbolname> <tokenname> ""<%"" <keyword> ""["" ""error"" ""("" "";""]

7	[ProductionRule : <symbolname> .  <production> ParserRules "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

8	[Rule : IdMethodLine . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

9	[Rule : StartLine . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

10	[Rule : NonAssociativeLine . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

11	[Rule : ProductionRule . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

12	[Rule : RightLine . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

13	[Parser : Rule . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

14	[B e g i n : File . ;E O F]

15	[File : Parser . ;E O F]
	[Parser : Parser .  Rule;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[ProductionRule : .  <symbolname> <production> ParserRules "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[NonAssociativeLine : .  ""%nonassoc"" TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  NonAssociativeLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[LeftLine : .  ""%left"" TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  StartLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[StartLine : .  ""%start"" StartingTokens "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[RightLine : .  ""%right"" TokenList "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  RightLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  ProductionRule;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  IdMethodLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[IdMethodLine : .  ""%id"" IdTokens "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Rule : .  LeftLine;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

16	[Rule : LeftLine . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

17	[StartingTokens : <symbolname> . ;<symbolname> "";""]

18	[StartLine : ""%start"" StartingTokens .  "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[StartingTokens : StartingTokens .  <symbolname>;<symbolname> "";""]

19	[SimpleTerm : .  SimpleTerm Term ""+"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""|"" ""]""]
	[SimpleTerm : .  SimpleTerm Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" ""|"" ""]""]
	[Term : ""["" .  SimpleTerms ""]"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]
	[SimpleTerm : .  SimpleTerm Term ""?"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""|"" ""]""]
	[SimpleTerm : .  SimpleTerm Term ""*"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""|"" ""]""]
	[SimpleTerms : .  SimpleTerm;""]"" ""|""]
	[SimpleTerms : .  SimpleTerms ""|"" SimpleTerm;""]"" ""|""]
	[SimpleTerm : . ;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" ""|"" ""]""]

20	[SimpleTerm : .  SimpleTerm Term ""+"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""%>"" ""|""]
	[SimpleTerm : .  SimpleTerm Term;<symbolname> <tokenname> ""<%"" ""%>"" ""["" <keyword> ""error"" ""("" ""|""]
	[SimpleTerm : .  SimpleTerm Term ""?"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""%>"" ""|""]
	[SimpleTerm : .  SimpleTerm Term ""*"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""%>"" ""|""]
	[SimpleTerms : .  SimpleTerm;""%>"" ""|""]
	[Term : ""<%"" .  SimpleTerms ""%>"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]
	[SimpleTerms : .  SimpleTerms ""|"" SimpleTerm;""%>"" ""|""]
	[SimpleTerm : . ;<symbolname> <tokenname> ""<%"" ""%>"" ""["" <keyword> ""error"" ""("" ""|""]

21	[Term : ""error"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

22	[SimpleTerm : .  SimpleTerm Term ""+"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""|"" "")""]
	[SimpleTerm : .  SimpleTerm Term;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" ""|"" "")""]
	[SimpleTerm : .  SimpleTerm Term ""?"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""|"" "")""]
	[SimpleTerm : .  SimpleTerm Term ""*"";<symbolname> <tokenname> ""["" <keyword> ""<%"" ""error"" ""("" ""|"" "")""]
	[SimpleTerms : .  SimpleTerm;""|"" "")""]
	[SimpleTerms : .  SimpleTerms ""|"" SimpleTerm;""|"" "")""]
	[SimpleTerm : . ;<symbolname> <tokenname> ""<%"" ""["" <keyword> ""error"" ""("" ""|"" "")""]
	[Term : ""("" .  SimpleTerms "")"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

23	[Term : <tokenname> . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

24	[Term : <symbolname> . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

25	[Term : <keyword> . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

26	[NonAssociativeLine : ""%nonassoc"" TokenList .  "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Term : .  <tokenname>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[TokenList : TokenList .  Term;<symbolname> ""error"" <tokenname> ""<%"" ""["" <keyword> ""("" "";""]
	[Term : .  <keyword>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""error"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  <symbolname>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]

27	[TokenList : Term . ;<symbolname> ""error"" <tokenname> ""<%"" ""["" <keyword> ""("" "";""]

28	[IdTokens : <tokenname> . ;<tokenname> "";""]

29	[IdTokens : IdTokens .  <tokenname>;<tokenname> "";""]
	[IdMethodLine : ""%id"" IdTokens .  "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

30	[Term : .  <tokenname>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[LeftLine : ""%left"" TokenList .  "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[TokenList : TokenList .  Term;<symbolname> ""error"" <tokenname> ""<%"" ""["" <keyword> ""("" "";""]
	[Term : .  <keyword>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""error"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  <symbolname>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]

31	[Term : .  ""["" SimpleTerms ""]"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  <tokenname>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[TokenList : TokenList .  Term;<symbolname> ""error"" <tokenname> ""<%"" ""["" <keyword> ""("" "";""]
	[Term : .  <keyword>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[RightLine : ""%right"" TokenList .  "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[Term : .  ""error"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]
	[Term : .  <symbolname>;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]

32	[Terms : .  Terms Term ""+"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRule : .  Terms <code>;""|"" "";""]
	[Terms : .  Terms Term ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term ""?"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term ""*"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRules : .  ParserRules ""|"" ParserRule;""|"" "";""]
	[Terms : .  Terms Term <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ProductionRule : <symbolname> <production> .  ParserRules "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]
	[ParserRule : .  Terms;""|"" "";""]
	[Terms : .  Terms Term;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRules : .  ParserRule;""|"" "";""]
	[Terms : .  Terms Term ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

33	[Parser : Parser Rule . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

34	[StartLine : ""%start"" StartingTokens "";"" . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

35	[StartingTokens : StartingTokens <symbolname> . ;<symbolname> "";""]

36	[Term : ""["" SimpleTerms .  ""]"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]
	[SimpleTerms : SimpleTerms .  ""|"" SimpleTerm;""]"" ""|""]

37	[SimpleTerms : SimpleTerm . ;"")"" ""]"" ""|"" ""%>""]
	[Term : .  <tokenname>;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[SimpleTerm : SimpleTerm .  Term;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[SimpleTerm : SimpleTerm .  Term ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[Term : .  <keyword>;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[SimpleTerm : SimpleTerm .  Term ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : SimpleTerm .  Term ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[Term : .  ""error"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[Term : .  <symbolname>;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]

38	[SimpleTerms : SimpleTerms .  ""|"" SimpleTerm;""%>"" ""|""]
	[Term : ""<%"" SimpleTerms .  ""%>"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

39	[SimpleTerms : SimpleTerms .  ""|"" SimpleTerm;""|"" "")""]
	[Term : ""("" SimpleTerms .  "")"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

40	[NonAssociativeLine : ""%nonassoc"" TokenList "";"" . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

41	[TokenList : TokenList Term . ;<symbolname> ""error"" <tokenname> <keyword> ""<%"" ""["" ""("" "";""]

42	[IdMethodLine : ""%id"" IdTokens "";"" . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

43	[IdTokens : IdTokens <tokenname> . ;<tokenname> "";""]

44	[LeftLine : ""%left"" TokenList "";"" . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

45	[RightLine : ""%right"" TokenList "";"" . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

46	[ParserRules : ParserRules .  ""|"" ParserRule;""|"" "";""]
	[ProductionRule : <symbolname> <production> ParserRules .  "";"";E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

47	[ParserRules : ParserRule . ;""|"" "";""]

48	[Terms : Terms .  Term ""*"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms .  Term ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Term : .  <tokenname>;<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]
	[Terms : Terms .  Term <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]
	[ParserRule : Terms . ;""|"" "";""]
	[Terms : Terms .  Term;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms .  Term ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms .  Term ""+"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRule : Terms .  <code>;""|"" "";""]
	[Term : .  <keyword>;<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]
	[Terms : Terms .  Term ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms .  Term ""?"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Term : .  ""error"";<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]
	[Term : .  <symbolname>;<symbolname> <tokenname> ""<%"" ""|"" ""+"" ""("" ""error"" ""?"" <variablename> ""["" <keyword> ""*"" <code> "";""]

49	[Term : ""["" SimpleTerms ""]"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

50	[SimpleTerm : .  SimpleTerm Term ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : .  SimpleTerm Term;<symbolname> <tokenname> ""|"" ""<%"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : .  SimpleTerm Term ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : .  SimpleTerm Term ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerms : SimpleTerms ""|"" .  SimpleTerm;"")"" ""]"" ""|"" ""%>""]
	[SimpleTerm : . ;<symbolname> <tokenname> ""|"" ""<%"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]

51	[SimpleTerm : SimpleTerm Term .  ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : SimpleTerm Term .  ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : SimpleTerm Term . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : SimpleTerm Term .  ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]

52	[Term : ""<%"" SimpleTerms ""%>"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

53	[Term : ""("" SimpleTerms "")"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""+"" ""]"" "")"" ""error"" ""["" <keyword> ""?"" <variablename> ""*"" <code> "";""]

54	[ProductionRule : <symbolname> <production> ParserRules "";"" . ;E O F <symbolname> ""%left"" ""%start"" ""%right"" ""%nonassoc"" ""%id""]

55	[Terms : .  Terms Term ""+"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRule : .  Terms <code>;""|"" "";""]
	[Terms : .  Terms Term ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term ""?"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term ""*"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : .  Terms Term <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : . ;<symbolname> <tokenname> ""|"" ""<%"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRules : ParserRules ""|"" .  ParserRule;""|"" "";""]
	[Terms : .  Terms Term;<symbolname> <tokenname> ""|"" ""<%"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[ParserRule : .  Terms;""|"" "";""]
	[Terms : .  Terms Term ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

56	[ParserRule : Terms <code> . ;""|"" "";""]

57	[Terms : Terms Term .  ""*"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term .  ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term .  ""?"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term .  <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term .  ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term .  ""+"" <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term .  ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

58	[SimpleTerms : SimpleTerms ""|"" SimpleTerm . ;""%>"" ""]"" "")"" ""|""]
	[Term : .  <tokenname>;<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[Term : .  ""<%"" SimpleTerms ""%>"";<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[SimpleTerm : SimpleTerm .  Term;<symbolname> <tokenname> ""|"" ""<%"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[Term : .  ""("" SimpleTerms "")"";<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[SimpleTerm : SimpleTerm .  Term ""+"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[Term : .  <keyword>;<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[SimpleTerm : SimpleTerm .  Term ""?"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[SimpleTerm : SimpleTerm .  Term ""*"";<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]
	[Term : .  ""error"";<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[Term : .  ""["" SimpleTerms ""]"";<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]
	[Term : .  <symbolname>;<symbolname> <tokenname> ""%>"" ""|"" ""<%"" ""+"" ""("" ""]"" "")"" ""error"" ""["" <keyword> ""?"" ""*""]

59	[SimpleTerm : SimpleTerm Term ""?"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]

60	[SimpleTerm : SimpleTerm Term ""*"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]

61	[SimpleTerm : SimpleTerm Term ""+"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""%>"" ""("" ""]"" "")"" ""error"" ""["" <keyword>]

62	[ParserRules : ParserRules ""|"" ParserRule . ;""|"" "";""]

63	[Terms : Terms Term ""?"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term ""?"" .  <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

64	[Terms : Terms Term ""*"" .  <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term ""*"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

65	[Terms : Terms Term ""+"" .  <variablename>;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]
	[Terms : Terms Term ""+"" . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

66	[Terms : Terms Term <variablename> . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

67	[Terms : Terms Term ""?"" <variablename> . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

68	[Terms : Terms Term ""*"" <variablename> . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

69	[Terms : Terms Term ""+"" <variablename> . ;<symbolname> <tokenname> ""<%"" ""|"" ""("" ""error"" ""["" <keyword> <code> "";""]

"! !

!SmaCCGrammarParser class methodsFor: 'generated-comments' stamp: 'jmb 1/21/2003 17:17'!
parserDefinitionComment

	"File:	Parser {grammar addEmptySymbol; yourself};

Parser:	Rule
	| Parser Rule ;

Rule : ProductionRule {grammar setStartSymbolIfNone: '1'. nil}
	| LeftLine 
	| RightLine 
	| NonAssociativeLine
	| IdMethodLine
	| StartLine ;

LeftLine:	""%left"" TokenList 'tokens' "";"" { tokens do: [:each | grammar leftPrecedenceFor: each; setOperatorPrecedenceFor: each to: scanner lineNumber]. nil };
RightLine:	""%right"" TokenList 'tokens' "";"" { tokens do: [:each | grammar rightPrecedenceFor: each; setOperatorPrecedenceFor: each to: scanner lineNumber]. nil };
NonAssociativeLine: ""%nonassoc"" TokenList 'tokens' "";"" { tokens do: [:each | grammar nonAssociativePrecedenceFor: each; setOperatorPrecedenceFor: each to: scanner lineNumber]. nil };
IdMethodLine: ""%id"" IdTokens 'tokens' "";"" {tokens do: [:each | grammar makeTokenIdMethodFor: each]. nil};
StartLine: ""%start"" StartingTokens "";"";

IdTokens: <tokenname> {OrderedCollection with: '1' value}
	| IdTokens <tokenname> {'1' add: '2' value; yourself};
TokenList:	Term
	| TokenList Term	;
StartingTokens: <symbolname> 'symbol' {grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: symbol value)}
	| StartingTokens <symbolname> 'symbol' {grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: symbol value)};

ProductionRule: <symbolname> <production> ParserRules "";"" {| symbol | symbol := grammar nonTerminalSymbolNamed: '1' value. '3' do: [:each | symbol addProduction: each]. symbol};

ParserRules:	ParserRules ""|"" ParserRule {'1' add: '3'; yourself}
	| ParserRule	 ;

ParserRule : Terms 'rhs' {rhs}
	| Terms 'rhs' <code> 'code' {self verifyCodeToken: code for: rhs} ;

Terms :	{SmaCCRHS new}
	| Terms 'rhs' Term 'term'	{rhs add: term; yourself}	
	| Terms 'rhs' Term 'term' <variablename> 'variableNameToken'	{rhs add: term; nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}	
	| Terms 'rhs' Term 'term' ""?"" {rhs add: (grammar makeOptionalSymbolFor: term); yourself}
	| Terms 'rhs' Term 'term' ""?"" <variablename> 'variableNameToken' {rhs add: (grammar makeOptionalSymbolFor: term); nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}	
	| Terms 'rhs' Term 'term' ""*"" {rhs add: (grammar makeRepeatSymbolFor: term); yourself}
	| Terms 'rhs' Term 'term' ""*"" <variablename> 'variableNameToken' {rhs add: (grammar makeRepeatSymbolFor: term); nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}		
	| Terms 'rhs' Term 'term' ""+"" {rhs add: (grammar makeRepeatMultipleSymbolFor: term); yourself}
	| Terms 'rhs' Term 'term' ""+"" <variablename> 'variableNameToken' {rhs add: (grammar makeRepeatMultipleSymbolFor: term); nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}	;

Term:	<keyword> {grammar keywordTerminalNamed: '1' value}
	| <tokenname> {grammar terminalSymbolNamed: '1' value ifAbsent: [currentToken := '1'. self reportErrorMessage: 'Token not specified']}
	| <symbolname> {grammar nonTerminalSymbolNamed: '1' value}
	| ""error"" {SmaCCSymbol error}
	| ""("" SimpleTerms "")"" {grammar makeGroupFor: '2'}
	| ""<%"" SimpleTerms ""%>"" {grammar makeRepeatSymbolFor: (grammar makeGroupFor: '2')}
	| ""["" SimpleTerms ""]"" {grammar makeOptionalSymbolFor: (grammar makeGroupFor: '2')};

SimpleTerms :
	SimpleTerm {OrderedCollection with: '1'}
	| SimpleTerms 'terms' ""|"" SimpleTerm 'term' {terms add: term; yourself};

SimpleTerm :
	{ SmaCCRHS new }
	| SimpleTerm 'rhs' Term 'term' {rhs add: term; yourself} 
	| SimpleTerm 'rhs' Term 'term' ""?"" {rhs add: (grammar makeOptionalSymbolFor: term); yourself}
	| SimpleTerm 'rhs' Term 'term' ""*"" {rhs add: (grammar makeRepeatSymbolFor: term); yourself}
	| SimpleTerm 'rhs' Term 'term' ""+"" {rhs add: (grammar makeRepeatMultipleSymbolFor: term); yourself}	;"! !

!SmaCCGrammarParser class methodsFor: 'generated-accessing' stamp: 'jmb 1/21/2003 17:17'!
scannerClass
	^SmaCCGrammarScanner! !

!SmaCCGrammarParser class methodsFor: 'generated-starting states' stamp: 'jmb 1/21/2003 17:17'!
startingStateForFile
	^1! !

!SmaCCGrammarParser class methodsFor: 'generated-comments' stamp: 'jmb 1/21/2003 17:17'!
symbolComment

	"
1. ""%start""
2. ""]""
3. ""%nonassoc""
4. ""%id""
5. ""?""
6. ""%left""
7. "";""
8. ""%right""
9. ""|""
10. ""*""
11. ""[""
12. ""%>""
13. ""<%""
14. "")""
15. ""error""
16. ""+""
17. ""(""
18. <whitespace>
19. <tokenname>
20. <symbolname>
21. <keyword>
22. <comment>
23. <code>
24. <variablename>
25. <production>
26. IdMethodLine
27. StartLine
28. TokenList
29. IdTokens
30. StartingTokens
31. NonAssociativeLine
32. Term
33. B e g i n
34. ProductionRule
35. ParserRules
36. ParserRule
37. Terms
38. RightLine
39. Rule
40. File
41. SimpleTerms
42. SimpleTerm
43. E O F
44. error
45. Parser
46. LeftLine
"! !

!SmaCCGrammarParser methodsFor: 'accessing' stamp: ''!
grammar
	^grammar! !

!SmaCCGrammarParser methodsFor: 'accessing' stamp: ''!
grammar: aGrammar
	grammar := aGrammar! !

!SmaCCGrammarParser methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	grammar := SmaCCGrammar new! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForFile1: nodes 
	^grammar
		addEmptySymbol;
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForIdMethodLine1: nodes 
	(nodes at: 2) do: [:each | grammar makeTokenIdMethodFor: each].
	^nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForIdTokens1: nodes 
	^OrderedCollection with: (nodes at: 1) value! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForIdTokens2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2) value;
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForLeftLine1: nodes 
	(nodes at: 2) do: 
			[:each | 
			grammar
				leftPrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber].
	^nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForNonAssociativeLine1: nodes 
	(nodes at: 2) do: 
			[:each | 
			grammar
				nonAssociativePrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber].
	^nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForParserRule1: nodes 
	^nodes at: 1! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForParserRule2: nodes 
	^self verifyCodeToken: (nodes at: 2) for: (nodes at: 1)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForParserRules1: nodes 
	^(nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForProductionRule1: nodes 
	| symbol |
	symbol := grammar nonTerminalSymbolNamed: (nodes at: 1) value.
	(nodes at: 3) do: [:each | symbol addProduction: each].
	^symbol! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForRightLine1: nodes 
	(nodes at: 2) do: 
			[:each | 
			grammar
				rightPrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber].
	^nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForRule1: nodes 
	grammar setStartSymbolIfNone: (nodes at: 1).
	^nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerm1: nodes 
	^SmaCCRHS new! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerm2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerm3: nodes 
	^(nodes at: 1)
		add: (grammar makeOptionalSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerm4: nodes 
	^(nodes at: 1)
		add: (grammar makeRepeatSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerm5: nodes 
	^(nodes at: 1)
		add: (grammar makeRepeatMultipleSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerms1: nodes 
	^OrderedCollection with: (nodes at: 1)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForSimpleTerms2: nodes 
	^(nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForStartingTokens1: nodes 
	^grammar 
		addStartingSymbol: (grammar nonTerminalSymbolNamed: (nodes at: 1) value)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForStartingTokens2: nodes 
	^grammar 
		addStartingSymbol: (grammar nonTerminalSymbolNamed: (nodes at: 2) value)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm1: nodes 
	^grammar keywordTerminalNamed: (nodes at: 1) value! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm2: nodes 
	^grammar terminalSymbolNamed: (nodes at: 1) value
		ifAbsent: 
			[currentToken := nodes at: 1.
			self reportErrorMessage: 'Token not specified']! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm3: nodes 
	^grammar nonTerminalSymbolNamed: (nodes at: 1) value! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm4: nodes 
	^SmaCCSymbol error! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm5: nodes 
	^grammar makeGroupFor: (nodes at: 2)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm6: nodes 
	^grammar makeRepeatSymbolFor: (grammar makeGroupFor: (nodes at: 2))! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerm7: nodes 
	^grammar makeOptionalSymbolFor: (grammar makeGroupFor: (nodes at: 2))! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms1: nodes 
	^SmaCCRHS new! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms3: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		nameLastItem: ((nodes at: 3) value copyFrom: 2
					to: (nodes at: 3) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms4: nodes 
	^(nodes at: 1)
		add: (grammar makeOptionalSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms5: nodes 
	^(nodes at: 1)
		add: (grammar makeOptionalSymbolFor: (nodes at: 2));
		nameLastItem: ((nodes at: 4) value copyFrom: 2
					to: (nodes at: 4) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms6: nodes 
	^(nodes at: 1)
		add: (grammar makeRepeatSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms7: nodes 
	^(nodes at: 1)
		add: (grammar makeRepeatSymbolFor: (nodes at: 2));
		nameLastItem: ((nodes at: 4) value copyFrom: 2
					to: (nodes at: 4) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms8: nodes 
	^(nodes at: 1)
		add: (grammar makeRepeatMultipleSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 17:17'!
reduceActionForTerms9: nodes 
	^(nodes at: 1)
		add: (grammar makeRepeatMultipleSymbolFor: (nodes at: 2));
		nameLastItem: ((nodes at: 4) value copyFrom: 2
					to: (nodes at: 4) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-tables' stamp: 'jmb 1/21/2003 17:17'!
reduceTable
	^#(
#(26 3 #reduceActionForIdMethodLine1:)
#(27 3 #reduceFor:)
#(28 1 #reduceFor:)
#(28 2 #reduceFor:)
#(29 1 #reduceActionForIdTokens1:)
#(29 2 #reduceActionForIdTokens2:)
#(30 1 #reduceActionForStartingTokens1:)
#(30 2 #reduceActionForStartingTokens2:)
#(31 3 #reduceActionForNonAssociativeLine1:)
#(32 1 #reduceActionForTerm1:)
#(32 1 #reduceActionForTerm2:)
#(32 1 #reduceActionForTerm3:)
#(32 1 #reduceActionForTerm4:)
#(32 3 #reduceActionForTerm5:)
#(32 3 #reduceActionForTerm6:)
#(32 3 #reduceActionForTerm7:)
#(33 1 #reduceFor:)
#(34 4 #reduceActionForProductionRule1:)
#(35 3 #reduceActionForParserRules1:)
#(35 1 #reduceFor:)
#(36 1 #reduceActionForParserRule1:)
#(36 2 #reduceActionForParserRule2:)
#(37 0 #reduceActionForTerms1:)
#(37 2 #reduceActionForTerms2:)
#(37 3 #reduceActionForTerms3:)
#(37 3 #reduceActionForTerms4:)
#(37 4 #reduceActionForTerms5:)
#(37 3 #reduceActionForTerms6:)
#(37 4 #reduceActionForTerms7:)
#(37 3 #reduceActionForTerms8:)
#(37 4 #reduceActionForTerms9:)
#(38 3 #reduceActionForRightLine1:)
#(39 1 #reduceActionForRule1:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(40 1 #reduceActionForFile1:)
#(41 1 #reduceActionForSimpleTerms1:)
#(41 3 #reduceActionForSimpleTerms2:)
#(42 0 #reduceActionForSimpleTerm1:)
#(42 2 #reduceActionForSimpleTerm2:)
#(42 3 #reduceActionForSimpleTerm3:)
#(42 3 #reduceActionForSimpleTerm4:)
#(42 3 #reduceActionForSimpleTerm5:)
#(45 1 #reduceFor:)
#(45 2 #reduceFor:)
#(46 3 #reduceActionForLeftLine1:)
)! !

!SmaCCGrammarParser methodsFor: 'generated-tables' stamp: 'jmb 1/21/2003 17:17'!
transitionTable
	^#(
#(3 9 1 13 3 17 4 21 6 25 8 29 20 33 26 37 27 41 31 45 34 49 38 53 39 57 40 61 45 65 46)
#(3 69 20 73 30)
#(3 77 11 81 13 85 15 89 17 93 19 97 20 101 21 105 28 109 32)
#(3 113 19 117 29)
#(3 77 11 81 13 85 15 89 17 93 19 97 20 101 21 121 28 109 32)
#(3 77 11 81 13 85 15 89 17 93 19 97 20 101 21 125 28 109 32)
#(2 129 25)
#(2 150 1 3 4 6 8 20 43)
#(2 154 1 3 4 6 8 20 43)
#(2 146 1 3 4 6 8 20 43)
#(2 134 1 3 4 6 8 20 43)
#(2 142 1 3 4 6 8 20 43)
#(2 190 1 3 4 6 8 20 43)
#(2 0 43)
#(3 9 1 13 3 17 4 21 6 25 8 29 20 33 26 37 27 41 31 45 34 49 38 133 39 158 43 65 46)
#(2 138 1 3 4 6 8 20 43)
#(2 30 7 20)
#(3 137 7 141 20)
#(3 170 2 170 9 170 11 170 13 170 15 170 17 170 19 170 20 170 21 145 41 149 42)
#(3 170 9 170 11 170 12 170 13 170 15 170 17 170 19 170 20 170 21 153 41 149 42)
#(2 54 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(3 170 9 170 11 170 13 170 14 170 15 170 17 170 19 170 20 170 21 157 41 149 42)
#(2 46 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(2 50 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(2 42 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(3 161 7 77 11 81 13 85 15 89 17 93 19 97 20 101 21 165 32)
#(2 14 7 11 13 15 17 19 20 21)
#(2 22 7 19)
#(3 169 7 173 19)
#(3 177 7 77 11 81 13 85 15 89 17 93 19 97 20 101 21 165 32)
#(3 181 7 77 11 81 13 85 15 89 17 93 19 97 20 101 21 165 32)
#(3 94 7 94 9 94 11 94 13 94 15 94 17 94 19 94 20 94 21 94 23 185 35 189 36 193 37)
#(2 194 1 3 4 6 8 20 43)
#(2 10 1 3 4 6 8 20 43)
#(2 34 7 20)
#(3 197 2 201 9)
#(3 162 2 162 9 77 11 162 12 81 13 162 14 85 15 89 17 93 19 97 20 101 21 205 32)
#(3 201 9 209 12)
#(3 201 9 213 14)
#(2 38 1 3 4 6 8 20 43)
#(2 18 7 11 13 15 17 19 20 21)
#(2 6 1 3 4 6 8 20 43)
#(2 26 7 19)
#(2 198 1 3 4 6 8 20 43)
#(2 130 1 3 4 6 8 20 43)
#(3 217 7 221 9)
#(2 82 7 9)
#(3 86 7 86 9 77 11 81 13 85 15 89 17 93 19 97 20 101 21 225 23 229 32)
#(2 66 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(3 170 2 170 9 170 11 170 12 170 13 170 14 170 15 170 17 170 19 170 20 170 21 233 42)
#(3 174 2 237 5 174 9 241 10 174 11 174 12 174 13 174 14 174 15 245 16 174 17 174 19 174 20 174 21)
#(2 62 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(2 58 2 5 7 9 10 11 12 13 14 15 16 17 19 20 21 23 24)
#(2 74 1 3 4 6 8 20 43)
#(3 94 7 94 9 94 11 94 13 94 15 94 17 94 19 94 20 94 21 94 23 249 36 193 37)
#(2 90 7 9)
#(3 253 5 98 7 98 9 257 10 98 11 98 13 98 15 261 16 98 17 98 19 98 20 98 21 98 23 265 24)
#(3 166 2 166 9 77 11 166 12 81 13 166 14 85 15 89 17 93 19 97 20 101 21 205 32)
#(2 178 2 9 11 12 13 14 15 17 19 20 21)
#(2 182 2 9 11 12 13 14 15 17 19 20 21)
#(2 186 2 9 11 12 13 14 15 17 19 20 21)
#(2 78 7 9)
#(3 106 7 106 9 106 11 106 13 106 15 106 17 106 19 106 20 106 21 106 23 269 24)
#(3 114 7 114 9 114 11 114 13 114 15 114 17 114 19 114 20 114 21 114 23 273 24)
#(3 122 7 122 9 122 11 122 13 122 15 122 17 122 19 122 20 122 21 122 23 277 24)
#(2 102 7 9 11 13 15 17 19 20 21 23)
#(2 110 7 9 11 13 15 17 19 20 21 23)
#(2 118 7 9 11 13 15 17 19 20 21 23)
#(2 126 7 9 11 13 15 17 19 20 21 23)
)! !

!SmaCCGrammarParser methodsFor: 'private' stamp: ''!
verifyCodeToken: codeToken for: aRHS 
	| code |
	code := codeToken value copyFrom: 2 to: codeToken value size - 1.
	RBParser parseExpression: code
		onError: 
			[:string :position | 
			currentToken := nil.
			scanner position: codeToken startPosition + position.
			self reportErrorMessage: string].
	aRHS reduceAction: code.
	^aRHS! !

SmaCCParser subclass: #SmaCCScannerParser
	instanceVariableNames: 'tokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCScannerParser commentStamp: 'jmb' prior: 0!
SmaCCScannerParser is the parser for the scanner definition.

Instance Variables:
	tokens	<Dictionary key: String value: SmaCCRegularExpressionNode>	the tokens that are parsed

!

!SmaCCScannerParser class methodsFor: 'generated-comments' stamp: 'jmb 1/21/2003 20:27'!
parserDefinitionComment

	"%left	""|"";
%left ""("" <character> <backslashcharacter> <characterblock> <anycharacter> <tokenname>;
%left ""*"" ""+"" ""?"" <repeat> ;

File: Rules	 {tokens} 
	|  {tokens};

Rules: Rule "";""
	| Rules Rule "";"" ;

Rule: <tokenname> "":"" Regex {'3' position: '1' startPosition. tokens at: '1' value put: '3'. nil};

Regex: RegexTerm {'1'}
	| Regex ""|"" Regex {'1' | '3'}
	| Regex RegexTerm {'1' , '2'};

RegexTerm:	<character> {SmaCCCharacterRENode characters: '1' value}
	| <anycharacter> {SmaCCCharacterRENode characters: self allCharacters}
	| <backslashcharacter> {self nodeFor: (ReadStream on: ('1' value copyFrom: 2 to: '1' value size))} 
	| ""("" Regex "")"" {'2'}
	| <characterblock> {SmaCCCharacterRENode characters: (self parseCharacterBlock: '1')}
	| <tokenname> {(tokens at: '1' value) copy}
	| RegexTerm ""*""	{'1' repeat}
	| RegexTerm ""+"" {'1' repeatForAtLeast: 1}
	| RegexTerm ""?"" {'1' repeatFor: 0 to: 1}
	| RegexTerm <repeat> {| readStream start stop | 
					readStream := ReadStream on: ('2' value copyFrom: 2 to: '2' value size - 1). 
					start := readStream upTo: $,. 
					stop := readStream upToEnd.
					'1' repeatFor: (start isEmpty ifTrue: [0] ifFalse: [start asNumber]) to: (stop isEmpty ifTrue: [(1 bitShift: 31)] ifFalse: [stop asNumber])} ;"! !

!SmaCCScannerParser class methodsFor: 'generated-accessing' stamp: 'jmb 1/21/2003 20:27'!
scannerClass
	^SmaCCScannerScanner! !

!SmaCCScannerParser class methodsFor: 'generated-starting states' stamp: 'jmb 1/21/2003 20:27'!
startingStateForFile
	^1! !

!SmaCCScannerParser methodsFor: 'private' stamp: ''!
allCharacters
	^String withAll: ((0 to: SmaCCGrammar maximumCharacterValue) 
				collect: [:each | Character value: each])! !

!SmaCCScannerParser methodsFor: 'private' stamp: ''!
charactersFor: aStream in: aToken 
	| characters char endCharacters |
	aStream atEnd ifTrue: [self reportCharacterBlockErrorForToken: aToken].
	char := aStream next.
	characters := char == $\ 
				ifTrue: [(self nodeFor: aStream) characters]
				ifFalse: [OrderedCollection with: char].
	(characters size = 1 and: [aStream peekFor: $-]) ifFalse: [^characters].
	endCharacters := self charactersFor: aStream in: aToken.
	endCharacters size > 1 
		ifTrue: [self reportCharacterBlockErrorForToken: aToken].
	^(characters first asInteger to: endCharacters first asInteger) 
		collect: [:each | Character value: each]! !

!SmaCCScannerParser methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	tokens := Dictionary new! !

!SmaCCScannerParser methodsFor: 'private' stamp: 'jmb 1/20/2003 21:15'!
nodeFor: aStream 
	| block char value count |
	char := aStream next.
	char == $f 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 12))].
	char == $n 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 10))].
	char == $r 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 13))].
	char == $t ifTrue: [^SmaCCCharacterRENode characters: '	'].
	char == $v 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 11))].
	char == $c 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String 
						with: (Character value: aStream next asInteger - $A asInteger))].
	char == $x 
		ifTrue: 
			[count := value := 0.
			
			[aStream atEnd not and: 
					[count < 4 and: 
							[char := aStream peek.
							(char between: $0 and: $9) 
								or: [(char between: $A and: $F) or: [char between: $a and: $f]]]]] 
					whileTrue: 
						[count := count + 1.
						value := value * 16 + aStream next digitValue].
			^SmaCCCharacterRENode characters: (String with: (Character value: value))].
	char == $d ifTrue: [block := [:each | each between: $0 and: $9]].
	char == $D ifTrue: [block := [:each | (each between: $0 and: $9) not]].
	char == $s 
		ifTrue: [block := [:each | #(9 10 11 12 13 32) includes: each asInteger]].
	char == $S 
		ifTrue: 
			[block := [:each | (#(9 10 11 12 13 32) includes: each asInteger) not]].
	char == $w 
		ifTrue: 
			[block := 
					[:each | 
					(each between: $a and: $z) or: 
							[(each between: $A and: $Z) 
								or: [(each between: $0 and: $9) or: [each == $_]]]]].
	char == $W 
		ifTrue: 
			[block := 
					[:each | 
					((each between: $a and: $z) or: 
							[(each between: $A and: $Z) 
								or: [(each between: $0 and: $9) or: [each == $_]]]) 
						not]].
	block isNil 
		ifTrue: [^SmaCCCharacterRENode characters: (String with: char)].
	^SmaCCCharacterRENode 
		characters: (String withAll: (self allCharacters select: block))! !

!SmaCCScannerParser methodsFor: 'private' stamp: ''!
parseCharacterBlock: aToken 
	| characters aStream invert |
	aStream := ReadStream 
				on: (aToken value copyFrom: 2 to: aToken value size - 1).
	characters := OrderedCollection new.
	invert := aStream peekFor: $^.
	[aStream atEnd] 
		whileFalse: [characters addAll: (self charactersFor: aStream in: aToken)].
	^String withAll: (invert 
				ifTrue: [self allCharacters reject: [:each | characters includes: each]]
				ifFalse: [characters])! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForFile1: nodes 
	^tokens! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForFile2: nodes 
	^tokens! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegex1: nodes 
	^nodes at: 1! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegex2: nodes 
	^(nodes at: 1) | (nodes at: 3)! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegex3: nodes 
	^(nodes at: 1) , (nodes at: 2)! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm10: nodes 
	| readStream start stop |
	readStream := ReadStream 
				on: ((nodes at: 2) value copyFrom: 2 to: (nodes at: 2) value size - 1).
	start := readStream upTo: $,.
	stop := readStream upToEnd.
	^(nodes at: 1) 
		repeatFor: (start isEmpty ifTrue: [0] ifFalse: [start asNumber])
		to: (stop isEmpty ifTrue: [1 bitShift: 31] ifFalse: [stop asNumber])! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm1: nodes 
	^SmaCCCharacterRENode characters: (nodes at: 1) value! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm2: nodes 
	^SmaCCCharacterRENode characters: self allCharacters! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm3: nodes 
	^self nodeFor: (ReadStream 
				on: ((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size))! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm4: nodes 
	^nodes at: 2! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm5: nodes 
	^SmaCCCharacterRENode 
		characters: (self parseCharacterBlock: (nodes at: 1))! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm6: nodes 
	^(tokens at: (nodes at: 1) value) copy! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm7: nodes 
	^(nodes at: 1) repeat! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm8: nodes 
	^(nodes at: 1) repeatForAtLeast: 1! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRegexTerm9: nodes 
	^(nodes at: 1) repeatFor: 0 to: 1! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/21/2003 20:27'!
reduceActionForRule1: nodes 
	(nodes at: 3) position: (nodes at: 1) startPosition.
	tokens at: (nodes at: 1) value put: (nodes at: 3).
	^nil! !

!SmaCCScannerParser methodsFor: 'generated-tables' stamp: 'jmb 1/21/2003 20:27'!
reduceTable
	^#(
#(17 1 #reduceFor:)
#(18 1 #reduceActionForFile1:)
#(18 0 #reduceActionForFile2:)
#(19 1 #reduceActionForRegex1:)
#(19 3 #reduceActionForRegex2:)
#(19 2 #reduceActionForRegex3:)
#(20 1 #reduceActionForRegexTerm1:)
#(20 1 #reduceActionForRegexTerm2:)
#(20 1 #reduceActionForRegexTerm3:)
#(20 3 #reduceActionForRegexTerm4:)
#(20 1 #reduceActionForRegexTerm5:)
#(20 1 #reduceActionForRegexTerm6:)
#(20 2 #reduceActionForRegexTerm7:)
#(20 2 #reduceActionForRegexTerm8:)
#(20 2 #reduceActionForRegexTerm9:)
#(20 2 #reduceActionForRegexTerm10:)
#(23 2 #reduceFor:)
#(23 3 #reduceFor:)
#(24 3 #reduceActionForRule1:)
)! !

!SmaCCScannerParser methodsFor: 'private' stamp: ''!
reportCharacterBlockErrorForToken: aToken 
	currentToken := aToken.
	self reportErrorMessage: 'Invalid character block'! !

!SmaCCScannerParser methodsFor: 'generated-tables' stamp: 'jmb 1/21/2003 20:27'!
transitionTable
	^#(
#(3 9 12 13 18 14 21 17 23 21 24)
#(2 25 7)
#(2 0 21)
#(3 9 12 10 21 29 24)
#(2 33 8)
#(3 37 1 41 9 45 10 49 12 53 15 57 16 61 19 65 20)
#(2 69 8)
#(2 70 12 21)
#(3 37 1 41 9 45 10 49 12 53 15 57 16 73 19 65 20)
#(2 38 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 46 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 50 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 30 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 34 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(3 37 1 77 2 78 8 41 9 45 10 49 12 53 15 57 16 81 20)
#(3 18 1 18 2 85 3 18 4 89 5 93 6 18 8 18 9 18 10 18 12 97 14 18 15 18 16)
#(2 74 12 21)
#(3 37 1 77 2 101 4 41 9 45 10 49 12 53 15 57 16 81 20)
#(3 37 1 41 9 45 10 49 12 53 15 57 16 105 19 65 20)
#(3 26 1 26 2 85 3 26 4 89 5 93 6 26 8 26 9 26 10 26 12 97 14 26 15 26 16)
#(2 54 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 58 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 62 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 66 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(2 42 1 2 3 4 5 6 8 9 10 12 14 15 16)
#(3 37 1 22 2 22 4 22 8 41 9 45 10 49 12 53 15 57 16 81 20)
)! !

SmaCCParser subclass: #StParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Parsers'!

!StParser class methodsFor: 'accessing' stamp: ''!
parseExpression: aString 
	^self simplifyExpression: (self parse: aString
				startingAt: self startingStateForSequenceNode)! !

!StParser class methodsFor: 'accessing' stamp: ''!
parseExpression: aString onError: aBlock 
	^self simplifyExpression: (self 
				parse: aString
				startingAt: self startingStateForSequenceNode
				onError: aBlock)! !

!StParser class methodsFor: 'accessing' stamp: ''!
parseMethod: aString 
	^self parse: aString startingAt: self startingStateForMethod! !

!StParser class methodsFor: 'accessing' stamp: ''!
parseMethod: aString onError: aBlock 
	^self 
		parse: aString
		startingAt: self startingStateForMethod
		onError: aBlock! !

!StParser class methodsFor: 'generated-comments' stamp: 'jmb 1/23/2003 16:14'!
parserDefinitionComment

	"%id <number> <negativeNumber> <name> <binarySymbol>;
%start SequenceNode ;

Method:
	  <name> MethodSequenceNode {(RBMethodNode selector: '1' value asSymbol arguments: #() body: '2' last) tags: '2' first; yourself}
	| BinaryMethodName MethodSequenceNode {(RBMethodNode selector: '1' first arguments: '1' last body: '2' last) tags: '2' first; yourself}
	| KeywordMethodName MethodSequenceNode {(RBMethodNode selector: '1' first contents asSymbol arguments: '1' last body: '2' last) tags: '2' first; yourself};

BinaryMethodName:
	<binarySymbol> Variable {Array with: '1' value asSymbol with: (Array with: '2')} ;

KeywordMethodName:
	<keyword> Variable {| stream | stream := WriteStream on: (String new: 30). stream nextPutAll: '1' value. Array with: stream with: (OrderedCollection with: '2')}
	| KeywordMethodName <keyword> Variable {'1' first nextPutAll: '2' value. '1' last add: '3'. '1'};

Primitives:
	{OrderedCollection new}
	| Primitives ""<"" PrimitiveMessageSend "">"" {'1' add: ('2' startPosition to: '4' startPosition); yourself};

PrimitiveMessageSend:
	| PrimitiveMessageSend <keyword> {nil}
	| PrimitiveMessageSend Literal {nil}
	| PrimitiveMessageSend ""("" {nil}
	| PrimitiveMessageSend "")"" {nil}
	| PrimitiveMessageSend ""{"" {nil}
	| PrimitiveMessageSend ""}"" {nil}
	| PrimitiveMessageSend "";"" {nil}
	| PrimitiveMessageSend ""."" {nil}
	| PrimitiveMessageSend <name> {nil}
	| PrimitiveMessageSend <binarySymbol> {nil};

MethodSequenceNode:
	Primitives ""|"" TemporaryVariables ""|"" Primitives Statements {Array with: ('1' addAll: '5'; yourself) with: (RBSequenceNode temporaries: '3' statements: '6')}
	| Primitives ""||"" Primitives Statements {Array with: ('1' addAll: '3'; yourself) with: (RBSequenceNode temporaries: #() statements: '4')}
	| Primitives Statements {Array with: '1' with: (RBSequenceNode temporaries: #() statements: '2')};

SequenceNode:
	Temporaries Statements {RBSequenceNode temporaries: '1' statements: '2'};

Temporaries:
	{#()}
	| ""||"" {#()}
	| ""|"" TemporaryVariables ""|"" {'2'};

TemporaryVariables:
	{OrderedCollection new}
	| TemporaryVariables Variable {'1' add: '2'; yourself};

Statements:
	{OrderedCollection new}
	| StatementList "".""? {#liftFirstValue:}
	| StatementList ""."" ""^"" Expression "".""? {'1' add: (RBReturnNode value: '4'); yourself}
	| ""^"" Expression "".""? {OrderedCollection with: (RBReturnNode value: '2')};

StatementList:
	Expression
	| StatementList ""."" Expression {'1' add: '3'; yourself};

Block:
	""["" BlockArgs ""|"" SequenceNode ""]"" {RBBlockNode arguments: '2' body: '4'}
	| ""["" SequenceNode ""]"" {RBBlockNode body: '2'}
	| ""["" BlockArgs ""]"" {RBBlockNode arguments: '2' body: (RBSequenceNode statements: #())}
	| ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {RBBlockNode arguments: '2' body: (RBSequenceNode temporaries: '4' statements: '6')};

BlockArgs:
	"":"" Variable {OrderedCollection with: '2'}
	| BlockArgs "":"" Variable {'1' add: '3'; yourself};


Expression:
	Variable "":="" Expression {RBAssignmentNode variable: '1' value: '3'}
|	Cascade {#liftFirstValue:};

Cascade:
	MessageSend CascadeList 
				{| messages |
				'2' isEmpty ifTrue: [^'1'].
				messages := OrderedCollection new: '2' size + 1.
				messages add: '1'.
				'2' do: [:each | messages add: (RBMessageNode receiver: '1' receiver selector: each first contents asSymbol arguments: each last)].
				RBCascadeNode messages: messages}
|	Primary {#liftFirstValue:};

MessageSend:
	KeywordMessageSend {#liftFirstValue:}
|	BinaryMessageSend {#liftFirstValue:}
|	UnaryMessageSend {#liftFirstValue:};

CascadeList:
	{OrderedCollection new}
|	CascadeList "";"" SimpleMessage {'1' add: '3'; yourself};

SimpleMessage:
	UnaryMessage {#liftFirstValue:}
|	BinaryMessage {#liftFirstValue:}
|	KeywordMessage {#liftFirstValue:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage {#createMessageNodeFrom:}
|	UnaryMessageSend KeywordMessage {#createMessageNodeFrom:}
|	Primary KeywordMessage {#createMessageNodeFrom:};

KeywordMessage:
	<keyword> KeywordArgument {| stream | stream := WriteStream on: (String new: 30). stream nextPutAll: '1' value. Array with: stream with: (OrderedCollection with: '2')}
|	KeywordMessage <keyword> KeywordArgument {'1' first nextPutAll: '2' value. '1' last add: '3'. '1'};

KeywordArgument:
	BinaryMessageSend {#liftFirstValue:}
|	UnaryMessageSend {#liftFirstValue:}
|	Primary {#liftFirstValue:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage {#createMessageNodeFrom:}
|	UnaryMessageSend BinaryMessage {#createMessageNodeFrom:}
|	Primary BinaryMessage {#createMessageNodeFrom:} ;

BinaryMessage :
	<binarySymbol> BinaryArgument {Array with: (ReadStream on: '1' value) with: (Array with: '2')};

BinaryArgument:
	UnaryMessageSend {#liftFirstValue:}
|	Primary {#liftFirstValue:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage {#createMessageNodeFrom:}
|	Primary UnaryMessage {#createMessageNodeFrom:};

UnaryMessage :
	<name> {Array with: (ReadStream on: '1' value) with: #()};


Primary: 
	""("" Expression "")"" {#liftSecondValue:}
|	Literal {RBLiteralNode value: '1'}
|	Variable {#liftFirstValue:}
|	Block {#liftFirstValue:};

Variable: 
	<name> {RBVariableNode named: '1' value}
|	<dottedName> {RBVariableNode named: '1' value};

Literal:
	""true"" {true}
|	""false"" {false}
|	""nil"" {nil}
|	<number> {'1' value}
|	<negativeNumber> {'1' value}
|	<character> {'1' value at: 2}
|	<string> {('1' value copyFrom: 2 to: '1' value size - 1) copyReplaceAll: '''''' with: ''''}
|	 ""#"" <string> {(('2' value copyFrom: 2 to: '2' value size - 1) copyReplaceAll: '''''' with: '''') asSymbol}
|	""#"" <name> {'2' value asSymbol}
|	""#"" <binarySymbol> {'2' value asSymbol}
|	""#"" <keyword> {'2' value asSymbol}
|	""#"" <multikeyword> {'2' value asSymbol}
|	""#"" ""["" ByteArray ""]"" {'3' contents}
|	""#"" ""("" Array "")"" {'3' contents}
|	""#"" ""{"" <name> ""}"" {'3' value asQualifiedReference}
|	""#"" ""{"" <dottedName> ""}"" {'3' value asQualifiedReference};

ByteArray: 
	{WriteStream on: ByteArray new}
|	ByteArray <number> {'1' nextPut: '2' value; yourself};

Array: 
	{WriteStream on: Array new}
|	Array ArrayLiteral {'1' nextPut: '2'; yourself} 
|	Array <name> "":="" {'2' stopPosition + 1 = '3' startPosition ifTrue: ['1' nextPut: ('2' value, ':') asSymbol] ifFalse: ['1' nextPut: '2' value asSymbol; nextPut: #':']. scanner position: '3' startPosition. currentToken := nil. '1'};

ArrayLiteral:
	Literal {#liftFirstValue:}
|	<name> {'1' value asSymbol}
|	<binarySymbol> {'1' value asSymbol}
|	<keyword> {'1' value asSymbol}
|	<multikeyword> {'1' value asSymbol}
|	""{"" <name> ""}"" {'2' value asQualifiedReference}
|	""{"" <dottedName> ""}"" {'2' value asQualifiedReference}
|	""("" Array "")"" {'2' contents}
|	""["" ByteArray ""]"" {'2' contents}
|	<anyChar> {'1' value asSymbol}
|	<dottedName> {'1' value};"! !

!StParser class methodsFor: 'generated-accessing' stamp: 'jmb 1/23/2003 16:14'!
scannerClass
	^StScanner! !

!StParser class methodsFor: 'private' stamp: ''!
simplifyExpression: aSequenceNode 
	^(aSequenceNode statements size == 1 
		and: [aSequenceNode temporaries isEmpty]) 
			ifTrue: [aSequenceNode statements first]
			ifFalse: [aSequenceNode]! !

!StParser class methodsFor: 'generated-starting states' stamp: 'jmb 1/23/2003 16:14'!
startingStateForMethod
	^1! !

!StParser class methodsFor: 'generated-starting states' stamp: 'jmb 1/23/2003 16:14'!
startingStateForSequenceNode
	^2! !

!StParser methodsFor: 'private' stamp: ''!
actionForCurrentToken
	| ids action |
	ids := currentToken id.
	1 to: ids size
		do: 
			[:i | 
			action := self actionFor: (ids at: i).
			(action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
			(ids at: i) = scanner negativeNumberId 
				ifTrue: 
					[currentToken := SmaCCToken 
								value: '-'
								start: currentToken startPosition
								id: (Array with: scanner binarySymbolId).
					scanner position: currentToken stopPosition - 1.
					^self actionForCurrentToken]].
	^self errorAction! !

!StParser methodsFor: 'private' stamp: ''!
createMessageNodeFrom: aCollection 
	^RBMessageNode 
		receiver: aCollection first
		selector: (aCollection at: 2) first contents asSymbol
		arguments: (aCollection at: 2) last! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArray1: nodes 
	^WriteStream on: Array new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArray2: nodes 
	^(nodes at: 1)
		nextPut: (nodes at: 2);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArray3: nodes 
	(nodes at: 2) stopPosition + 1 = (nodes at: 3) startPosition 
		ifTrue: [(nodes at: 1) nextPut: ((nodes at: 2) value , ':') asSymbol]
		ifFalse: 
			[(nodes at: 1)
				nextPut: (nodes at: 2) value asSymbol;
				nextPut: #':'].
	scanner position: (nodes at: 3) startPosition.
	currentToken := nil.
	^nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral10: nodes 
	^(nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral11: nodes 
	^(nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral2: nodes 
	^(nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral3: nodes 
	^(nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral4: nodes 
	^(nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral5: nodes 
	^(nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral6: nodes 
	^(nodes at: 2) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral7: nodes 
	^(nodes at: 2) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral8: nodes 
	^(nodes at: 2) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForArrayLiteral9: nodes 
	^(nodes at: 2) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBinaryMessage1: nodes 
	^Array with: (ReadStream on: (nodes at: 1) value)
		with: (Array with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBinaryMethodName1: nodes 
	^Array with: (nodes at: 1) value asSymbol with: (Array with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBlock1: nodes 
	^RBBlockNode arguments: (nodes at: 2) body: (nodes at: 4)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBlock2: nodes 
	^RBBlockNode body: (nodes at: 2)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBlock3: nodes 
	^RBBlockNode arguments: (nodes at: 2)
		body: (RBSequenceNode statements: #())! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBlock4: nodes 
	^RBBlockNode arguments: (nodes at: 2)
		body: (RBSequenceNode temporaries: (nodes at: 4) statements: (nodes at: 6))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBlockArgs1: nodes 
	^OrderedCollection with: (nodes at: 2)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForBlockArgs2: nodes 
	^(nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForByteArray1: nodes 
	^WriteStream on: ByteArray new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForByteArray2: nodes 
	^(nodes at: 1)
		nextPut: (nodes at: 2) value;
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForCascade1: nodes 
	| messages |
	(nodes at: 2) isEmpty ifTrue: [^nodes at: 1].
	messages := OrderedCollection new: (nodes at: 2) size + 1.
	messages add: (nodes at: 1).
	(nodes at: 2) do: 
			[:each | 
			messages add: (RBMessageNode 
						receiver: (nodes at: 1) receiver
						selector: each first contents asSymbol
						arguments: each last)].
	^RBCascadeNode messages: messages! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForCascadeList1: nodes 
	^OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForCascadeList2: nodes 
	^(nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForExpression1: nodes 
	^RBAssignmentNode variable: (nodes at: 1) value: (nodes at: 3)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForKeywordMessage1: nodes 
	| stream |
	stream := WriteStream on: (String new: 30).
	stream nextPutAll: (nodes at: 1) value.
	^Array with: stream with: (OrderedCollection with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForKeywordMessage2: nodes 
	(nodes at: 1) first nextPutAll: (nodes at: 2) value.
	(nodes at: 1) last add: (nodes at: 3).
	^nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForKeywordMethodName1: nodes 
	| stream |
	stream := WriteStream on: (String new: 30).
	stream nextPutAll: (nodes at: 1) value.
	^Array with: stream with: (OrderedCollection with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForKeywordMethodName2: nodes 
	(nodes at: 1) first nextPutAll: (nodes at: 2) value.
	(nodes at: 1) last add: (nodes at: 3).
	^nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral10: nodes 
	^(nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral11: nodes 
	^(nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral12: nodes 
	^(nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral13: nodes 
	^(nodes at: 3) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral14: nodes 
	^(nodes at: 3) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral15: nodes 
	^(nodes at: 3) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral16: nodes 
	^(nodes at: 3) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral1: nodes 
	^true! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral2: nodes 
	^false! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral3: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral4: nodes 
	^(nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral5: nodes 
	^(nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral6: nodes 
	^(nodes at: 1) value at: 2! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral7: nodes 
	^((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1) 
		copyReplaceAll: ''''''
		with: ''''! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral8: nodes 
	^(((nodes at: 2) value copyFrom: 2 to: (nodes at: 2) value size - 1) 
		copyReplaceAll: ''''''
		with: '''') asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForLiteral9: nodes 
	^(nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForMethod1: nodes 
	^(RBMethodNode 
		selector: (nodes at: 1) value asSymbol
		arguments: #()
		body: (nodes at: 2) last)
		tags: (nodes at: 2) first;
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForMethod2: nodes 
	^(RBMethodNode 
		selector: (nodes at: 1) first
		arguments: (nodes at: 1) last
		body: (nodes at: 2) last)
		tags: (nodes at: 2) first;
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForMethod3: nodes 
	^(RBMethodNode 
		selector: (nodes at: 1) first contents asSymbol
		arguments: (nodes at: 1) last
		body: (nodes at: 2) last)
		tags: (nodes at: 2) first;
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForMethodSequenceNode1: nodes 
	^Array with: ((nodes at: 1)
				addAll: (nodes at: 5);
				yourself)
		with: (RBSequenceNode temporaries: (nodes at: 3) statements: (nodes at: 6))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForMethodSequenceNode2: nodes 
	^Array with: ((nodes at: 1)
				addAll: (nodes at: 3);
				yourself)
		with: (RBSequenceNode temporaries: #() statements: (nodes at: 4))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForMethodSequenceNode3: nodes 
	^Array with: (nodes at: 1)
		with: (RBSequenceNode temporaries: #() statements: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForOptionalXXXXX1: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForOptionalXXXXX2: nodes 
	^nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimary2: nodes 
	^RBLiteralNode value: (nodes at: 1)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend10: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend11: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend2: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend3: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend4: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend5: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend6: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend7: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend8: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitiveMessageSend9: nodes 
	^nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitives1: nodes 
	^OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForPrimitives2: nodes 
	^(nodes at: 1)
		add: ((nodes at: 2) startPosition to: (nodes at: 4) startPosition);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForSequenceNode1: nodes 
	^RBSequenceNode temporaries: (nodes at: 1) statements: (nodes at: 2)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForStatementList2: nodes 
	^(nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForStatements1: nodes 
	^OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForStatements3: nodes 
	^(nodes at: 1)
		add: (RBReturnNode value: (nodes at: 4));
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForStatements4: nodes 
	^OrderedCollection with: (RBReturnNode value: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForTemporaries1: nodes 
	^#()! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForTemporaries2: nodes 
	^#()! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForTemporaries3: nodes 
	^nodes at: 2! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForTemporaryVariables1: nodes 
	^OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForTemporaryVariables2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForUnaryMessage1: nodes 
	^Array with: (ReadStream on: (nodes at: 1) value) with: #()! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForVariable1: nodes 
	^RBVariableNode named: (nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'jmb 1/23/2003 16:14'!
reduceActionForVariable2: nodes 
	^RBVariableNode named: (nodes at: 1) value! !

!StParser methodsFor: 'generated-tables' stamp: 'jmb 1/23/2003 16:14'!
reduceTable
	^#(
#(33 0 #reduceFor:)
#(33 2 #reduceActionForPrimitiveMessageSend2:)
#(33 2 #reduceActionForPrimitiveMessageSend3:)
#(33 2 #reduceActionForPrimitiveMessageSend4:)
#(33 2 #reduceActionForPrimitiveMessageSend5:)
#(33 2 #reduceActionForPrimitiveMessageSend6:)
#(33 2 #reduceActionForPrimitiveMessageSend7:)
#(33 2 #reduceActionForPrimitiveMessageSend8:)
#(33 2 #reduceActionForPrimitiveMessageSend9:)
#(33 2 #reduceActionForPrimitiveMessageSend10:)
#(33 2 #reduceActionForPrimitiveMessageSend11:)
#(34 2 #reduceActionForBinaryMethodName1:)
#(35 0 #reduceActionForTemporaryVariables1:)
#(35 2 #reduceActionForTemporaryVariables2:)
#(36 0 #reduceActionForStatements1:)
#(36 2 #liftFirstValue:)
#(36 5 #reduceActionForStatements3:)
#(36 3 #reduceActionForStatements4:)
#(37 0 #reduceActionForTemporaries1:)
#(37 1 #reduceActionForTemporaries2:)
#(37 3 #reduceActionForTemporaries3:)
#(38 1 #reduceFor:)
#(38 3 #reduceActionForStatementList2:)
#(39 0 #reduceActionForOptionalXXXXX1:)
#(39 1 #reduceActionForOptionalXXXXX2:)
#(40 3 #reduceActionForExpression1:)
#(40 1 #liftFirstValue:)
#(41 2 #reduceActionForBlockArgs1:)
#(41 3 #reduceActionForBlockArgs2:)
#(42 5 #reduceActionForBlock1:)
#(42 3 #reduceActionForBlock2:)
#(42 3 #reduceActionForBlock3:)
#(42 7 #reduceActionForBlock4:)
#(43 2 #reduceActionForCascade1:)
#(43 1 #liftFirstValue:)
#(44 1 #liftFirstValue:)
#(44 1 #liftFirstValue:)
#(44 1 #liftFirstValue:)
#(45 0 #reduceActionForCascadeList1:)
#(45 3 #reduceActionForCascadeList2:)
#(46 3 #liftSecondValue:)
#(46 1 #reduceActionForPrimary2:)
#(46 1 #liftFirstValue:)
#(46 1 #liftFirstValue:)
#(47 2 #reduceActionForKeywordMethodName1:)
#(47 3 #reduceActionForKeywordMethodName2:)
#(48 2 #createMessageNodeFrom:)
#(48 2 #createMessageNodeFrom:)
#(48 2 #createMessageNodeFrom:)
#(49 2 #createMessageNodeFrom:)
#(49 2 #createMessageNodeFrom:)
#(50 1 #liftFirstValue:)
#(50 1 #liftFirstValue:)
#(50 1 #liftFirstValue:)
#(51 1 #reduceActionForUnaryMessage1:)
#(52 2 #reduceActionForBinaryMessage1:)
#(53 2 #reduceActionForKeywordMessage1:)
#(53 3 #reduceActionForKeywordMessage2:)
#(54 1 #liftFirstValue:)
#(54 1 #liftFirstValue:)
#(54 1 #liftFirstValue:)
#(55 1 #liftFirstValue:)
#(55 1 #liftFirstValue:)
#(56 1 #reduceActionForVariable1:)
#(56 1 #reduceActionForVariable2:)
#(57 1 #reduceFor:)
#(58 6 #reduceActionForMethodSequenceNode1:)
#(58 4 #reduceActionForMethodSequenceNode2:)
#(58 2 #reduceActionForMethodSequenceNode3:)
#(59 2 #reduceActionForSequenceNode1:)
#(60 0 #reduceActionForByteArray1:)
#(60 2 #reduceActionForByteArray2:)
#(61 0 #reduceActionForArray1:)
#(61 2 #reduceActionForArray2:)
#(61 3 #reduceActionForArray3:)
#(62 1 #liftFirstValue:)
#(62 1 #reduceActionForArrayLiteral2:)
#(62 1 #reduceActionForArrayLiteral3:)
#(62 1 #reduceActionForArrayLiteral4:)
#(62 1 #reduceActionForArrayLiteral5:)
#(62 3 #reduceActionForArrayLiteral6:)
#(62 3 #reduceActionForArrayLiteral7:)
#(62 3 #reduceActionForArrayLiteral8:)
#(62 3 #reduceActionForArrayLiteral9:)
#(62 1 #reduceActionForArrayLiteral10:)
#(62 1 #reduceActionForArrayLiteral11:)
#(63 0 #reduceActionForPrimitives1:)
#(63 4 #reduceActionForPrimitives2:)
#(66 2 #createMessageNodeFrom:)
#(66 2 #createMessageNodeFrom:)
#(66 2 #createMessageNodeFrom:)
#(67 2 #reduceActionForMethod1:)
#(67 2 #reduceActionForMethod2:)
#(67 2 #reduceActionForMethod3:)
#(68 1 #reduceActionForLiteral1:)
#(68 1 #reduceActionForLiteral2:)
#(68 1 #reduceActionForLiteral3:)
#(68 1 #reduceActionForLiteral4:)
#(68 1 #reduceActionForLiteral5:)
#(68 1 #reduceActionForLiteral6:)
#(68 1 #reduceActionForLiteral7:)
#(68 2 #reduceActionForLiteral8:)
#(68 2 #reduceActionForLiteral9:)
#(68 2 #reduceActionForLiteral10:)
#(68 2 #reduceActionForLiteral11:)
#(68 2 #reduceActionForLiteral12:)
#(68 4 #reduceActionForLiteral13:)
#(68 4 #reduceActionForLiteral14:)
#(68 4 #reduceActionForLiteral15:)
#(68 4 #reduceActionForLiteral16:)
)! !

!StParser methodsFor: 'generated-tables' stamp: 'jmb 1/23/2003 16:14'!
transitionTable
	^#(
#(3 13 20 17 24 21 26 25 34 29 47 33 67)
#(3 78 1 37 9 78 10 78 11 78 12 78 14 41 15 78 16 78 17 78 20 78 21 78 22 78 23 78 29 78 30 45 37 49 59 78 64)
#(3 350 1 350 6 350 9 350 10 350 11 350 12 350 14 350 15 350 16 350 17 350 20 350 21 350 22 350 23 350 29 350 30 53 58 57 63 350 64)
#(3 61 20 65 29 69 56)
#(3 61 20 65 29 73 56)
#(3 350 1 350 6 350 9 350 10 350 11 350 12 350 14 350 15 350 16 350 17 350 20 350 21 350 22 350 23 350 29 350 30 77 58 57 63 350 64)
#(3 350 1 350 6 350 9 350 10 350 11 350 12 350 14 350 15 350 16 350 17 350 20 350 21 350 22 350 23 81 24 350 29 350 30 85 58 57 63 350 64)
#(2 0 64)
#(3 54 9 54 20 54 29 89 35)
#(2 82 1 10 11 12 14 16 17 19 20 21 22 23 29 30 64)
#(3 93 1 97 10 101 11 105 12 109 14 113 16 117 17 62 19 61 20 121 21 125 22 129 23 65 29 133 30 137 36 141 38 145 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 62 64 177 66 181 68)
#(2 0 64)
#(2 370 64)
#(3 93 1 185 6 189 9 97 10 101 11 105 12 109 14 193 15 113 16 117 17 61 20 121 21 125 22 129 23 65 29 133 30 197 36 141 38 145 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 62 64 177 66 181 68)
#(2 258 1 2 4 5 6 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 29 30 64)
#(2 262 1 2 4 5 6 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 29 30 64)
#(2 182 1 6 9 10 11 12 14 15 16 17 20 21 22 23 24 29 30 64)
#(2 50 1 6 9 10 11 12 14 15 16 17 20 21 22 23 29 30 64)
#(2 374 64)
#(3 61 20 65 29 201 56)
#(2 378 64)
#(3 205 9 61 20 65 29 209 56)
#(3 213 3 217 10 221 17 225 20 229 23 233 24 237 25 241 26)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 245 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 177 66 181 68)
#(2 382 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 386 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 390 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 249 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 177 66 181 68)
#(3 78 1 37 9 78 10 78 11 78 12 78 14 41 15 78 16 78 17 253 18 78 19 78 20 78 21 78 22 78 23 78 29 78 30 45 37 257 41 261 59)
#(2 394 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 398 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 406 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 402 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 282 19 64)
#(3 265 5 98 19 269 39 98 64)
#(2 90 5 19 64)
#(2 178 2 4 5 19 20 24 26 64)
#(2 110 4 5 19 64)
#(3 158 2 158 4 158 5 158 19 273 45 158 64)
#(3 142 4 142 5 142 19 277 20 281 24 285 26 289 51 293 52 297 53 142 64)
#(3 150 2 150 4 150 5 150 19 281 24 285 26 301 52 305 53 150 64)
#(3 154 2 154 4 154 5 154 19 277 20 281 24 285 26 309 51 313 52 317 53 154 64)
#(3 174 4 174 5 321 13 174 19 174 20 174 24 174 26 174 64)
#(2 146 2 4 5 19 64)
#(2 170 2 4 5 19 20 24 26 64)
#(3 6 1 6 2 6 3 6 4 6 5 6 7 6 8 6 10 6 11 6 12 6 14 6 20 6 21 6 22 6 23 6 24 6 26 6 30 325 33)
#(3 54 9 54 20 54 29 329 35)
#(3 350 1 350 6 350 10 350 11 350 12 350 14 350 16 350 17 350 20 350 21 350 22 350 23 350 29 350 30 333 63 350 64)
#(2 278 64)
#(2 186 1 6 9 10 11 12 14 15 16 17 20 21 22 23 24 29 30 64)
#(2 86 1 10 11 12 14 16 17 19 20 21 22 23 29 30 64)
#(2 58 9 20 29)
#(3 337 20 341 29)
#(3 294 1 294 3 294 4 294 10 294 11 294 12 294 14 294 17 294 20 294 21 294 22 294 23 294 24 294 25 294 26 294 29 294 30 294 32 345 61)
#(3 286 19 286 21 349 60)
#(2 414 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 410 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 422 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 426 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 418 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 353 4)
#(3 357 5 98 19 361 39 98 64)
#(3 61 20 65 29 365 56)
#(3 369 9 373 15 377 18 381 19)
#(2 385 19)
#(3 93 1 97 10 101 11 105 12 109 14 389 16 117 17 102 19 61 20 121 21 125 22 129 23 65 29 133 30 393 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 102 64 177 66 181 68)
#(2 66 19 64)
#(3 397 2 138 4 138 5 138 19 138 64)
#(2 222 2 4 5 19 20 24 26 64)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 149 42 401 46 405 48 409 49 413 54 417 56 181 68)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 149 42 421 46 425 49 429 55 417 56 181 68)
#(2 206 2 4 5 19 20 24 26 64)
#(2 198 2 4 5 19 24 26 64)
#(3 366 2 366 4 366 5 366 19 433 24 366 64)
#(2 190 2 4 5 19 24 26 64)
#(3 358 2 358 4 358 5 358 19 433 24 358 64)
#(2 202 2 4 5 19 20 24 26 64)
#(2 194 2 4 5 19 24 26 64)
#(3 362 2 362 4 362 5 362 19 433 24 362 64)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 437 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 177 66 181 68)
#(3 93 1 441 2 445 3 449 4 453 5 457 7 461 8 465 10 101 11 105 12 109 14 469 20 121 21 125 22 129 23 473 24 477 26 133 30 481 68)
#(3 485 9 61 20 65 29 209 56)
#(3 93 1 185 6 97 10 101 11 105 12 109 14 113 16 117 17 61 20 121 21 125 22 129 23 65 29 133 30 489 36 141 38 145 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 62 64 177 66 181 68)
#(2 493 8)
#(2 497 8)
#(3 93 1 501 3 505 4 509 10 101 11 105 12 109 14 513 17 517 20 121 21 125 22 129 23 521 24 525 25 529 26 533 29 133 30 537 32 541 62 545 68)
#(3 549 19 553 21)
#(2 166 2 4 5 19 20 24 26 64)
#(2 102 19 64)
#(2 74 19 64)
#(2 114 9 15 18 19)
#(3 78 1 37 9 78 10 78 11 78 12 78 14 41 15 78 16 78 17 78 19 78 20 78 21 78 22 78 23 78 29 78 30 45 37 557 59)
#(3 54 9 54 20 54 29 561 35)
#(3 61 20 65 29 565 56)
#(2 130 2 4 5 19 20 24 26 64)
#(2 126 2 4 5 19 20 24 26 64)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 569 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 177 66 181 68)
#(2 94 5 19 64)
#(3 277 20 281 24 285 26 573 50 577 51 581 52 585 53)
#(3 246 2 246 4 246 5 246 19 277 20 246 24 285 26 289 51 293 52 246 64)
#(3 238 2 238 4 238 5 238 19 238 24 285 26 301 52 238 64)
#(3 242 2 242 4 242 5 242 19 277 20 242 24 285 26 309 51 313 52 242 64)
#(2 230 2 4 5 19 24 64)
#(2 174 2 4 5 19 20 24 26 64)
#(3 254 2 254 4 254 5 254 19 277 20 254 24 254 26 289 51 254 64)
#(3 250 2 250 4 250 5 250 19 277 20 250 24 250 26 309 51 250 64)
#(2 226 2 4 5 19 24 26 64)
#(3 93 1 97 10 101 11 105 12 109 14 117 17 61 20 121 21 125 22 129 23 65 29 133 30 149 42 401 46 405 48 409 49 589 54 417 56 181 68)
#(2 106 4 5 19 64)
#(2 34 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 26 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 22 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 38 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 354 1 6 9 10 11 12 14 15 16 17 20 21 22 23 29 30 64)
#(2 30 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 18 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 42 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 10 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 46 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(2 14 1 2 3 4 5 7 8 10 11 12 14 20 21 22 23 24 26 30)
#(3 350 1 350 6 350 10 350 11 350 12 350 14 350 16 350 17 350 20 350 21 350 22 350 23 350 29 350 30 593 63 350 64)
#(2 274 64)
#(2 438 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 442 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(3 597 20 601 29)
#(2 434 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(3 294 1 294 3 294 4 294 10 294 11 294 12 294 14 294 17 294 20 294 21 294 22 294 23 294 24 294 25 294 26 294 29 294 30 294 32 605 61)
#(3 286 19 286 21 609 60)
#(3 310 1 310 3 310 4 310 10 310 11 310 12 613 13 310 14 310 17 310 20 310 21 310 22 310 23 310 24 310 25 310 26 310 29 310 30 310 32)
#(2 318 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 322 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 314 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 346 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 342 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 298 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 306 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 430 1 2 3 4 5 7 8 10 11 12 14 17 19 20 21 22 23 24 25 26 29 30 32 64)
#(2 290 19 21)
#(2 617 19)
#(3 621 9 61 20 65 29 209 56)
#(2 118 9 15 18 19)
#(3 357 5 98 19 625 39 98 64)
#(2 162 2 4 5 19 64)
#(2 210 2 4 5 19 64)
#(2 214 2 4 5 19 64)
#(3 218 2 218 4 218 5 218 19 433 24 218 64)
#(2 234 2 4 5 19 24 64)
#(3 93 1 185 6 97 10 101 11 105 12 109 14 113 16 117 17 61 20 121 21 125 22 129 23 65 29 133 30 629 36 141 38 145 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 62 64 177 66 181 68)
#(2 633 8)
#(2 637 8)
#(3 93 1 501 3 641 4 509 10 101 11 105 12 109 14 513 17 517 20 121 21 125 22 129 23 521 24 525 25 529 26 533 29 133 30 537 32 541 62 545 68)
#(3 645 19 553 21)
#(2 302 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 122 2 4 5 19 20 24 26 64)
#(3 93 1 97 10 101 11 105 12 109 14 113 16 117 17 62 19 61 20 121 21 125 22 129 23 65 29 133 30 649 36 141 38 145 40 149 42 153 43 157 44 161 46 165 48 169 49 173 56 177 66 181 68)
#(2 70 19 64)
#(2 270 64)
#(2 326 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 330 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 334 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 338 1 3 4 10 11 12 14 17 20 21 22 23 24 25 26 29 30 32)
#(2 653 19)
#(2 134 2 4 5 19 20 24 26 64)
)! !

SmaCCParser subclass: #TestParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

SmaCCScanner subclass: #CScanner
	instanceVariableNames: 'typeNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Parsers'!

!CScanner class methodsFor: 'generated-initialization' stamp: 'jmb 1/23/2003 16:18'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(#IDENTIFIER 'auto' 70) #(#IDENTIFIER 'break' 48) #(#IDENTIFIER 'case' 38) #(#IDENTIFIER 'char' 71) #(#IDENTIFIER 'const' 40) #(#IDENTIFIER 'continue' 47) #(#IDENTIFIER 'default' 39) #(#IDENTIFIER 'do' 54) #(#IDENTIFIER 'double' 61) #(#IDENTIFIER 'else' 46) #(#IDENTIFIER 'enum' 45) #(#IDENTIFIER 'extern' 58) #(#IDENTIFIER 'float' 67) #(#IDENTIFIER 'for' 49) #(#IDENTIFIER 'goto' 50) #(#IDENTIFIER 'if' 42) #(#IDENTIFIER 'int' 69) #(#IDENTIFIER 'long' 66) #(#IDENTIFIER 'register' 72) #(#IDENTIFIER 'return' 19) #(#IDENTIFIER 'short' 68) #(#IDENTIFIER 'signed' 51) #(#IDENTIFIER 'sizeof' 24) #(#IDENTIFIER 'static' 65) #(#IDENTIFIER 'struct' 43) #(#IDENTIFIER 'switch' 52) #(#IDENTIFIER 'typedef' 57) #(#IDENTIFIER 'union' 44) #(#IDENTIFIER 'unsigned' 55) #(#IDENTIFIER 'void' 73) #(#IDENTIFIER 'volatile' 41) #(#IDENTIFIER 'while' 53)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!CScanner class methodsFor: 'testing' stamp: ''!
needsLineNumbers
	^true! !

!CScanner class methodsFor: 'generated-comments' stamp: 'jmb 1/23/2003 16:18'!
scannerDefinitionComment

	"<H>: [a-fA-F0-9]	;
<IS>: [uUlL]	;
<D>: [0-9]	;
<E>: [Ee][\+\-]?<D>+	;
<FS>: [fFlL]	;
<ELLIPSIS> : \.\.\. ;
<comment>: \/ \*	;
<LETTER> : [a-zA-Z_] ;
<DIGIT> : [0-9] ;
<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
<CONSTANT>: (0[xX]<H>+<IS>?) | 
				(<D>+<IS>?) | 
				(<D>+<E><FS>?) | 
				<D>*\.<D>+<E>?<FS>? | 
				(L? \' ( (\\ .) | ([^\\\""]) )+ \')	;

<STRINGLITERAL>: L? \"" ( (\\ .) | ([^\\\""]) )* \""	;

<LEFTBLOCK>: \[ | (\< \:)	;
<RIGHTBLOCK>: \] | (\: \>)	;
<LEFTBRACE>: \{ | (\< \%)	;
<RIGHTBRACE>: \} | (\% \>)	;

<whitespace>: \s+	;"! !

!CScanner methodsFor: 'scanning' stamp: ''!
addTypeName: aString 
	typeNames add: aString! !

!CScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:18'!
CONSTANTId
	^77! !

!CScanner methodsFor: 'default token handling' stamp: ''!
comment
	| char |
	
	[[(char := stream next) isNil or: [char == $*]] whileFalse.
	stream atEnd ifTrue: [self scannerError].
	stream peekFor: $/] 
			whileFalse.
	^self whitespace! !

!CScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:18'!
emptySymbolTokenId
	^147! !

!CScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:18'!
errorTokenId
	^148! !

!CScanner methodsFor: 'scanning' stamp: ''!
IDENTIFIER
	| name token |
	name := outputStream contents.
	matchActions := (typeNames includes: name) 
				ifTrue: [Array with: self TYPENAMEId]
				ifFalse: [Array with: self IDENTIFIERId].
	outputStream reset.
	token := SmaCCToken 
				value: name
				start: start
				id: matchActions.
	matchActions := nil.
	returnMatchBlock value: token! !

!CScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:18'!
IDENTIFIERId
	^76! !

!CScanner methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	typeNames := Set new! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan1
	self step.
	currentCharacter isDigit ifTrue: [^self scan2].
	(currentCharacter == $+ or: [currentCharacter == $-]) 
		ifTrue: 
			[self step.
			currentCharacter isDigit ifTrue: [^self scan2].
			^self reportLastMatch].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan2
	
	[self recordMatch: #(77).
	self step.
	currentCharacter isDigit] whileTrue.
	(currentCharacter == $F or: 
			[currentCharacter == $L 
				or: [currentCharacter == $f or: [currentCharacter == $l]]]) 
		ifTrue: [^self recordAndReportMatch: #(77)].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan3
	self step.
	currentCharacter isDigit ifTrue: [^self scan4].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan4
	
	[self recordMatch: #(77).
	self step.
	currentCharacter isDigit] whileTrue.
	(currentCharacter == $F or: 
			[currentCharacter == $L 
				or: [currentCharacter == $f or: [currentCharacter == $l]]]) 
		ifTrue: [^self recordAndReportMatch: #(77)].
	(currentCharacter == $E or: [currentCharacter == $e]) 
		ifTrue: [^self scan1].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan5
	self step.
	(currentCharacter <= $!! 
		or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]) 
			ifTrue: [^self scan7].
	currentCharacter == $\ ifTrue: [^self scan6].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan6
	self step.
	^self scan7! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan7
	
	[self step.
	currentCharacter <= $!! or: 
			[(currentCharacter between: $# and: $&) 
				or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]]] 
			whileTrue.
	currentCharacter == $' 
		ifTrue: 
			[
			[self recordMatch: #(77).
			self step.
			(currentCharacter <= $!! or: 
					[(currentCharacter between: $# and: $&) 
						or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]]) 
				ifTrue: [^self scan7].
			currentCharacter == $'] 
					whileTrue.
			currentCharacter == $\ ifTrue: [^self scan6].
			^self reportLastMatch].
	currentCharacter == $\ ifTrue: [^self scan6].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan8
	
	[
	[self step.
	currentCharacter <= $!! 
		or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]] 
			whileTrue.
	currentCharacter == $" ifTrue: [^self recordAndReportMatch: #(78)].
	currentCharacter == $\] 
			whileTrue: [self step].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scan9
	
	[self recordMatch: #(77).
	self step.
	currentCharacter isDigit] whileTrue.
	(currentCharacter == $L or: 
			[currentCharacter == $U 
				or: [currentCharacter == $l or: [currentCharacter == $u]]]) 
		ifTrue: [^self recordAndReportMatch: #(77)].
	(currentCharacter == $E or: [currentCharacter == $e]) 
		ifTrue: [^self scan1].
	currentCharacter == $. ifTrue: [^self scan3].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:18'!
scanForToken
	self step.
	(currentCharacter isLowercase or: 
			[(currentCharacter between: $A and: $K) 
				or: [(currentCharacter between: $M and: $Z) or: [currentCharacter == $_]]]) 
		ifTrue: 
			[
			[self recordMatch: #IDENTIFIER.
			self step.
			currentCharacter isAlphaNumeric or: [currentCharacter == $_]] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter between: $1 and: $9) ifTrue: [^self scan9].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $!! 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(4)].
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan8].
	currentCharacter == $% 
		ifTrue: 
			[self recordMatch: #(30).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(10)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(82)].
			^self reportLastMatch].
	currentCharacter == $& 
		ifTrue: 
			[self recordMatch: #(28).
			self step.
			currentCharacter == $& ifTrue: [^self recordAndReportMatch: #(5)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(63)].
			^self reportLastMatch].
	currentCharacter == $' ifTrue: [^self scan5].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(25)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(26)].
	currentCharacter == $* 
		ifTrue: 
			[self recordMatch: #(34).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(12)].
			^self reportLastMatch].
	currentCharacter == $+ 
		ifTrue: 
			[self recordMatch: #(35).
			self step.
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(23)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(11)].
			^self reportLastMatch].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(21)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(36).
			self step.
			currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(20)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(37)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(22)].
			^self reportLastMatch].
	currentCharacter == $. 
		ifTrue: 
			[self recordMatch: #(27).
			self step.
			currentCharacter isDigit ifTrue: [^self scan4].
			currentCharacter == $. 
				ifTrue: 
					[self step.
					currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(74)].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $/ 
		ifTrue: 
			[self recordMatch: #(29).
			self step.
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #comment].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(13)].
			^self reportLastMatch].
	currentCharacter == $0 
		ifTrue: 
			[self recordMatch: #(77).
			self step.
			currentCharacter isDigit ifTrue: [^self scan9].
			(currentCharacter == $L or: 
					[currentCharacter == $U 
						or: [currentCharacter == $l or: [currentCharacter == $u]]]) 
				ifTrue: [^self recordAndReportMatch: #(77)].
			(currentCharacter == $E or: [currentCharacter == $e]) 
				ifTrue: [^self scan1].
			(currentCharacter == $X or: [currentCharacter == $x]) 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: 
							[(currentCharacter between: $A and: $F) 
								or: [currentCharacter between: $a and: $f]]) 
						ifTrue: 
							[
							[self recordMatch: #(77).
							self step.
							currentCharacter isDigit or: 
									[(currentCharacter between: $A and: $F) 
										or: [currentCharacter between: $a and: $f]]] 
									whileTrue.
							(currentCharacter == $L or: 
									[currentCharacter == $U 
										or: [currentCharacter == $l or: [currentCharacter == $u]]]) 
								ifTrue: [^self recordAndReportMatch: #(77)].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $. ifTrue: [^self scan3].
			^self reportLastMatch].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(16).
			self step.
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(80)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(60)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(18).
			self step.
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(81)].
			currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(79)].
			currentCharacter == $< 
				ifTrue: 
					[self recordMatch: #(33).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(56)].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(7)].
			^self reportLastMatch].
	currentCharacter == $= 
		ifTrue: 
			[self recordMatch: #(17).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(3)].
			^self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(6).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(8)].
			currentCharacter == $> 
				ifTrue: 
					[self recordMatch: #(14).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(62)].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(15)].
	currentCharacter == $L 
		ifTrue: 
			[self recordMatch: #IDENTIFIER.
			self step.
			(currentCharacter isAlphaNumeric or: [currentCharacter == $_]) 
				ifTrue: 
					[
					[self recordMatch: #IDENTIFIER.
					self step.
					currentCharacter isAlphaNumeric or: [currentCharacter == $_]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $" ifTrue: [^self scan8].
			currentCharacter == $' ifTrue: [^self scan5].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(79)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(80)].
	currentCharacter == $^ 
		ifTrue: 
			[self recordMatch: #(1).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(64)].
			^self reportLastMatch].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(81)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(2).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(59)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(9)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(82)].
	currentCharacter == $~ ifTrue: [^self recordAndReportMatch: #(31)].
	^self reportLastMatch! !

!CScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:18'!
TYPENAMEId
	^149! !

SmaCCScanner subclass: #JavaScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Parsers'!

!JavaScanner class methodsFor: 'generated-initialization' stamp: 'jmb 1/23/2003 16:21'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(99 'abstract' 38) #(99 'boolean' 30) #(99 'break' 81) #(99 'byte' 31) #(99 'case' 41) #(99 'catch' 79) #(99 'char' 26) #(99 'class' 8) #(99 'continue' 80) #(99 'default' 47) #(99 'do' 77) #(99 'double' 25) #(99 'else' 35) #(99 'extends' 11) #(99 'false' 95) #(99 'final' 36) #(99 'finally' 75) #(99 'float' 24) #(99 'for' 78) #(99 'if' 13) #(99 'implements' 10) #(99 'import' 44) #(99 'instanceof' 65) #(99 'int' 33) #(99 'interface' 16) #(99 'long' 27) #(99 'native' 37) #(99 'new' 76) #(99 'null' 98) #(99 'package' 29) #(99 'private' 45) #(99 'protected' 46) #(99 'public' 43) #(99 'return' 74) #(99 'short' 34) #(99 'static' 39) #(99 'strictfp' 7) #(99 'super' 22) #(99 'switch' 17) #(99 'synchronized' 40) #(99 'this' 23) #(99 'throw' 73) #(99 'throws' 20) #(99 'transient' 18) #(99 'true' 95) #(99 'try' 71) #(99 'void' 9) #(99 'volatile' 12) #(99 'while' 58)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!JavaScanner class methodsFor: 'generated-comments' stamp: 'jmb 1/23/2003 16:21'!
scannerDefinitionComment

	"<DECIMALINTEGER>: 0 | [1-9] [0-9]*	;
<HEXINTEGER>: 0[xX][0-9a-fA-F]+	;
<OCTALINTEGER>: 0[0-7]+	;

<EXPONENT>: [eE] [\-\+]? [0-9]+ 	;
<FLOATTYPE>: [fFdD]	;

<ESCAPESEQUENCE>: \\ ([btnfr\""\'\\] | ([0-3] [0-7]{0,2} | [4-7][0-7]?))	;

<INTEGERLITERAL>: (<DECIMALINTEGER> | <HEXINTEGER> | <OCTALINTEGER>) [lL]?	;
<FLOATINGPOINTLITERAL>: [0-9]+ \. [0-9]* <EXPONENT>? <FLOATTYPE>? | \. [0-9]+ <EXPONENT>? <FLOATTYPE>? | [0-9]+ <EXPONENT> <FLOATTYPE>? | [0-9]+ <FLOATTYPE>	;
<BOOLEANLITERAL>: true | false	;
<CHARACTERLITERAL>: \' ([^\\\'] | <ESCAPESEQUENCE> ) \'	;
<STRINGLITERAL>: \"" ([^\\\""] | <ESCAPESEQUENCE> )* \""	;
<NULLLITERAL>: null	;

<IDENTIFIER>: [a-zA-Z_] \w*	;

<eol>: \r | \n | \r\n	;
<whitespace>: \s+	;
<comment>: \/\/ [^\r\n]* <eol>	;
<multipleLineComment>: \/ \* 	;"! !

!JavaScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:21'!
emptySymbolTokenId
	^255! !

!JavaScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:21'!
errorTokenId
	^256! !

!JavaScanner methodsFor: 'scanning' stamp: ''!
multipleLineComment
	| char |
	
	[[(char := stream next) isNil or: [char == $*]] whileFalse.
	stream atEnd ifTrue: [self scannerError].
	stream peekFor: $/] 
			whileFalse.
	^self whitespace! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan1
	
	[self recordMatch: #(94).
	self step.
	currentCharacter isDigit] whileTrue.
	(currentCharacter == $D or: 
			[currentCharacter == $F 
				or: [currentCharacter == $d or: [currentCharacter == $f]]]) 
		ifTrue: [^self recordAndReportMatch: #(94)].
	(currentCharacter == $E or: [currentCharacter == $e]) 
		ifTrue: [^self scan2].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan2
	self step.
	currentCharacter isDigit ifTrue: [^self scan3].
	(currentCharacter == $+ or: [currentCharacter == $-]) 
		ifTrue: 
			[self step.
			currentCharacter isDigit ifTrue: [^self scan3].
			^self reportLastMatch].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan3
	
	[self recordMatch: #(94).
	self step.
	currentCharacter isDigit] whileTrue.
	(currentCharacter == $D or: 
			[currentCharacter == $F 
				or: [currentCharacter == $d or: [currentCharacter == $f]]]) 
		ifTrue: [^self recordAndReportMatch: #(94)].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan4
	self step.
	currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(96)].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan5
	self step.
	(currentCharacter between: $0 and: $7) ifTrue: [^self scan4].
	currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(96)].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan6
	
	[self step.
	currentCharacter <= $!! 
		or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]] 
			whileTrue.
	currentCharacter == $" ifTrue: [^self recordAndReportMatch: #(97)].
	currentCharacter == $\ 
		ifTrue: 
			[self step.
			(currentCharacter == $" or: 
					[currentCharacter == $' or: 
							[(currentCharacter between: $0 and: $7) or: 
									[currentCharacter == $\ or: 
											[currentCharacter == $b or: 
													[currentCharacter == $f or: 
															[currentCharacter == $n 
																or: [currentCharacter == $r or: [currentCharacter == $t]]]]]]]]) 
				ifTrue: [^self scan6].
			^self reportLastMatch].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scan7
	
	[self step.
	currentCharacter isDigit] whileTrue.
	(currentCharacter == $D or: 
			[currentCharacter == $F 
				or: [currentCharacter == $d or: [currentCharacter == $f]]]) 
		ifTrue: [^self recordAndReportMatch: #(94)].
	(currentCharacter == $E or: [currentCharacter == $e]) 
		ifTrue: [^self scan2].
	currentCharacter == $. ifTrue: [^self scan1].
	^self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:21'!
scanForToken
	self step.
	(currentCharacter isLetter or: [currentCharacter == $_]) 
		ifTrue: 
			[
			[self recordMatch: #(99).
			self step.
			currentCharacter isAlphaNumeric or: [currentCharacter == $_]] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter between: $1 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(93).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			(currentCharacter == $D or: 
					[currentCharacter == $F 
						or: [currentCharacter == $d or: [currentCharacter == $f]]]) 
				ifTrue: [^self recordAndReportMatch: #(94)].
			(currentCharacter == $E or: [currentCharacter == $e]) 
				ifTrue: [^self scan2].
			(currentCharacter == $L or: [currentCharacter == $l]) 
				ifTrue: [^self recordAndReportMatch: #(93)].
			currentCharacter == $. ifTrue: [^self scan1].
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $!! 
		ifTrue: 
			[self recordMatch: #(89).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(51)].
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan6].
	currentCharacter == $% 
		ifTrue: 
			[self recordMatch: #(85).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(67)].
			^self reportLastMatch].
	currentCharacter == $& 
		ifTrue: 
			[self recordMatch: #(50).
			self step.
			currentCharacter == $& ifTrue: [^self recordAndReportMatch: #(52)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(61)].
			^self reportLastMatch].
	currentCharacter == $' 
		ifTrue: 
			[self step.
			(currentCharacter <= $& 
				or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]) 
					ifTrue: [^self scan4].
			currentCharacter == $\ 
				ifTrue: 
					[self step.
					(currentCharacter == $" or: 
							[currentCharacter == $' or: 
									[currentCharacter == $\ or: 
											[currentCharacter == $b or: 
													[currentCharacter == $f or: 
															[currentCharacter == $n 
																or: [currentCharacter == $r or: [currentCharacter == $t]]]]]]]) 
						ifTrue: [^self scan4].
					(currentCharacter between: $0 and: $3) 
						ifTrue: 
							[self step.
							(currentCharacter between: $0 and: $7) ifTrue: [^self scan5].
							currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(96)].
							^self reportLastMatch].
					(currentCharacter between: $4 and: $7) ifTrue: [^self scan5].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(21)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(19)].
	currentCharacter == $* 
		ifTrue: 
			[self recordMatch: #(42).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(68)].
			^self reportLastMatch].
	currentCharacter == $+ 
		ifTrue: 
			[self recordMatch: #(90).
			self step.
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(82)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(70)].
			^self reportLastMatch].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(4)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(91).
			self step.
			currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(84)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(69)].
			^self reportLastMatch].
	currentCharacter == $. 
		ifTrue: 
			[self recordMatch: #(28).
			self step.
			currentCharacter isDigit ifTrue: [^self scan1].
			^self reportLastMatch].
	currentCharacter == $/ 
		ifTrue: 
			[self recordMatch: #(88).
			self step.
			currentCharacter == $* 
				ifTrue: [^self recordAndReportMatch: #multipleLineComment].
			currentCharacter == $/ 
				ifTrue: 
					[
					[self step.
					currentCharacter <= $	 
						or: [(currentCharacter between: $ and: $) or: [currentCharacter >= $]]] 
							whileTrue.
					currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #comment].
					currentCharacter == $
 
						ifTrue: 
							[self recordMatch: #comment.
							self step.
							currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #comment].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(66)].
			^self reportLastMatch].
	currentCharacter == $0 
		ifTrue: 
			[self recordMatch: #(93).
			self step.
			(currentCharacter between: $0 and: $7) 
				ifTrue: 
					[
					[self recordMatch: #(93).
					self step.
					currentCharacter between: $0 and: $7] 
							whileTrue.
					(currentCharacter == $D or: 
							[currentCharacter == $F 
								or: [currentCharacter == $d or: [currentCharacter == $f]]]) 
						ifTrue: [^self recordAndReportMatch: #(94)].
					(currentCharacter between: $8 and: $9) ifTrue: [^self scan7].
					(currentCharacter == $E or: [currentCharacter == $e]) 
						ifTrue: [^self scan2].
					(currentCharacter == $L or: [currentCharacter == $l]) 
						ifTrue: [^self recordAndReportMatch: #(93)].
					currentCharacter == $. ifTrue: [^self scan1].
					^self reportLastMatch].
			(currentCharacter == $D or: 
					[currentCharacter == $F 
						or: [currentCharacter == $d or: [currentCharacter == $f]]]) 
				ifTrue: [^self recordAndReportMatch: #(94)].
			(currentCharacter between: $8 and: $9) ifTrue: [^self scan7].
			(currentCharacter == $E or: [currentCharacter == $e]) 
				ifTrue: [^self scan2].
			(currentCharacter == $L or: [currentCharacter == $l]) 
				ifTrue: [^self recordAndReportMatch: #(93)].
			(currentCharacter == $X or: [currentCharacter == $x]) 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: 
							[(currentCharacter between: $A and: $F) 
								or: [currentCharacter between: $a and: $f]]) 
						ifTrue: 
							[
							[self recordMatch: #(93).
							self step.
							currentCharacter isDigit or: 
									[(currentCharacter between: $A and: $F) 
										or: [currentCharacter between: $a and: $f]]] 
									whileTrue.
							(currentCharacter == $L or: [currentCharacter == $l]) 
								ifTrue: [^self recordAndReportMatch: #(93)].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $. ifTrue: [^self scan1].
			^self reportLastMatch].
	currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(15)].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(32)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(72).
			self step.
			currentCharacter == $< 
				ifTrue: 
					[self recordMatch: #(83).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(63)].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(54)].
			^self reportLastMatch].
	currentCharacter == $= 
		ifTrue: 
			[self recordMatch: #(2).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(57)].
			^self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(59).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(55)].
			currentCharacter == $> 
				ifTrue: 
					[self recordMatch: #(86).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(62)].
					currentCharacter == $> 
						ifTrue: 
							[self recordMatch: #(87).
							self step.
							currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(60)].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(56)].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(5)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(6)].
	currentCharacter == $^ 
		ifTrue: 
			[self recordMatch: #(48).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(64)].
			^self reportLastMatch].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(3)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(49).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(14)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(53)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(1)].
	currentCharacter == $~ ifTrue: [^self recordAndReportMatch: #(92)].
	^self reportLastMatch! !

SmaCCScanner subclass: #SmaCCGrammarScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammarScanner commentStamp: 'jmb' prior: 0!
SmaCCGrammarScanner is the scanner for the grammar parser!

!SmaCCGrammarScanner class methodsFor: 'generated-initialization' stamp: 'jmb 1/21/2003 17:17'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(20 'error' 15)) do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!SmaCCGrammarScanner class methodsFor: 'testing' stamp: ''!
needsLineNumbers
	^true! !

!SmaCCGrammarScanner class methodsFor: 'generated-comments' stamp: 'jmb 1/21/2003 17:17'!
scannerDefinitionComment

	"<name> : [a-zA-Z_] \w* ;
<whitespace>	:	\s+ ;
<tokenname>	:	\< <name> \> ;
<symbolname>	:	<name>	 ;
<keyword>	:	(\"" [^\""]* \"") + ;
<comment>	:	\# [^\r\n]* ;
<code>:	\{ [^\}]+ \} ;
<variablename> :	\' <name> \' ;
<production> : \: (\: \=)? ;"! !

!SmaCCGrammarScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/21/2003 17:17'!
emptySymbolTokenId
	^43! !

!SmaCCGrammarScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/21/2003 17:17'!
errorTokenId
	^44! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/21/2003 17:17'!
scan1
	
	[
	[self step.
	currentCharacter ~~ $"] whileTrue.
	self recordMatch: #(21).
	self step.
	currentCharacter == $"] 
			whileTrue: [].
	^self reportLastMatch! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/21/2003 17:17'!
scan2
	self step.
	currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(12)].
	currentCharacter == $i 
		ifTrue: 
			[self step.
			currentCharacter == $d ifTrue: [^self recordAndReportMatch: #(4)].
			^self reportLastMatch].
	currentCharacter == $l 
		ifTrue: 
			[self step.
			currentCharacter == $e 
				ifTrue: 
					[self step.
					currentCharacter == $f 
						ifTrue: 
							[self step.
							currentCharacter == $t ifTrue: [^self recordAndReportMatch: #(6)].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $n 
		ifTrue: 
			[self step.
			currentCharacter == $o 
				ifTrue: 
					[self step.
					currentCharacter == $n 
						ifTrue: 
							[self step.
							currentCharacter == $a 
								ifTrue: 
									[self step.
									currentCharacter == $s 
										ifTrue: 
											[self step.
											currentCharacter == $s 
												ifTrue: 
													[self step.
													currentCharacter == $o 
														ifTrue: 
															[self step.
															currentCharacter == $c ifTrue: [^self recordAndReportMatch: #(3)].
															^self reportLastMatch].
													^self reportLastMatch].
											^self reportLastMatch].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $r 
		ifTrue: 
			[self step.
			currentCharacter == $i 
				ifTrue: 
					[self step.
					currentCharacter == $g 
						ifTrue: 
							[self step.
							currentCharacter == $h 
								ifTrue: 
									[self step.
									currentCharacter == $t ifTrue: [^self recordAndReportMatch: #(8)].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $s 
		ifTrue: 
			[self step.
			currentCharacter == $t 
				ifTrue: 
					[self step.
					currentCharacter == $a 
						ifTrue: 
							[self step.
							currentCharacter == $r 
								ifTrue: 
									[self step.
									currentCharacter == $t ifTrue: [^self recordAndReportMatch: #(1)].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/21/2003 17:17'!
scanForToken
	self step.
	(currentCharacter isLetter or: [currentCharacter == $_]) 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isAlphaNumeric or: [currentCharacter == $_]] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan1].
	currentCharacter == $# 
		ifTrue: 
			[
			[self recordMatch: #comment.
			self step.
			currentCharacter <= $	 
				or: [(currentCharacter between: $ and: $) or: [currentCharacter >= $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $% ifTrue: [^self scan2].
	currentCharacter == $' 
		ifTrue: 
			[self step.
			(currentCharacter isLetter or: [currentCharacter == $_]) 
				ifTrue: 
					[
					[self step.
					currentCharacter isAlphaNumeric or: [currentCharacter == $_]] 
							whileTrue.
					currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(24)].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(17)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(14)].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(10)].
	currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(16)].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(25).
			self step.
			currentCharacter == $: 
				ifTrue: 
					[self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(25)].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(7)].
	currentCharacter == $< 
		ifTrue: 
			[self step.
			(currentCharacter isLetter or: [currentCharacter == $_]) 
				ifTrue: 
					[
					[self step.
					currentCharacter isAlphaNumeric or: [currentCharacter == $_]] 
							whileTrue.
					currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(19)].
					^self reportLastMatch].
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(13)].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(5)].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(11)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(2)].
	currentCharacter == ${ 
		ifTrue: 
			[self step.
			currentCharacter ~~ $} 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $}] whileTrue.
					^self recordAndReportMatch: #(23)].
			^self reportLastMatch].
	currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(9)].
	^self reportLastMatch! !

SmaCCScanner subclass: #SmaCCScannerScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCScannerScanner commentStamp: 'jmb' prior: 0!
SmaCCScannerScanner is the scanner for the scanner definition!

!SmaCCScannerScanner class methodsFor: 'generated-comments' stamp: 'jmb 1/21/2003 20:27'!
scannerDefinitionComment

	"<backslashcharacter>	:	\\ [^cx] | \\ c [A-Z] | \\ x [0-9A-Fa-f]{1,4} ;
<characterblock>	: \[ ([^\]\\] | <backslashcharacter> )+ \] ;
<whitespace>	:	[\ \t\v\r\n]+ ;
<tokenname>	:	\< [a-zA-Z] [a-zA-Z0-9]* \> ;
<comment>	:	\# [^\r\n]* ;
<repeat>	:	\{ [0-9]* \, [0-9]* \} ;
<character>	:	[^\ \t\v\\\r\n\{\(\[\.] ; 
<anycharacter>	: \. ;"! !

!SmaCCScannerScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/21/2003 20:27'!
emptySymbolTokenId
	^21! !

!SmaCCScannerScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/21/2003 20:27'!
errorTokenId
	^22! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/21/2003 20:27'!
scan1
	
	[self step.
	currentCharacter <= $[ or: [currentCharacter >= $^]] whileTrue.
	currentCharacter == $\ ifTrue: [^self scan2].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(10)].
	^self reportLastMatch! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/21/2003 20:27'!
scan2
	self step.
	(currentCharacter <= $b 
		or: [(currentCharacter between: $d and: $w) or: [currentCharacter >= $y]]) 
			ifTrue: [^self scan1].
	currentCharacter == $c 
		ifTrue: 
			[self step.
			currentCharacter isUppercase ifTrue: [^self scan1].
			^self reportLastMatch].
	currentCharacter == $x 
		ifTrue: 
			[self step.
			(currentCharacter isDigit or: 
					[(currentCharacter between: $A and: $F) 
						or: [currentCharacter between: $a and: $f]]) 
				ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/21/2003 20:27'!
scanForToken
	self step.
	(currentCharacter isAlphaNumeric or: 
			[currentCharacter <= $ or: 
					[currentCharacter == $ or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $!! and: $") or: 
											[(currentCharacter between: $$ and: $') or: 
													[(currentCharacter between: $, and: $-) or: 
															[currentCharacter == $/ or: 
																	[(currentCharacter between: $= and: $>) or: 
																			[currentCharacter == $@ 
																				or: [(currentCharacter between: $] and: $`) or: [currentCharacter >= $}]]]]]]]]]]]) 
		ifTrue: [^self recordAndReportMatch: #(15)].
	((currentCharacter between: $	 and: $) 
		or: [currentCharacter == $
 or: [currentCharacter == $ ]]) 
			ifTrue: 
				[
				[self recordMatch: #whitespace.
				self step.
				(currentCharacter between: $	 and: $) 
					or: [currentCharacter == $
 or: [currentCharacter == $ ]]] 
						whileTrue.
				^self reportLastMatch].
	currentCharacter == $# 
		ifTrue: 
			[self recordMatch: #comment.
			self step.
			(currentCharacter <= $	 
				or: [(currentCharacter between: $ and: $) or: [currentCharacter >= $]]) 
					ifTrue: 
						[
						[self recordMatch: #comment.
						self step.
						currentCharacter <= $	 
							or: [(currentCharacter between: $ and: $) or: [currentCharacter >= $]]] 
								whileTrue.
						^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(1)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(4 15)].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(3 15)].
	currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(5 15)].
	currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(16)].
	currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(7 15)].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(8 15)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(15).
			self step.
			currentCharacter isLetter 
				ifTrue: 
					[
					[self step.
					currentCharacter isAlphaNumeric] whileTrue.
					currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(12)].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(6 15)].
	currentCharacter == $[ 
		ifTrue: 
			[self step.
			(currentCharacter <= $[ or: [currentCharacter >= $^]) 
				ifTrue: [^self scan1].
			currentCharacter == $\ ifTrue: [^self scan2].
			^self reportLastMatch].
	currentCharacter == $\ 
		ifTrue: 
			[self step.
			(currentCharacter <= $b 
				or: [(currentCharacter between: $d and: $w) or: [currentCharacter >= $y]]) 
					ifTrue: [^self recordAndReportMatch: #(9)].
			currentCharacter == $c 
				ifTrue: 
					[self step.
					currentCharacter isUppercase ifTrue: [^self recordAndReportMatch: #(9)].
					^self reportLastMatch].
			currentCharacter == $x 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: 
							[(currentCharacter between: $A and: $F) 
								or: [currentCharacter between: $a and: $f]]) 
						ifTrue: 
							[self recordMatch: #(9).
							self step.
							(currentCharacter isDigit or: 
									[(currentCharacter between: $A and: $F) 
										or: [currentCharacter between: $a and: $f]]) 
								ifTrue: 
									[self recordMatch: #(9).
									self step.
									(currentCharacter isDigit or: 
											[(currentCharacter between: $A and: $F) 
												or: [currentCharacter between: $a and: $f]]) 
										ifTrue: 
											[self recordMatch: #(9).
											self step.
											(currentCharacter isDigit or: 
													[(currentCharacter between: $A and: $F) 
														or: [currentCharacter between: $a and: $f]]) 
												ifTrue: [^self recordAndReportMatch: #(9)].
											^self reportLastMatch].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == ${ 
		ifTrue: 
			[
			[self step.
			currentCharacter isDigit] whileTrue.
			currentCharacter == $, 
				ifTrue: 
					[
					[self step.
					currentCharacter isDigit] whileTrue.
					currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(14)].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(2 15)].
	^self reportLastMatch! !

SmaCCScanner subclass: #StScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Parsers'!

!StScanner class methodsFor: 'accessing' stamp: ''!
frequencyTable
	^#(0.0 1.31372e-7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0481767 0.0 0.0 0.0 0.0252514 0.0 0.0 2.62743e-7 1.31372e-7 5.25487e-7 1.31372e-7 1.31372e-7 0.0 1.31372e-7 0.0 2.62743e-7 0.0 1.31372e-7 7.8823e-7 2.62743e-7 2.62743e-7 1.31372e-7 5.25487e-7 0.106011 5.13007e-5 0.004554 0.00655584 2.41133e-4 3.60615e-5 1.93248e-4 0.00410241 0.00463893 0.0046369 2.82712e-4 4.64268e-4 0.0011675 9.75895e-4 0.00982753 2.26945e-4 0.00795055 0.00590903 0.0036363 0.00220212 0.00180485 0.00224265 0.00183191 0.00138545 0.00146217 0.00115246 0.0248349 0.00129723 7.50395e-4 0.00496762 8.97532e-4 1.44378e-4 0.00164497 0.00403659 0.00332443 0.00587547 0.00266882 0.00223293 0.00382922 9.91266e-4 9.99673e-4 0.00418163 3.27773e-5 6.31044e-4 0.00271013 0.00248917 0.00292348 0.00278226 0.00359742 7.08751e-4 0.00239287 0.00749351 0.00486778 0.00145908 0.00167453 0.00112251 2.2458e-4 2.32856e-4 4.40752e-5 0.00467815 1.22701e-4 0.00470173 0.00298378 7.73451e-4 2.634e-4 0.0515694 0.00918972 0.0257636 0.0226939 0.09244 0.0167193 0.0108988 0.0138365 0.042864 9.52379e-4 0.00366494 0.0402202 0.0159142 0.0440905 0.0418992 0.0154463 5.66869e-4 0.043972 0.0443068 0.0543899 0.0180997 0.00593537 0.00725816 0.00494884 0.00808567 0.00128285 7.45009e-4 0.00281083 7.45206e-4 1.08907e-4 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 6.56859e-8 3.28429e-7 0.0 0.0 1.97058e-7 0.0 0.0 0.0 0.0 3.94115e-7 6.56859e-8 0.0 2.62743e-7 1.31372e-7 0.0 1.31372e-7 1.31372e-7 0.0 0.0 1.97058e-7 1.31372e-7 6.56859e-8 1.31372e-7 0.0 0.0 7.8823e-7 0.0 0.0 1.31372e-7 1.31372e-7 4.59801e-7 7.8823e-7 0.0 9.85288e-7 5.25487e-7 1.31372e-7 6.56859e-8 1.05097e-6 0.0 2.62743e-7 0.0 1.97058e-7 4.59801e-7 1.97058e-7 5.25487e-7 2.62743e-7 0.0 1.51078e-6 5.91173e-7 1.11666e-6 0.0 1.97058e-7 8.53916e-7 1.57646e-6 0.0 0.0 0.0 0.0 0.0 0.0 0.0 6.56859e-8 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 5.25487e-7 0.0 0.0 0.0 0.0 0.0 0.0 7.8823e-7 0.0 2.62743e-7 0.0 0.0 3.28429e-7 1.31372e-7 0.0 2.62743e-7 0.0 3.28429e-7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.62743e-7 0.0 5.25487e-7 0.0 0.0 1.31372e-7 0.0 0.0 0.0 0.0)! !

!StScanner class methodsFor: 'generated-initialization' stamp: 'jmb 1/23/2003 16:14'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(20 'false' 12) #(20 'nil' 14) #(20 'true' 11) #(32 '0' #number) #(32 '1' #number) #(32 '2' #number) #(32 '3' #number) #(32 '4' #number) #(32 '5' #number) #(32 '6' #number) #(32 '7' #number) #(32 '8' #number) #(32 '9' #number)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!StScanner class methodsFor: 'generated-comments' stamp: 'jmb 1/23/2003 16:14'!
scannerDefinitionComment

	"<name>	:	[a-zA-Z] [a-zA-Z0-9]*	;
<number>:	[0-9]	;
<negativeNumber>	:	\- <number>	;
<string>	:	\'  [^\']* \' (\' [^\']* \')*	;
<keyword>	:	<name> \:	;
<multikeyword>	:	<name> \: (<name> \: )+	;
<binarySymbol>	:	[\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]?	;
<whitespace>	:	\s+	;
<comment>	:	\"" [^\""]* \""	;
<dottedName>	:	<name> (\. <name>)+	;
<character>	:	\$ .	;
<variableAssignment> : <name> \: \=	;

<anyChar> : . ; # For VW literal arrays that handle #(;) -> #(#';')"! !

!StScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:14'!
binarySymbolId
	^26! !

!StScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:14'!
emptySymbolTokenId
	^64! !

!StScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:14'!
errorTokenId
	^65! !

!StScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:14'!
nameId
	^20! !

!StScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:14'!
negativeNumberId
	^22! !

!StScanner methodsFor: 'scanning' stamp: ''!
number
	stream skip: -1.
	self scanNumber: self numberId! !

!StScanner methodsFor: 'generated-tokens' stamp: 'jmb 1/23/2003 16:14'!
numberId
	^21! !

!StScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:14'!
scan1
	
	[self step.
	currentCharacter ~~ $'] whileTrue.
	^self scan2! !

!StScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:14'!
scan2
	self recordMatch: #(23).
	self step.
	currentCharacter == $' ifTrue: [^self scan1].
	^self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:14'!
scan3
	
	[self step.
	currentCharacter isAlphaNumeric] whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(25).
			self step.
			currentCharacter isLetter ifTrue: [^self scan3].
			^self reportLastMatch].
	^self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:14'!
scan4
	self step.
	currentCharacter isLetter 
		ifTrue: 
			[
			[self recordMatch: #(29).
			self step.
			currentCharacter isAlphaNumeric] 
					whileTrue.
			currentCharacter == $. ifTrue: [^self scan4].
			^self reportLastMatch].
	^self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:14'!
scan5
	self recordMatch: #(24).
	self step.
	currentCharacter isLetter ifTrue: [^self scan3].
	currentCharacter == $= 
		ifTrue: [^self recordAndReportMatch: #variableAssignment].
	^self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'jmb 1/23/2003 16:14'!
scanForToken
	self step.
	currentCharacter isLetter 
		ifTrue: 
			[self recordMatch: #(20 32).
			self step.
			currentCharacter isAlphaNumeric 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isAlphaNumeric] 
							whileTrue.
					currentCharacter == $: ifTrue: [^self scan5].
					currentCharacter == $. ifTrue: [^self scan4].
					^self reportLastMatch].
			currentCharacter == $: ifTrue: [^self scan5].
			currentCharacter == $. ifTrue: [^self scan4].
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[self recordMatch: #whitespace.
			self step.
			(currentCharacter isSeparator or: [currentCharacter == $]) 
				ifTrue: 
					[
					[self recordMatch: #whitespace.
					self step.
					currentCharacter isSeparator or: [currentCharacter == $]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	(currentCharacter isDigit or: 
			[currentCharacter <= $ or: 
					[(currentCharacter between: $ and: $) 
						or: [(currentCharacter between: $_ and: $`) or: [currentCharacter >= $]]]]) 
		ifTrue: [^self recordAndReportMatch: #(32)].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(18 32).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(13)].
			^self reportLastMatch].
	currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(5 32)].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[currentCharacter == $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(26)].
			^self reportLastMatch].
	currentCharacter == $# ifTrue: [^self recordAndReportMatch: #(1 32)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(19 32)].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(17 32)].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(10 32)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(4 32)].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			currentCharacter ~~ $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $"] whileTrue.
					^self recordAndReportMatch: #comment].
			currentCharacter == $" ifTrue: [^self recordAndReportMatch: #comment].
			^self reportLastMatch].
	currentCharacter == $' 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			currentCharacter ~~ $' ifTrue: [^self scan1].
			currentCharacter == $' ifTrue: [^self scan2].
			^self reportLastMatch].
	currentCharacter == $^ ifTrue: [^self recordAndReportMatch: #(16 32)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(9 26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(26)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(15 26)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(2 32)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(26 32).
			self step.
			currentCharacter isDigit ifTrue: [^self recordAndReportMatch: #(22)].
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(26)].
			^self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(7 26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(26)].
			^self reportLastMatch].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(6 26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(26)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(8 32)].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(3 32)].
	currentCharacter == $$ 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			^self recordAndReportMatch: #(30)].
	^self reportLastMatch! !

!StScanner methodsFor: 'scanning' stamp: ''!
scanNumber: id 
	| token number |
	number := Number readFrom: stream.
	outputStream reset.
	token := SmaCCToken 
				value: number
				start: start
				id: (Array with: id).
	matchActions := nil.
	returnMatchBlock value: token! !

!StScanner methodsFor: 'scanning' stamp: ''!
variableAssignment
	| token |
	outputStream skip: -2.
	stream skip: -2.
	token := SmaCCToken 
				value: outputStream contents
				start: start
				id: (Array with: self nameId).
	outputStream reset.
	matchActions := nil.
	returnMatchBlock value: token! !

SmaCCScanner subclass: #TestScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

StringHolder subclass: #SmaCCCodeHolder
	instanceVariableNames: 'contentsMorph owner ownerAcceptSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-UI'!

!SmaCCCodeHolder class methodsFor: 'instance creation' stamp: 'apl 2/18/2003 13:44'!
owner: aSmaCCParserGenerator 
	^ self owner: aSmaCCParserGenerator ownerAcceptSelector: nil! !

!SmaCCCodeHolder class methodsFor: 'instance creation' stamp: 'apl 2/17/2003 11:26'!
owner: aSmaCCParserGenerator ownerAcceptSelector: aSymbol 
	^ self new owner: aSmaCCParserGenerator ownerAcceptSelector: aSymbol ! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'apl 2/20/2003 11:32'!
contentsMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:,  
	PluggableTextController will respond to all menu items in a text pane"
	| selections labelsString linesArray |
	selections _ #(#menuFind #findAgain #setSearchString #again #undo #copySelection #cut #paste #pasteRecent #accept #cancel #saveContentsInFile #sendContentsToPrinter #printerSetup #readContentsFromFile ).
	labelsString _ 'find...(f)\find again (g)\set search string (h)\do again (j)\undo (z)\copy (c)\cut (x)\paste (v)\paste...\accept (s)\cancel (l)\save contents to file...\send contents to printer\printer setup\read contents from file...' withCRs.
	linesArray _ #(3 5 9 11 14).
	^ aMenu
		labels: labelsString
		lines: linesArray
		selections: selections! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/6/2004 10:38'!
contentsMorph
   | txtClass |
   contentsMorph isNil
       ifTrue: [txtClass _ ((Smalltalk
                               associationAt: #SVIPrefs
                               ifAbsent: []) isNil
                           or: [(Smalltalk at: #SVIPrefs) sviIsDefaultCodeEditor not])
                       ifTrue: [PluggableTextMorph]
                       ifFalse: [Smalltalk at: #PluggableSVIMorph].
           contentsMorph _ txtClass
                       on: self
                       text: #contents
                       accept: #contents:notifying:
                       readSelection: nil
                       menu: #contentsMenu:shifted:].
   ^ contentsMorph
! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'apl 2/18/2003 12:39'!
contents: aStringOrText notifying: aRequestor 
	| result |
	self ownerAcceptSelector notNil ifTrue: [result _ (self owner
			perform: self ownerAcceptSelector
			with: aStringOrText
			with: aRequestor)] ifFalse: [result _ true].
		result ifTrue: [self acceptContents: aStringOrText.
			^ true].
	^ false! !

!SmaCCCodeHolder methodsFor: 'edit flag' stamp: 'apl 2/18/2003 10:25'!
hasUnacceptedEdits
	^ self contentsMorph hasUnacceptedEdits! !

!SmaCCCodeHolder methodsFor: 'edit flag' stamp: 'apl 2/17/2003 11:39'!
hasUnacceptedEdits: aBoolean 
	^ self contentsMorph hasUnacceptedEdits: aBoolean! !

!SmaCCCodeHolder methodsFor: 'edit flag' stamp: 'apl 2/17/2003 11:39'!
okToChange
	^ super okToChange! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:23'!
owner
	^owner! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:26'!
ownerAcceptSelector
	^ownerAcceptSelector! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:26'!
ownerAcceptSelector: anObject
	ownerAcceptSelector := anObject! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:23'!
owner: anObject
	owner := anObject! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 12:30'!
owner: aSmaCCParserGenerator ownerAcceptSelector: aSymbol 
	self owner: aSmaCCParserGenerator.
	self ownerAcceptSelector: aSymbol.
! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'apl 2/17/2003 11:16'!
perform: selector orSendTo: otherTarget 
	"Selector was just chosen from a menu by a user. If can respond, 
	then perform it on myself. If not, send it to otherTarget,  
	presumably the editPane from which the menu was invoked."
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'apl 2/18/2003 12:00'!
readContentsFromFile
	| result fullFilename |
	(result _ StandardFileMenu oldFile)
		ifNotNil: [fullFilename _ result directory fullNameFor: result name.
			(FileDirectory default fileExists: fullFilename)
				ifFalse: [^ PopUpMenu inform: ' ' , fullFilename , ' doesn''t exists '].
			self acceptContents: (FileStream fileNamed: fullFilename) contents. self changed: #contents]! !

Object subclass: #SmaCCAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCAction commentStamp: 'jmb' prior: 0!
SmaCCAction is an abstract class that represents an action in the LR parsing table.

Subclasses must implement the following messages:
	accessing
		id!

SmaCCAction subclass: #SmaCCAcceptAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCAcceptAction commentStamp: 'jmb' prior: 0!
SmaCCAcceptAction represents an accept action in the parser (i.e., we have parsed a valid string).!

!SmaCCAcceptAction methodsFor: 'accessing' stamp: ''!
id
	^2r00! !

!SmaCCAction methodsFor: 'accessing' stamp: ''!
id
	^self subclassResponsibility! !

!SmaCCAction methodsFor: 'testing' stamp: ''!
isReduce
	^false! !

!SmaCCAction methodsFor: 'testing' stamp: ''!
isShift
	^false! !

SmaCCAction subclass: #SmaCCReduceAction
	instanceVariableNames: 'symbol rhs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCReduceAction commentStamp: 'jmb' prior: 0!
SmaCCReduceAction represents a reduce action in our parser's table.

Instance Variables:
	rhs	<SmaCCRHS>	the rhs that is being reduced
	symbol	<SmaCCNonTerminalSymbol>	the symbol that has the rhs!

!SmaCCReduceAction class methodsFor: 'instance creation' stamp: ''!
symbol: aSymbol rhs: aRHS
	^self new symbol: aSymbol rhs: aRHS! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ''!
id
	^2r10! !

!SmaCCReduceAction methodsFor: 'testing' stamp: ''!
isReduce
	^true! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ''!
rhs
	^rhs! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ''!
size
	^rhs size! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ''!
symbol
	^symbol! !

!SmaCCReduceAction methodsFor: 'initialize-release' stamp: ''!
symbol: aSymbol rhs: aRHS
	rhs := aRHS.
	symbol := aSymbol! !

SmaCCAction subclass: #SmaCCRejectAction
	instanceVariableNames: ''
	classVariableNames: 'Reject'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCRejectAction commentStamp: 'jmb' prior: 0!
SmaCCRejectAction represents a reject action in the parsing tables.!

!SmaCCRejectAction class methodsFor: 'class initialization' stamp: ''!
initialize
	Reject := self basicNew! !

!SmaCCRejectAction class methodsFor: 'instance creation' stamp: ''!
new
	^Reject! !

!SmaCCRejectAction class methodsFor: 'class initialization' stamp: ''!
releaseObjects
	Reject := nil! !

!SmaCCRejectAction methodsFor: 'accessing' stamp: ''!
id
	^2r11! !

SmaCCAction subclass: #SmaCCShiftAction
	instanceVariableNames: ''
	classVariableNames: 'Shift'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCShiftAction commentStamp: 'jmb' prior: 0!
SmaCCShiftAction represents a shift action in the parser's tables.!

!SmaCCShiftAction class methodsFor: 'class initialization' stamp: ''!
initialize
	Shift := self basicNew! !

!SmaCCShiftAction class methodsFor: 'instance creation' stamp: ''!
new
	^Shift! !

!SmaCCShiftAction class methodsFor: 'class initialization' stamp: ''!
releaseObjects
	Shift := nil! !

!SmaCCShiftAction methodsFor: 'accessing' stamp: ''!
id
	^2r01! !

!SmaCCShiftAction methodsFor: 'testing' stamp: ''!
isShift
	^true! !

Object subclass: #SmaCCEdge
	instanceVariableNames: 'toNode characters'
	classVariableNames: 'IsExpressions'
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCEdge commentStamp: 'jmb' prior: 0!
SmaCCEdge represents a transition in a Finite Automata (directed graph). It is labeled with the characters (possibly none, indicating an epsilon transition) that cause the transition.

Instance Variables:
	characters	<SortedCollection of: Character>	The characters that cause the transition. Note that there are no duplicates and all characters are sorted.
	toNode	<SmaCCNode>	The node that this is transitioning to.!

!SmaCCEdge class methodsFor: 'class initialization' stamp: ''!
generateCharacterSetFor: aSelector 
	| stream |
	stream := WriteStream on: String new.
	0 to: SmaCCGrammar maximumCharacterValue
		do: 
			[:i | 
			| ch |
			ch := Character value: i.
			(ch perform: aSelector) ifTrue: [stream nextPut: ch]].
	^stream contents! !

!SmaCCEdge class methodsFor: 'class initialization' stamp: 'jmb 1/20/2003 21:24'!
initializeIsExpressions
	"Creates a map from sets of characters to selectors that start with 'is' on Character. This allows generated scanners to take
	full advantage of selectors that are already implemented on Character"

	| selectors |
	IsExpressions := Dictionary new.
	selectors := Character selectors select: 
					[:each | 
					('is*' match: each) 
						and: [each numArgs = 0 and: [(each at: 3) isUppercase]]].
	selectors do: 
			[:sel | 
			| string |
			string := self generateCharacterSetFor: sel.
			string isEmpty ifFalse: [IsExpressions at: string put: sel]]! !

!SmaCCEdge class methodsFor: 'instance creation' stamp: ''!
to: aNode on: aStringOrNil 
	| edge |
	edge := self new.
	edge to: aNode on: aStringOrNil.
	^edge! !

!SmaCCEdge methodsFor: 'private' stamp: ''!
characters
	^characters! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
closestIsExpression
	"Attempts to find the #is selector that most closely matches the character set that this edge transitions on."

	| expressions closest |
	expressions := IsExpressions keys 
				select: [:each | (each reject: [:ch | self includesCharacter: ch]) isEmpty].
	expressions isEmpty ifTrue: [^nil].
	closest := IsExpressions 
				at: (expressions asSortedCollection: [:a :b | a size > b size]) first.
	(self minMaxPairsWithout: closest) size 
		<= (self minMaxPairsWithout: nil) size ifFalse: [^nil].
	^closest! !

!SmaCCEdge methodsFor: 'testing' stamp: ''!
conflictsWith: anEdge 
	^characters anySatisfy: [:each | anEdge characters includes: each]! !

!SmaCCEdge methodsFor: 'testing' stamp: ''!
does: aString includeCharacter: aCharacter 
	| start stop mid |
	start := 1.
	stop := aString size.
	stop = 0 ifTrue: [^false].
	
	[mid := (start + stop) // 2.
	mid == start] whileFalse: 
				[(aString at: mid) asInteger < aCharacter asInteger 
					ifTrue: [start := mid]
					ifFalse: [stop := mid]].
	^(aString at: start) == aCharacter or: [(aString at: stop) == aCharacter]! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
expression
	| stream isSelector |
	stream := WriteStream on: (String new: 128).
	stream nextPut: $(.
	characters size = SmaCCGrammar maximumCharacterValue 
		ifTrue: [self outputInvertedMatchOn: stream]
		ifFalse: 
			[isSelector := self outputClosestIsMethodOn: stream.
			self outputExpressionOn: stream without: isSelector].
	stream nextPut: $).
	^stream contents! !

!SmaCCEdge methodsFor: 'comparing' stamp: ''!
hash
	^(self to hash bitShift: 14) bitXor: characters hash! !

!SmaCCEdge methodsFor: 'testing' stamp: ''!
includesCharacter: aCharacter 
	^self does: characters includeCharacter: aCharacter! !

!SmaCCEdge methodsFor: 'testing' stamp: ''!
isEmpty
	^characters isEmpty! !

!SmaCCEdge methodsFor: 'testing' stamp: ''!
isEpsilonTransition
	^characters isNil! !

!SmaCCEdge methodsFor: 'accessing' stamp: ''!
mergeWith: anEdge 
	characters := String withAll: ((characters , anEdge characters) asSet 
						asSortedCollection: [:a :b | a asInteger < b asInteger])! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
minMaxPairsWithout: aSelector 
	"Converts a list of characters into a collection of pairs representing the minimum and maximum of each sequence.
	The list is first filtered to include only those characters that fail aSelector."

	| start last pairs charsLeft |
	charsLeft := aSelector isNil 
				ifTrue: [characters]
				ifFalse: [characters reject: [:ch | ch perform: aSelector]].
	pairs := OrderedCollection new.
	charsLeft isEmpty ifTrue: [^pairs].
	last := charsLeft first.
	start := nil.
	charsLeft do: 
			[:each | 
			last asInteger + 1 = each asInteger 
				ifFalse: 
					[start notNil ifTrue: [pairs add: (Array with: start with: last)].
					start := each].
			last := each].
	pairs add: (Array with: start with: last).
	^pairs! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputClosestIsMethodOn: stream 
	| expr |
	expr := self closestIsExpression.
	expr isNil ifFalse: [stream nextPutAll: 'currentCharacter ' , expr].
	^expr! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputExpressionFor: aPair on: stream 
	aPair first == aPair last 
		ifTrue: [^self outputMatchSingleCharacter: aPair first on: stream].
	aPair first = (Character value: 0) 
		ifTrue: [^self outputMatchLessThan: aPair last on: stream].
	aPair last = (Character value: SmaCCGrammar maximumCharacterValue) 
		ifTrue: [^self outputMatchGreaterThan: aPair first on: stream].
	self outputMatchRange: aPair on: stream! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputExpressionOn: aStream without: aSelector 
	| pairs |
	pairs := self minMaxPairsWithout: aSelector.
	pairs isEmpty ifTrue: [^self].
	aSelector notNil ifTrue: [aStream nextPutAll: ' or: ['].
	pairs do: [:each | self outputExpressionFor: each on: aStream]
		separatedBy: [aStream nextPutAll: ' or: ['].
	aStream next: pairs size - 1 put: $].
	aSelector notNil ifTrue: [aStream nextPut: $]]! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputInvertedMatchOn: aStream 
	| char |
	char := Character value: ((0 to: SmaCCGrammar maximumCharacterValue) 
						detect: [:each | (characters includes: (Character value: each)) not]).
	aStream
		nextPutAll: 'currentCharacter ~~ ';
		nextPutAll: char storeString! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputMatchGreaterThan: aCharacter on: stream 
	stream
		nextPutAll: 'currentCharacter >= ';
		nextPutAll: aCharacter storeString! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputMatchLessThan: aCharacter on: stream 
	stream
		nextPutAll: 'currentCharacter <= ';
		nextPutAll: aCharacter storeString! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputMatchRange: aPair on: stream 
	stream
		nextPutAll: '(currentCharacter between: ';
		nextPutAll: aPair first storeString;
		nextPutAll: ' and: ';
		nextPutAll: aPair last storeString;
		nextPutAll: ')'! !

!SmaCCEdge methodsFor: 'compiling' stamp: ''!
outputMatchSingleCharacter: aCharacter on: stream 
	stream
		nextPutAll: 'currentCharacter == ';
		nextPutAll: aCharacter storeString! !

!SmaCCEdge methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: '---';
		nextPutAll: (characters ifNil: ['""']);
		nextPutAll: '--->';
		nextPutAll: toNode printString! !

!SmaCCEdge methodsFor: 'private' stamp: ''!
removeCharacters: aCollection 
	characters := characters 
				reject: [:each | self does: aCollection includeCharacter: each]! !

!SmaCCEdge methodsFor: 'accessing' stamp: ''!
to
	^toNode! !

!SmaCCEdge methodsFor: 'initialize-release' stamp: ''!
to: aNode on: aStringOrNil 
	toNode := aNode.
	characters := aStringOrNil! !

!SmaCCEdge methodsFor: 'comparing' stamp: ''!
<= anEdge 
	^self to id <= anEdge to id! !

!SmaCCEdge methodsFor: 'comparing' stamp: ''!
= anEdge 
	self class = anEdge class ifFalse: [^false].
	^self to = anEdge to and: [self characters = anEdge characters]! !

Object subclass: #SmaCCGrammar
	instanceVariableNames: 'type shiftReduceTable symbols tokens otherStartingSymbols'
	classVariableNames: 'MaximumCharacterValue IgnoreCase'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammar commentStamp: 'jmb' prior: 0!
SmaCCGrammar represents a LR(1) or a LALR(1) grammar.

Instance Variables:
	otherStartingSymbols	<Collection of: SmaCCSymbol>	other starting productions. The first production in the grammar is the defaulting starting position, but this can list other starting positions.
	shiftReduceTable	<Dictionary key: SmaCCSymbol value: SmaCCAction class>	when we have a shift/reduce conflict how should we handle it. This table contains the left/right associative rules. Left is a reduce action and right is a shift action.
	symbols	<OrderedCollection of: SmaCCSymbol>	all symbols in our grammar -- includes both terminal and non-terminal
	tokens	<Dictionary key: String value: SmaCCRegularExpressionNode>	the tokens for our scanner
	type	<Symbol>	the type of grammar (LALR1 or LR1)

!

!SmaCCGrammar class methodsFor: 'accessing' stamp: ''!
ignoreCase
	^IgnoreCase! !

!SmaCCGrammar class methodsFor: 'accessing' stamp: ''!
ignoreCase: aBoolean 
	IgnoreCase := aBoolean! !

!SmaCCGrammar class methodsFor: 'class initialization' stamp: ''!
initialize
	IgnoreCase := false.
	self maximumCharacterValue: 255! !

!SmaCCGrammar class methodsFor: 'accessing' stamp: ''!
maximumCharacterValue
	^MaximumCharacterValue! !

!SmaCCGrammar class methodsFor: 'accessing' stamp: ''!
maximumCharacterValue: anInteger 
	MaximumCharacterValue := anInteger.
	SmaCCEdge initializeIsExpressions! !

!SmaCCGrammar class methodsFor: 'instance creation' stamp: ''!
new
	^(super new)
		initialize;
		yourself! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
addEmptySymbol
	self addSymbol: SmaCCSymbol empty.
	self addSymbol: SmaCCSymbol error! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
addStartingSymbol: aSymbol 
	(otherStartingSymbols includes: aSymbol) 
		ifFalse: [otherStartingSymbols add: aSymbol]! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
addSymbol: aGrammarSymbol 
	^symbols add: aGrammarSymbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
allStartingSymbols
	"Return all starting symbols with the default starting symbol listed first."

	| startingSymbols default |
	default := self startSymbol.
	startingSymbols := otherStartingSymbols copy.
	startingSymbols remove: default ifAbsent: [].
	startingSymbols := startingSymbols collect: 
					[:each | 
					(SmaCCStartingSymbol name: 'B e g i n' , each name)
						addProduction: ((SmaCCRHS new)
									add: each;
									yourself);
						yourself].
	startingSymbols addFirst: default.
	^startingSymbols! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
calculateFirstSets
	| changed |
	changed := true.
	[changed] whileTrue: 
			[changed := false.
			self symbols 
				do: [:each | changed := changed | each calculateFirstTerminals]]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
emptySymbols
	^self symbols select: [:each | each isTerminal not and: [each isEmpty]]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
initialItemSetFor: aSymbol 
	^(aSymbol asLRItemSet)
		type: type;
		yourself! !

!SmaCCGrammar methodsFor: 'initialize-release' stamp: ''!
initialize
	type := #LALR1.
	symbols := OrderedCollection new.
	shiftReduceTable := Dictionary new.
	otherStartingSymbols := OrderedCollection new! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
keywordTerminalNamed: aString 
	^symbols detect: [:each | each name = aString]
		ifNone: 
			[symbols addFirst: ((SmaCCTerminalSymbol name: aString)
						regularExpression: (((aString copyFrom: 2 to: aString size - 1) 
									copyReplaceAll: '""'
									with: '"') inject: nil
										into: 
											[:sum :each | 
											sum isNil 
												ifTrue: [SmaCCCharacterRENode characters: (String with: each)]
												ifFalse: [sum , (SmaCCCharacterRENode characters: (String with: each))]]);
						yourself)]! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ''!
leftPrecedenceFor: aGrammarSymbol 
	shiftReduceTable at: aGrammarSymbol put: SmaCCReduceAction! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
makeGroupFor: aRHSCollection 
	| symbol name |
	name := aRHSCollection inject: ''
				into: [:sum :each | sum , ' | ' , each printString].
	symbol := self nonTerminalSymbolNamed: 'Group: ' , name.
	symbol isEmpty 
		ifTrue: 
			[(aRHSCollection allSatisfy: [:each | each size = 1]) 
				ifTrue: [aRHSCollection do: [:each | each reduceAction: '''1''']].
			aRHSCollection do: [:each | symbol addProduction: each]].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
makeOptionalSymbolFor: aSymbol 
	| symbol |
	symbol := self nonTerminalSymbolNamed: 'Optional: ' , aSymbol printString.
	symbol isEmpty 
		ifTrue: 
			[symbol
				addProduction: ((SmaCCRHS new)
							reduceAction: 'nil';
							yourself);
				addProduction: ((SmaCCRHS new)
							add: aSymbol;
							reduceAction: '''1''';
							yourself)].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
makeRepeatMultipleSymbolFor: aSymbol 
	| symbol |
	symbol := self 
				nonTerminalSymbolNamed: 'Repeat Multiple: ' , aSymbol printString.
	symbol isEmpty 
		ifTrue: 
			[symbol
				addProduction: ((SmaCCRHS new)
							add: aSymbol;
							reduceAction: 'OrderedCollection with: ''1''';
							yourself);
				addProduction: ((SmaCCRHS new)
							add: symbol;
							add: aSymbol;
							reduceAction: '''1'' add: ''2''; yourself';
							yourself)].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
makeRepeatSymbolFor: aSymbol 
	| symbol |
	symbol := self nonTerminalSymbolNamed: 'Repeat: ' , aSymbol printString.
	symbol isEmpty 
		ifTrue: 
			[symbol
				addProduction: ((SmaCCRHS new)
							reduceAction: 'OrderedCollection new';
							yourself);
				addProduction: ((SmaCCRHS new)
							add: symbol;
							add: aSymbol;
							reduceAction: '''1'' add: ''2''; yourself';
							yourself)].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
makeTokenIdMethodFor: aString 
	| token |
	token := (tokens includesKey: aString) 
				ifTrue: [self terminalSymbolNamed: aString]
				ifFalse: 
					[symbols detect: [:each | each name = aString]
						ifNone: [symbols add: (SmaCCTerminalSymbol name: aString)]].
	token createIdMethod: true! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ''!
nonAssociativePrecedenceFor: aGrammarSymbol 
	shiftReduceTable at: aGrammarSymbol put: SmaCCRejectAction! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
nonTerminalSymbolNamed: aString 
	^symbols detect: [:each | each name = aString]
		ifNone: [self addSymbol: (SmaCCNonTerminalSymbol name: aString)]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
preferredActionFor: aGrammarSymbol 
	^shiftReduceTable at: aGrammarSymbol ifAbsent: [nil]! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
reduceTableIndexFor: aGrammarSymbol rhs: aRHS 
	| index |
	index := 0.
	self symbols do: 
			[:each | 
			each = aGrammarSymbol ifTrue: [^index + (each positionOf: aRHS)].
			index := index + each size].
	^0! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ''!
rightPrecedenceFor: aGrammarSymbol 
	shiftReduceTable at: aGrammarSymbol put: SmaCCShiftAction! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ''!
setOperatorPrecedenceFor: aGrammarSymbol to: anInteger
	aGrammarSymbol precedence: anInteger! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
setStartSymbolIfNone: aGrammarSymbol 
	| startSymbol |
	self startSymbol notNil ifTrue: [^self].
	startSymbol := SmaCCStartingSymbol name: 'B e g i n'.
	self addSymbol: startSymbol.
	startSymbol addProduction: ((SmaCCRHS new)
				add: aGrammarSymbol;
				yourself)! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
startSymbol
	^symbols detect: [:each | each isStartingSymbol] ifNone: [nil]! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
symbols
	^symbols! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
symbols: aCollection
	symbols := aCollection! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
terminalSymbolNamed: aString 
	^symbols detect: [:each | each name = aString]
		ifNone: 
			[symbols add: ((SmaCCTerminalSymbol name: aString)
						regularExpression: (tokens at: aString);
						yourself)]! !

!SmaCCGrammar methodsFor: 'private' stamp: ''!
terminalSymbolNamed: aString ifAbsent: aBlock 
	^symbols detect: [:each | each name = aString]
		ifNone: 
			[symbols add: ((SmaCCTerminalSymbol name: aString)
						regularExpression: (tokens at: aString ifAbsent: [^aBlock value]);
						yourself)]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
tokens
	^tokens! !

!SmaCCGrammar methodsFor: 'initialize-release' stamp: ''!
tokens: aCollection
	tokens := aCollection! !

!SmaCCGrammar methodsFor: 'initialize-release' stamp: ''!
type: aSymbol
	type := aSymbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ''!
unusedSymbols
	| nonTerminals problemSymbols todo symbol |
	nonTerminals := self symbols reject: [:each | each isTerminal].
	problemSymbols := nonTerminals asSet.
	problemSymbols remove: self startSymbol.
	todo := OrderedCollection with: self startSymbol.
	[todo isEmpty] whileFalse: 
			[symbol := todo removeFirst.
			symbol productionsDo: 
					[:rhs | 
					rhs do: 
							[:each | 
							each isTerminal 
								ifFalse: 
									[(problemSymbols includes: each) 
										ifTrue: 
											[todo add: each.
											problemSymbols remove: each]]]]].
	^problemSymbols! !

Object subclass: #SmaCCGrammarCompiler
	instanceVariableNames: 'shiftTable itemSets startingStateMap actions parserClass parserDefinitionString scannerCompiler grammar model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammarCompiler commentStamp: 'jmb' prior: 0!
SmaCCGrammarCompiler compiles a SmaCCGrammar.

Instance Variables:
	actions	<Array>	the action table for the parser. It contains the action (shift/reduce/accept/reject) for each possible state/symbol pair
	grammar	<SmaCCGrammar>	our grammar
	itemSets	<SequenceableCollection of: SmaCCItemSet>	the item sets for our grammar
	model	<RBNameSpace>	where we are compiling our changes into
	parserClass	<RBAbstractClass>	the parser class for our changes
	parserDefinitionString	<String>	the definition of our parser
	scannerCompiler	<SmaCCScannerCompiler>	a compiler for the scanner
	shiftTable	<Dictionary key: (Array with: Integer with: SmaCCSymbol) value: Integer>	a table mapping a state/symbol pair to the new state that is aquired by shifting the symbol
	startingStateMap	<Dictionary key: SmaCCSymbol value: Integer>	the state for SmaCCSymbol's starting item set

!

!SmaCCGrammarCompiler class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew initialize! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ''!
actionForState: anInteger on: aGrammarSymbol 
	| action newStateIndex |
	action := (itemSets at: anInteger) action: aGrammarSymbol
				prefer: (grammar preferredActionFor: aGrammarSymbol).
	action isShift 
		ifTrue: 
			[newStateIndex := shiftTable 
						at: (Array with: anInteger with: aGrammarSymbol).
			^(newStateIndex bitShift: 2) + action id].
	action isReduce 
		ifTrue: 
			[^((grammar reduceTableIndexFor: action symbol rhs: action rhs) 
				bitShift: 2) + action id].
	^action id! !

!SmaCCGrammarCompiler methodsFor: 'initialize-release' stamp: ''!
buildScanner: scannerString andParser: parserString 
	| parser |
	scannerCompiler grammar: self grammar.
	scannerCompiler scannerDefinitionString: scannerString.
	parserDefinitionString := parserString.
	scannerCompiler parseTokens.
	parser := SmaCCGrammarParser on: (ReadStream on: parserString).
	parser grammar: grammar.
	parser parse! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
changes
	^model changes! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ''!
checkForEmptySymbols
	| problemSymbols stream |
	problemSymbols := grammar emptySymbols.
	problemSymbols isEmpty ifTrue: [^self].
	stream := WriteStream on: String new.
	problemSymbols do: [:each | stream nextPutAll: each printString]
		separatedBy: [stream space].
	SmaCCCompilationNotification raiseRequestWith: stream contents
		errorString: 'Missing non-terminal productions'! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ''!
checkForUnusedSymbols
	| problemSymbols stream |
	problemSymbols := grammar unusedSymbols.
	problemSymbols isEmpty ifTrue: [^self].
	stream := WriteStream on: String new.
	problemSymbols do: [:each | stream nextPutAll: each printString]
		separatedBy: [stream space].
	SmaCCCompilationNotification raiseRequestWith: stream contents
		errorString: 'Unused non-terminal symbols'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'jmb 1/20/2003 22:01'!
compileChanges
	RefactoryChangeManager instance performChange: self changes.
	scannerCompiler scannerClass realClass 
		ifNotNil: [scannerCompiler scannerClass realClass initializeKeywordMap]! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileDefinitionComments
	scannerCompiler compileScannerDefinitionComment.
	self compileParserDefinitionComment! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileInto: sClass andParser: pClass 
	self scannerClass: sClass.
	self parserClass: pClass.
	self createChanges.
	self compileChanges! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileItemSetsComment
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'itemSetsComment';
		cr;
		cr;
		tab;
		nextPut: $";
		cr.
	(1 to: itemSets size) with: itemSets
		do: 
			[:index :each | 
			stream
				nextPutAll: index printString;
				nextPutAll: (each printString copyReplaceAll: '"' with: '""');
				cr].
	stream nextPut: $".
	self parserClass metaclass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileParser
	self compileTransitionTable.
	self compileStartingStateIds.
	self compileReductionTable.
	self compileScannerClassIntoParser! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileParserDefinitionComment
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'parserDefinitionComment';
		cr;
		cr;
		tab;
		nextPut: $";
		nextPutAll: (parserDefinitionString copyReplaceAll: '"'
					with: '""');
		nextPut: $".
	parserClass metaclass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileReductionTable
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'reduceTable';
		cr;
		tab;
		nextPutAll: '^#(';
		cr.
	self reduceTable do: 
			[:each | 
			stream nextPutAll: '#('.
			each do: [:e | stream nextPutAll: e storeString]
				separatedBy: [stream space].
			stream
				nextPut: $);
				cr].
	stream nextPut: $).
	parserClass compile: stream contents classified: #'generated-tables'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'jmb 1/20/2003 22:01'!
compileScannerClassIntoParser
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'scannerClass';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: scannerCompiler scannerClass name.
	self parserClass metaclass compile: stream contents
		classified: #'generated-accessing'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileStartingStateIds
	startingStateMap keysAndValuesDo: 
			[:symbol :position | 
			| stream |
			stream := WriteStream on: (String new: 1000).
			stream
				nextPutAll: 'startingStateFor';
				nextPutAll: symbol compileName;
				cr;
				tab;
				nextPutAll: '^';
				nextPutAll: position printString.
			parserClass metaclass compile: stream contents
				classified: #'generated-starting states']! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileSymbolComment
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'symbolComment';
		cr;
		cr;
		tab;
		nextPut: $";
		cr.
	(1 to: scannerCompiler symbols size) with: scannerCompiler symbols
		do: 
			[:index :each | 
			stream
				nextPutAll: index printString;
				nextPutAll: '. ';
				nextPutAll: (each printString copyReplaceAll: '"' with: '""');
				cr].
	stream nextPut: $".
	self parserClass metaclass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
compileTransitionTable
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'transitionTable';
		cr;
		tab;
		nextPutAll: '^#(';
		cr.
	self transitionTable do: 
			[:each | 
			stream nextPutAll: '#('.
			each do: [:byte | stream nextPutAll: byte printString]
				separatedBy: [stream nextPut: $ ].
			stream
				nextPut: $);
				cr].
	stream nextPut: $).
	parserClass compile: stream contents classified: #'generated-tables'! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ''!
compressTable: table 
	^table collect: 
			[:row | 
			| stream uniqueItems |
			stream := WriteStream on: Array new.
			uniqueItems := (row asSet)
						remove: 3 ifAbsent: [];
						asArray.
			uniqueItems size = 1 
				ifTrue: 
					[stream nextPut: 2.
					stream nextPut: uniqueItems first.
					(1 to: row size) with: row
						do: [:index :each | each ~~ 3 ifTrue: [stream nextPut: index]]]
				ifFalse: 
					[stream nextPut: 3.
					(1 to: row size) with: row
						do: 
							[:index :each | 
							each ~~ 3 
								ifTrue: 
									[stream
										nextPut: each;
										nextPut: index]]].
			stream contents]! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ''!
createChanges
	self removeOldMethods.
	self checkForEmptySymbols.
	self checkForUnusedSymbols.
	scannerCompiler compileScanner.
	self compileParser! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ''!
createItemSets
	| itemSet newState index |
	startingStateMap := Dictionary new.
	grammar calculateFirstSets.
	itemSets := OrderedCollection new.
	grammar allStartingSymbols do: 
			[:each | 
			itemSets add: (grammar initialItemSetFor: each).
			startingStateMap at: each put: itemSets size].
	shiftTable := Dictionary new.
	index := 1.
	[index <= itemSets size] whileTrue: 
			[itemSet := itemSets at: index.
			grammar symbols do: 
					[:each | 
					newState := itemSet moveOn: each.
					newState notEmpty 
						ifTrue: 
							[shiftTable at: (Array with: index with: each)
								put: (self indexOfState: newState)]].
			index := index + 1]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ''!
createTransitionTable
	| table |
	table := OrderedCollection new.
	(1 to: itemSets size) with: itemSets
		do: 
			[:index :each | 
			table add: ((1 to: scannerCompiler symbols size) 
						collect: [:i | self actionForState: index on: (scannerCompiler symbols at: i)])].
	actions := self compressTable: table! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'jmb 1/21/2003 15:33'!
defineClass: aString asSubclassOf: aBehavior
	model defineClass: aBehavior name , ' subclass: #' , aString 
				, ' instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: '''' '.
	^model classNamed: aString asSymbol! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: ''!
grammar
	^grammar isNil ifTrue: [grammar := SmaCCGrammar new] ifFalse: [grammar]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ''!
indexOfState: newState 
	| newStateIndex |
	newStateIndex := itemSets indexOf: newState.
	newStateIndex == 0 
		ifTrue: 
			[itemSets add: newState.
			newStateIndex := itemSets size]
		ifFalse: [(itemSets at: newStateIndex) mergeWith: newState].
	^newStateIndex! !

!SmaCCGrammarCompiler methodsFor: 'initialize-release' stamp: 'jmb 1/20/2003 21:47'!
initialize
	scannerCompiler := SmaCCScannerCompiler new.
	model := (RBNamespace new)
				name: 'Compile Scanner/Parser';
				yourself.
	startingStateMap := Dictionary new! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: ''!
parserClass
	^parserClass! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: 'jmb 1/21/2003 15:35'!
parserClass: aClassOrString 
	(aClassOrString isKindOf: Behavior) 
		ifTrue: [parserClass := model classFor: aClassOrString]
		ifFalse: 
			[parserClass := model classNamed: aClassOrString asSymbol.
			parserClass isNil  
				ifTrue: [parserClass := self defineClass: aClassOrString asSubclassOf: SmaCCParser]]! !

!SmaCCGrammarCompiler methodsFor: 'reduction table' stamp: ''!
reduceTable
	| table |
	table := OrderedCollection new.
	scannerCompiler symbols do: 
			[:each | 
			each isTerminal 
				ifFalse: 
					[each productionsDo: 
							[:rhs | 
							table add: (Array 
										with: (scannerCompiler symbols indexOf: each)
										with: rhs size
										with: (rhs compileSourceFor: each in: parserClass))]]].
	^table! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ''!
removeOldMethods
	self
		removeOldMethodsFrom: scannerCompiler scannerClass;
		removeOldMethodsFrom: scannerCompiler scannerClass metaclass;
		removeOldMethodsFrom: parserClass;
		removeOldMethodsFrom: parserClass metaclass! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ''!
removeOldMethodsFrom: aRBClass 
	(aRBClass selectors select: 
			[:each | 
			(aRBClass protocolsFor: each) 
				allSatisfy: [:protocol | protocol notNil and: ['generated*' match: protocol]]]) 
		do: [:each | aRBClass removeMethod: each]! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: 'jmb 1/21/2003 15:34'!
scannerClass: aClassOrString 
	(aClassOrString isKindOf: Behavior) 
		ifTrue: [scannerCompiler scannerClass: (model classFor: aClassOrString)]
		ifFalse: 
			[scannerCompiler scannerClass: (model classNamed: aClassOrString asSymbol).
			scannerCompiler scannerClass isNil 
				ifTrue: 
					[scannerCompiler 
						scannerClass: (self defineClass: aClassOrString asSubclassOf: SmaCCScanner)]]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ''!
transitionTable
	actions isNil 
		ifTrue: 
			[self createItemSets.
			self createTransitionTable].
	^actions! !

Object subclass: #SmaCCLR1Item
	instanceVariableNames: 'rhs symbol location followers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCLR1Item commentStamp: 'jmb' prior: 0!
SmaCCLR1Item represents an item in a SmaCCItemSet.

Instance Variables:
	followers	<SmaCCSymbolSet>	all possible symbols that can follow this production in this state
	location	<Integer>	the position in the rhs of the production we are at
	rhs	<SmaCCRHS>	the rhs of the production
	symbol	<SmaCCSymbol>	the symbol for the production!

!SmaCCLR1Item class methodsFor: 'instance creation' stamp: ''!
symbol: productionGrammarSymbol rhs: aRHS follow: aGrammarSymbolCollection 
	^(self new)
		symbol: productionGrammarSymbol
			rhs: aRHS
			follow: aGrammarSymbolCollection;
		yourself! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
action: aGrammarSymbol 
	location > rhs size 
		ifTrue: 
			[(symbol isStartingSymbol and: [aGrammarSymbol isEmptySymbol]) 
				ifTrue: [^SmaCCAcceptAction new].
			(followers includes: aGrammarSymbol) 
				ifTrue: [^SmaCCReduceAction symbol: symbol rhs: rhs]]
		ifFalse: [(rhs at: location) = aGrammarSymbol ifTrue: [^SmaCCShiftAction new]].
	^SmaCCRejectAction new! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
followers
	^followers! !

!SmaCCLR1Item methodsFor: 'initialize-release' stamp: ''!
followers: aSymbolSet 
	followers := aSymbolSet! !

!SmaCCLR1Item methodsFor: 'comparing' stamp: ''!
hash
	^(symbol identityHash bitXor: (location bitShift: 14)) 
		bitXor: rhs identityHash! !

!SmaCCLR1Item methodsFor: 'testing' stamp: ''!
isLR1EqualTo: aLRItem 
	^self followers size = aLRItem followers size 
		and: [self followers allSatisfy: [:each | aLRItem followers includes: each]]! !

!SmaCCLR1Item methodsFor: 'private' stamp: ''!
location
	^location! !

!SmaCCLR1Item methodsFor: 'initialize-release' stamp: ''!
location: anInteger 
	location := anInteger! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
mergeWith: aLRItem 
	followers mergeWith: aLRItem followers! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
moveNext
	^(self copy)
		followers: (followers class basedOn: followers);
		location: location + 1;
		yourself! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
nextSymbol
	^location > rhs size 
		ifTrue: [SmaCCSymbol sentinel]
		ifFalse: [rhs at: location]! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
precedence
	"If we don't have a precedence, then assume we are the lowest precedence (which will cause a shift action)."

	| max |
	max := -1.
	rhs do: [:each | max := max max: (each precedence ifNil: [max])].
	^max! !

!SmaCCLR1Item methodsFor: 'printing' stamp: ''!
printOn: aStream 
	| i |
	aStream
		nextPut: $[;
		nextPutAll: symbol printString;
		nextPutAll: ' :'.
	i := 1.
	rhs do: 
			[:each | 
			i = location ifTrue: [aStream nextPutAll: ' . '].
			aStream
				space;
				nextPutAll: each printString.
			i := i + 1].
	location > rhs size ifTrue: [aStream nextPutAll: ' . '].
	aStream nextPut: $;.
	followers printOn: aStream.
	aStream nextPut: $]! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ''!
rest
	| newRHS |
	newRHS := SmaCCRHS new.
	location + 1 to: rhs size do: [:each | newRHS add: (rhs at: each)].
	^newRHS! !

!SmaCCLR1Item methodsFor: 'private' stamp: ''!
rhs
	^rhs! !

!SmaCCLR1Item methodsFor: 'private' stamp: ''!
symbol
	^symbol! !

!SmaCCLR1Item methodsFor: 'initialize-release' stamp: ''!
symbol: productionGrammarSymbol rhs: aRHS follow: aSymbolCollection 
	symbol := productionGrammarSymbol.
	rhs := aRHS.
	location := 1.
	followers := aSymbolCollection! !

!SmaCCLR1Item methodsFor: 'comparing' stamp: ''!
= anItem 
	^self class == anItem class and: 
			[location == anItem location 
				and: [rhs == anItem rhs and: [symbol == anItem symbol]]]! !

Object subclass: #SmaCCNode
	instanceVariableNames: 'transitions action id'
	classVariableNames: 'NextId'
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCNode commentStamp: 'jmb' prior: 0!
SmaCCNode is a node in a directed graph.

Instance Variables:
	action	<SequenceableCollection>	a collection of integers or a symbol. This contains the action to be performed when we match and can't find a longer match.
	id	<Integer>	a unique number that allows us to sort the nodes
	transitions	<Collection of: SmaCCEdge>	our transitions

!

!SmaCCNode class methodsFor: 'class initialization' stamp: ''!
initialize
	NextId := 0! !

!SmaCCNode class methodsFor: 'instance creation' stamp: ''!
new
	^(super new)
		initialize;
		yourself! !

!SmaCCNode methodsFor: 'private' stamp: ''!
action
	^action! !

!SmaCCNode methodsFor: 'initialize-release' stamp: ''!
action: anObject 
	anObject isNil ifTrue: [^self].
	action := anObject isSymbol 
				ifTrue: [anObject]
				ifFalse: [SortedCollection with: anObject]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
addActions: aCollection 
	aCollection isNil ifTrue: [^self].
	action isNil 
		ifTrue: 
			[action := aCollection copy.
			^self].
	action isSymbol ifTrue: [^self].
	aCollection isSymbol ifTrue: [^action := aCollection].
	aCollection 
		do: [:each | (action includes: each) ifFalse: [action add: each]]! !

!SmaCCNode methodsFor: 'edges' stamp: ''!
addEdgeTo: endNode 
	transitions add: (SmaCCEdge to: endNode on: nil)! !

!SmaCCNode methodsFor: 'edges' stamp: ''!
addEdgeTo: endNode on: characterCollection 
	transitions add: (SmaCCEdge to: endNode on: characterCollection)! !

!SmaCCNode methodsFor: 'private' stamp: ''!
allCharacterTransitionsAndActionsInto: aNode 
	| seen |
	seen := IdentitySet new.
	self allCharacterTransitions: seen into: aNode! !

!SmaCCNode methodsFor: 'private' stamp: ''!
allCharacterTransitions: aSet into: aNode 
	| index each |
	(aSet includes: self) ifTrue: [^#()].
	aSet add: self.
	aNode addActions: action.
	index := 1.
	[index <= transitions size] whileTrue: 
			[each := transitions at: index.
			index := index + 1.
			each isEpsilonTransition 
				ifTrue: [each to allCharacterTransitions: aSet into: aNode]
				ifFalse: 
					[(aNode transitions includes: each) ifFalse: [aNode transitions add: each]]]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
allStates
	| nodes |
	nodes := Set new.
	self allStatesInto: nodes.
	^nodes! !

!SmaCCNode methodsFor: 'private' stamp: ''!
allStatesInto: aSet 
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	transitions do: [:each | each to allStatesInto: aSet]! !

!SmaCCNode methodsFor: 'converting' stamp: ''!
asDFA
	self asDFA: IdentitySet new merged: Dictionary new.
	self removeDuplicateNodes.
	^self! !

!SmaCCNode methodsFor: 'private' stamp: ''!
asDFA: aSet merged: aDictionary 
	| newTransitions |
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	newTransitions := OrderedCollection new: transitions size.
	transitions do: 
			[:each | 
			| existingEdges new |
			new := each copy.
			existingEdges := newTransitions select: [:edge | edge conflictsWith: each].
			existingEdges do: 
					[:existing | 
					| node newChars existingChars chars |
					node := aDictionary 
								at: (SortedCollection with: existing to id with: new to id) asArray
								ifAbsentPut: 
									[node := self class new.
									node transitions: ((Set 
												withAll: (existing to transitions collect: [:edge | edge copy]))
												addAll: (new to transitions collect: [:edge | edge copy]);
												yourself).
									node mergeCharacterTransitions.
									node addActions: existing to action.
									node addActions: new to action.
									node].
					newChars := new characters.
					chars := newChars select: [:char | existing includesCharacter: char].
					chars notEmpty 
						ifTrue: [newTransitions addFirst: (SmaCCEdge to: node on: chars)].
					existingChars := existing characters.
					existing removeCharacters: newChars.
					new removeCharacters: existingChars.
					existing isEmpty ifTrue: [newTransitions remove: existing]].
			new isEmpty ifFalse: [newTransitions add: new]].
	transitions := newTransitions.
	transitions do: [:each | each to asDFA: aSet merged: aDictionary]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
asNFAWithoutEpsilonTransitions
	| seen node |
	node := self class new.
	self allCharacterTransitionsAndActionsInto: node.
	seen := IdentitySet new.
	node asNFAWithoutEpsilonTransitions: seen.
	seen := IdentitySet new.
	node removeEpsilonTransitions: seen.
	node cleanUp.
	^node! !

!SmaCCNode methodsFor: 'private' stamp: ''!
asNFAWithoutEpsilonTransitions: aSet 
	| index each |
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	index := 1.
	[index <= transitions size] whileTrue: 
			[each := transitions at: index.
			index := index + 1.
			each isEpsilonTransition 
				ifTrue: [each to allCharacterTransitionsAndActionsInto: self]
				ifFalse: [each to asNFAWithoutEpsilonTransitions: aSet]]! !

!SmaCCNode methodsFor: 'compiling' stamp: ''!
asStatement: methodMap usingSelectorMap: aDictionary forClass: aClass 
	| stream |
	stream := WriteStream on: (String new: 128).
	self hasSimpleLoop ifTrue: [stream nextPut: $[].
	self writeMatchingCodeOn: stream usingSelectorMap: aDictionary.
	(self sortedTransitionsFor: aClass) do: 
			[:each | 
			each to == self 
				ifTrue: 
					[stream
						nextPutAll: each expression;
						nextPut: $];
						nextPutAll: ' whileTrue.';
						cr]
				ifFalse: 
					[stream
						nextPutAll: each expression;
						nextPutAll: ' ifTrue: ['.
					stream
						nextPutAll: (methodMap at: each to
									ifAbsentPut: 
										[each to 
											asStatement: methodMap
											usingSelectorMap: aDictionary
											forClass: aClass]);
						nextPutAll: '].';
						cr]].
	(transitions notEmpty or: [action isNil]) 
		ifTrue: 
			[stream
				nextPutAll: '^self reportLastMatch';
				cr].
	^stream contents! !

!SmaCCNode methodsFor: 'private' stamp: ''!
cleanUp
	self removeDuplicateNodes.
	self mergeAllTransitions! !

!SmaCCNode methodsFor: 'compiling' stamp: ''!
compileInto: aClass usingSelectorMap: aDictionary 
	| methodNodes methodMap index |
	methodNodes := self statesToMakeIntoMethods.
	methodMap := self methodNameMapFor: methodNodes.
	index := 0.
	methodNodes do: 
			[:each | 
			| stream |
			stream := WriteStream on: (String new: 1000).
			stream
				nextPutAll: (each == self 
							ifTrue: ['scanForToken']
							ifFalse: ['scan' , (index := index + 1) printString]);
				cr.
			stream nextPutAll: (each 
						asStatement: methodMap
						usingSelectorMap: aDictionary
						forClass: aClass).
			aClass 
				compile: (self optimizedParseTreeFor: stream contents) formattedCode
				classified: #'generated-scanner']! !

!SmaCCNode methodsFor: 'testing' stamp: ''!
hasSimpleLoop
	^transitions anySatisfy: [:each | each to == self]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
id
	^id! !

!SmaCCNode methodsFor: 'initialize-release' stamp: ''!
initialize
	id := NextId := NextId + 1.
	transitions := SortedCollection new! !

!SmaCCNode methodsFor: 'testing' stamp: ''!
isTerminalNode
	^transitions isEmpty or: [transitions size = 1 and: [self hasSimpleLoop]]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
mergeAllTransitions
	| nodes |
	nodes := self allStates.
	nodes do: [:each | each mergeCharacterTransitions]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
mergeCharacterTransitions
	| toMap |
	toMap := IdentityDictionary new.
	transitions copy do: 
			[:each | 
			(toMap includesKey: each to) 
				ifTrue: 
					[(toMap at: each to) mergeWith: each.
					transitions remove: each]
				ifFalse: [toMap at: each to put: each]]! !

!SmaCCNode methodsFor: 'compiling' stamp: ''!
methodNameMapFor: methodNodes 
	| index methodMap |
	methodMap := IdentityDictionary new.
	index := 0.
	methodNodes do: 
			[:value | 
			methodMap at: value
				put: (value == self 
						ifTrue: ['^self scanForToken']
						ifFalse: ['^self scan' , (index := index + 1) printString])].
	^methodMap! !

!SmaCCNode methodsFor: 'compiling' stamp: ''!
needsSeparateMethod
	^self allStates size > 20! !

!SmaCCNode methodsFor: 'compiling' stamp: 'jmb 1/20/2003 21:57'!
optimizationRewriter
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: 'Core.Character' with: 'Character';
		replace: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				currentCharacter == `#l ifTrue: [`@.Stmts3].
				`@.Stmts4'
			with: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				`@.Stmts3';
		replaceMethod: '`name
							`@.Stmts1.
							`@a ifTrue: [`@.Stmts2.
									^self `name].
							`@.Stmts3'
			with: '`name
				[`@.Stmts1.
				`@a] whileTrue: [`@.Stmts2].
				`@.Stmts3';
		replace: '`@.Stmts1.
				currentCharacter isLiteral ifTrue: [`@.Stmts2].
				`@.Stmts3'
			with: '`@.Stmts1.
				`@.Stmts2';
"		replace: '``@.Stmts1.
				(`@a ifTrue: [``@.Stmts2]) `{:node :dictionary | | index myStatements |
						index := node parent statements indexOf: node.
						myStatements := node parent statements.
						dictionary at: #size put: ``@.Stmts2 size - (myStatements size - index).
						index ~~  myStatements size and: [``@.Stmts2 size >= (myStatements size - index) and: [
							(index + 1 to: myStatements size) allSatisfy: [:each | 
								(myStatements at: each) = (``@.Stmts2 at: ``@.Stmts2 size - (myStatements size - each))]]]
						}.
				``@.Stmts3'
			with: '``@.Stmts1.
				`{:dictionary | RBMessageNode receiver: `@a selector: #ifTrue: arguments: (Array with: (RBBlockNode body: (RBSequenceNode statements: (``@.Stmts2 copyFrom: 1 to: (dictionary at: #size)))))}.
				``@.Stmts3';"
		replace: '`@.Stmts1.
				`.Stmt.
				`@.Stmts.
				`@a ifTrue: [self step. `.Stmt. `@.Stmts].
				`@.Stmts2'
			with: '`@.Stmts1.
				`@a ifTrue: [self step].
				`.Stmt.
				`@.Stmts.
				`@.Stmts2'.
	^rewriter! !

!SmaCCNode methodsFor: 'compiling' stamp: ''!
optimizedParseTreeFor: aString 
	| tree rewriter |
	tree := RBParser parseMethod: aString.
	rewriter := self optimizationRewriter.
	[rewriter executeTree: tree] whileTrue: [tree := rewriter tree].
	^tree! !

!SmaCCNode methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: id printString;
		nextPut: $)! !

!SmaCCNode methodsFor: 'private' stamp: ''!
removeDuplicateEdges
	transitions := transitions asSet asSortedCollection! !

!SmaCCNode methodsFor: 'private' stamp: ''!
removeDuplicateNodes
	| nodes |
	
	[nodes := self allStates.
	nodes do: 
			[:each | 
			each
				mergeCharacterTransitions;
				removeDuplicateEdges].
	self removeDuplicateNodes: nodes] 
			whileTrue! !

!SmaCCNode methodsFor: 'private' stamp: 'jmb 1/20/2003 21:54'!
removeDuplicateNodes: aCollection 
	| merged nodePartition |
	merged := false.
	nodePartition := Dictionary new.
	aCollection do: 
			[:each | 
			(nodePartition at: (Array with: each transitions size with: each action)
				ifAbsentPut: [OrderedCollection new]) add: each].
	nodePartition do: 
			[:each | 
			| seen |
			seen := OrderedCollection new.
			each do: 
					[:node | 
					| existingNode |
					existingNode := seen 
								detect: [:otherNode | otherNode transitionsMatch: node]
								ifNone: [nil].
					existingNode isNil 
						ifTrue: [seen add: node]
						ifFalse: 
							[merged := true.
							node becomeForward: existingNode]]].
	^merged! !

!SmaCCNode methodsFor: 'private' stamp: ''!
removeEpsilonTransitions: aSet 
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	transitions copy 
		do: [:each | each isEpsilonTransition ifTrue: [transitions remove: each]].
	transitions do: [:each | each to removeEpsilonTransitions: aSet]! !

!SmaCCNode methodsFor: 'simulating' stamp: ''!
simulate: aStream 
	| char |
	aStream atEnd ifTrue: [^action].
	char := aStream next.
	transitions 
		do: [:each | (each characters includes: char) ifTrue: [^each to simulate: aStream]].
	^action! !

!SmaCCNode methodsFor: 'compiling' stamp: 'jmb 1/20/2003 21:56'!
sortedTransitionsFor: aClass 
	| frequencies |
	frequencies := ((aClass realClass) ifNil: [SmaCCScanner]) frequencyTable.
	^transitions asSortedCollection: 
			[:a :b | 
			| aFrequency bFrequency |
			aFrequency := a characters inject: 0
						into: [:sum :each | sum + (frequencies at: each asInteger \\ frequencies size + 1)].
			bFrequency := b characters inject: 0
						into: [:sum :each | sum + (frequencies at: each asInteger \\ frequencies size + 1)].
			aFrequency > bFrequency 
				or: [aFrequency = bFrequency and: [a characters first < b characters first]]]! !

!SmaCCNode methodsFor: 'compiling' stamp: ''!
statesToMakeIntoMethods
	| allStates incoming |
	allStates := self allStates.
	incoming := Dictionary new.
	allStates do: 
			[:each | 
			each transitions do: 
					[:edge | 
					each ~~ edge to 
						ifTrue: [(incoming at: edge to ifAbsentPut: [Set new]) add: each]]].
	^(allStates asOrderedCollection select: 
			[:each | 
			self == each or: 
					[each isTerminalNode not and: 
							[(incoming at: each ifAbsent: [#()]) size > 1 
								or: [each needsSeparateMethod]]]]) 
		asSortedCollection: [:a :b | a id < b id]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
transitions
	^transitions! !

!SmaCCNode methodsFor: 'private' stamp: ''!
transitionsMatch: aNode 
	^aNode transitions allSatisfy: 
			[:each | 
			(transitions includes: each) or: 
					[each to = aNode and: 
							[each characters 
								= (transitions detect: [:edge | edge to = self] ifNone: [^false]) 
										characters]]]! !

!SmaCCNode methodsFor: 'private' stamp: ''!
transitions: aCollection 
	transitions := aCollection asSortedCollection! !

!SmaCCNode methodsFor: 'compiling' stamp: 'jmb 1/20/2003 21:55'!
writeMatchingCodeOn: aStream usingSelectorMap: aDictionary 
	| matchedItem |
	(action notNil and: [action size > 0]) 
		ifTrue: 
			[matchedItem := aDictionary at: action first ifAbsent: [action asArray].
			aStream nextPutAll: (transitions isEmpty 
						ifTrue: ['^self recordAndReportMatch:']
						ifFalse: ['self recordMatch: ']).
			matchedItem isSymbol 
				ifTrue: [aStream nextPutAll: matchedItem storeString]
				ifFalse: 
					[aStream nextPutAll: '#('.
					matchedItem do: [:each | aStream nextPutAll: each storeString]
						separatedBy: [aStream nextPut: $ ].
					aStream nextPut: $)].
			aStream
				nextPut: $.;
				cr].
	transitions notEmpty 
		ifTrue: 
			[aStream
				nextPutAll: 'self step.';
				cr]! !

Object subclass: #SmaCCParserGenerator
	instanceVariableNames: 'tabList parserClassMorph scannerClassMorph findScannerClassButton findParserClassButton conflicts generateDefinitionComments generateSymbolComments generateItemSetComments ignoreCase mainWindow parserCodeHolder scannerCodeHolder testCodeHolder tutorialTextHolder conflictTextMorph'
	classVariableNames: 'ShowPrecedenceConflicts'
	poolDictionaries: ''
	category: 'SmaCCDev-UI'!

!SmaCCParserGenerator commentStamp: 'jmb 1/23/2003 15:59' prior: 0!
SmaCC: The Smalltalk Compiler-Compiler 
from John Brant and Don Roberts
(http://www.refactory.com/Software/SmaCC)

Tutorial

This is a walk-through tutorial to demonstrate many of the features of SmaCC, the Smalltalk Compiler Compiler. In this example, we will incrementally develop a simple calculator. 

Our first calculator is going to be relatively simple. It is going to take two  numbers  and add them together. To start things off, we have to tell the scanner how to recognize a  number. It starts with one or more digits, possibly followed by an decimal point with zero or more digits after it. The scanner definition for this token is: 
<number>        :       [0-9]+ (\. [0-9]*) ? ; 

Enter that line into the scanner tab on the interface. Let's go over each part: 

<number> 

Names the token. The name inside the <> must be a legal Smalltalk variable name. 

:

Separates the name of the token from the token's definition. 

[0-9] 

Matches any single character in the range '0' to '9' (a digit). 

+

Matches the previous expression  one or more times. In this case, we are matching one or more digits. 

( ... ) 

Groups subexpressions. 

\. 

Matches the '.' character (. has a special meaning in regular expressions, \ quotes it). 

*

Matches the previous expression zero or more times. 

?

Matches the previous expression  zero or one time (i.e., it is optional). 

;

Terminates a token specification. 

We don't want to have to worry about whitespace in our language, so we need to define what a whitespace is and to ignore it. To do this, enter the following token specification on the next line on the scanner page: 
<whitespace>    :       \s+; 

\s matches any whitespace character (space, tab, linefeed, etc.). So how do  we tell the scanner to ignore it? If you look in the SmaCCScanner class, you will find a method named 'whitespace'. If a scanner understands a method that has the same name as a token name, that method will get called whenever the scanner matches that kind of token. As you can see, the whitespace method eats whitespace. There is also a 'comment' method that behaves similarly. 

The only other token that will appear in our system would be the '+' token for addition. However, since this is token is always the same, we don't have to tell the scanner what it looks like. It will figure it out from our grammar. 

Speaking of our grammar, let's go ahead and define it. Enter the following specification in the Parser tab: 
Expression : 
          Expression "+" Number
        | Number ;
Number : <number>; 

This basically says that an expressions is either a number  or an expression added to a number. 

We should be able to compile a parser now. Switch to the Compile tab. You need to enter the class name for both  the scanner and parser. Use CalculatorScanner and CalculatorParser respectively.  Once the class names are entered, we are ready to compile the parser. Press the  'Compile LALR(1)' button (you should always push this one unless you know what  you are doing. Basically, it will generate smaller parsers than the other  option). This will create new Smalltalk classes for the CalculatorScanner and  CalculatorParser and compile several methods in those classes. All methods that  SmaCC compiles will go into a "generated-*" method protocol. You should not  change those methods since they are replace each time you compile. 

Whenever SmaCC creates new classes, they are compiled in the default application/package. If you are using VisualAge,  you will need to make sure that the default application is an open edition and  that it prereqs the SmaCCRuntime application. 

If you have already created the scanner and parser classes, you can load their  definitions by using the "..." buttons next to the class name entry fields. If  you answer "Yes" to the dialog, the text in the scanner/parser tabs will be  replaced with the definition that was last compiled (assuming that the "Generate  definition comments" was checked during the last compile). 

Now we are ready to test our parser. Go to the test pane, enter 3 + 4, and press the parse button; you will see that the parser correctly parses it. If you press Parse and Inspect you will see and inspector on an OrderedCollection that contains the parsed tokens. This is because we haven't specified what the parser is supposed to do when it parses. You can also enter incorrect  items. For example, try to parse "3 + + 4" or "3 + a". An  error message should appear in the text. 

Now we need to define the actions that need to happen when we parse our  expressions. Currently, our parser is just validating that the expression is a  bunch of numbers added together. Generally, you will create some structure that  represents what you've parsed (e.g., a parse tree). However, in this case, we  are not concerned about the structure, but we are concerned about the result  (the value of the expression). For our example, you need to modify the grammar  definition to be: 
Expression : 
          Expression "+" Number {'1' + '3'} | Number {'1'} ;
Number : <number> {'1' value asNumber} ;

The text between the braces is Smalltalk code that gets evaluated when the rule is applied. Strings with a number get replaced with the corresponding parse node. In the first Expression rule, the '1' will get replaced by the ParseNode that matches Expression and the '3' gets replaced by the ParseNode that matches Number. The second item in the rule is the "+" token. Since we already know what  it is, it is not interesting. Compile the new parser. Now when you do a 'Parse  and Inspect' from the test pane, you should see the result: 7. 

One problem with the previous code is that if you need to change a rule then you  may also need to change the code for that rule. For example, suppose you  inserted a new token at the beginning of a rule, then you would need to change  all of your references in the Smalltalk code. We can alleviate this problem by  using named expressions. After each part of a rule, we can specify its name.  Names are specified with single quotes and must be legal Smalltalk variable  names. Doing this for our grammar we get: 
Expression : 
          Expression 'expression' "+" Number 'number' {expression + number} | Number 'number' {number} ;
Number : <number> 'numberToken' {numberToken value asNumber} ;

While this will result in the same language being parsed, it makes it easier  to maintain your parsers. Let's extend our language to add subtraction. Here's the new grammar: 
Expression : 
          Expression 'expression' "+" Number 'number' {expression + number} | Expression 'expression' "-" Number 'number' {expression - number} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

After you've compiled this, '3 + 4 - 2 ' should return '5'. Next, let's add multiplication and division: 
Expression : 
          Expression 'expression' "+" Number 'number' {expression + number}
        | Expression 'expression' "-" Number 'number' {expression - number} | Expression 'expression' "*" Number 'number' {expression * number}
        | Expression 'expression' "/" Number 'number' {expression / number} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

Here we run into a problem. If you evaluate '2 + 3 * 4' you end up with 20. The problem is that in standard mathematics, multiplication has a higher precedence than addition. Our grammar evaluates strictly left-to-right. The standard solution for this problem is to define additional nonterminals to force the sequence of evaluation. Our grammar with that solution would look like: 
Expression : 
          Term 'term' {term}
        | Expression 'expression' "+" Term 'term' {expression + term}
        | Expression 'expression' "-" Term 'term' {expression - term};
Term : 
          Number 'number' {number}
        | Term 'term' "*" Number 'number' {term * number}
        | Term 'term' "/" Number 'number' {term / number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

If you compile this grammar, you will see that '2 + 3 * 4' evaluates to 14 like we would expect. Now, as you can imagine, this gets pretty complicated as the number of precedence rules increases (e.g., C). We can use ambiguous grammars and precedence rules to simplify this situation. Here is the same grammar using precedence to enforce our evaluation order: 
%left "+" "-";
%left "*" "/"; Expression : 
          Expression 'exp1' "+" Expression 'exp2' {exp1 + exp2} | Expression 'exp1' "-" Expression 'exp2' {exp1 - exp2} | Expression 'exp1' "*" Expression 'exp2' {exp1 * exp2} | Expression 'exp1' "/" Expression 'exp2' {exp1 / exp2} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

Notice that we changed the grammar so that there are Expressions on both sides  of the operator.  The two lines that we added to the top of the grammar mean that + and - are evaluated left-to-right and have the same precedence, which is lower than * and /. Likewise, the second line means that * and / have equal precedence.  Grammars in this form are usually much more intuitive, especially in cases with many precedence levels. Just as an example, let's add exponentiation and parentheses: 
%left "+" "-";
%left "*" "/"; %right "^"; Expression : 
          Expression 'exp1' "+" Expression 'exp2' {exp1 + exp2}
        | Expression 'exp1' "-" Expression 'exp2' {exp1 - exp2}
        | Expression 'exp1' "*" Expression 'exp2' {exp1 * exp2}
        | Expression 'exp1' "/" Expression 'exp2' {exp1 / exp2} | Expression 'exp1' "^" Expression 'exp2' {exp1 raisedTo: exp2} | "(" Expression 'expression' ")" {expression} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

Once you have compiled the grammar, you will be able to evaluate '3 + 4 * 5 ^ 2  ^ 2' to get 2503. Since the exponent operator is right associative, this  expression is evaluated like 3 + (4 * (5 ^ (2 ^ 2))). We can also evaluate  expressions with parentheses. For example, evaluating '(3 + 4) * (5 - 2) ^ 3'  results in 189. 

The Scanner

Scanning takes an input stream of characters and converts that into a stream of tokens. The tokens are then passed on to the parsing phase. 

The scanner is specified by a collection of token specifications. Each token is specified by: 
    TokenName    :    RegularExpression ;

TokenName is a valid Smalltalk variable name that is surrounded by <>. For example, "<token>" is a valid TokenName, but "<token name>" is not since "token name" isn't a valid Smalltalk variable name. The RegularExpression is a regular expression that matches a token. It should match one or more characters in the input stream. The colon character, ":", is used to separate the TokenName and the RegularExpression, and the semicolon character, ";", is used to terminate the token specification. 


Regular Expression Syntax

While the rules are specified as regular expressions, there are many different syntaxes for regular expressions. We choose a relatively simple syntax that is specified below. If you wish to have a more rich syntax, you can modify the scanner's parser: SmaCCScannerScanner & SmaCCScannerParser. These classes were created using SmaCC. 
\character Matches a special character. The character immediately following the backslash is matched exactly, unless it is a letter. Backslash-letter combinations have other meanings and are specified below. 
\cLetter Matches a control character. Control characters are the first 26 characters (e.g., \cA equals "Character value: 0"). The letter that follows the "\c" must be an uppercase letter. 
\d Matches a digit, 0-9. 
\D Matches anything that is not a digit. 
\f Matches a form-feed character, "Character value: 12". 
\n Matches a newline character, "Character value: 10". 
\r Matches a carriage return character, "Character value: 13". 
\s Matches any whitespace character, [ \f\n\r\t\v]. 
\S Matches any non-whitespace character. 
\t Matches a tab, "Character value: 9". 
\v Matches a vertical tab, "Character value: 11" 
\w Matches any letter, number or underscore, [A-Za-z0-9_]. 
\W Matches anything that is not a letter, number or underscore. 
\xHexNumber Matches a character specified by the hex number following the "\x". The hex number must be at least one character long and no more than four characters for Unicode characters and two characters for non-Unicode characters. For example, "\x20" matches the space character (Character value: 16r20), and "\x1FFF" matches "Character value: 16r1FFF". 
<token> Copies the definition of <token> into the current regular expression. For example, if we have "<hexdigit> : \d | [A-F] ;", we can use <hexdigit> in a later rule: "<hexnumber> : <hexdigit> + ;". 
[characters] Matches one of the characters inside the []. This is a shortcut for the "|" operator. In addition to single characters, you can also specify character ranges with the "-" character. For example, "[a-z]" matches any lower case letter. 
[^characters] Matches any character not listed in the characters block. "[^a]" matches anything except for "a". 
# comment Creates a comment that is ignored by SmaCC. Everything from the # to the end of the line is ignored. 
exp1| exp2 Matches either exp1 or exp2. 
exp1 exp2 Matches exp1 followed by exp2. "\d \d" matches two digits. 
exp* Matches exp zero or more times. "0*" matches "" and "000". 
exp? Matches exp zero or one time. "0?" matches only "" or "0". 
exp+ Matches exp one or more times. "0+" matches "0" and "000", but not "". 
exp{min,max} Matches exp at least min times but no more than max times. "0{1,2}" matches only "0" or "00". It does not match "" or "000". 
(exp) Groups exp for precedence. For example, "(a b)*" matches "ababab". Without the parentheses, "a b *" would match "abbbb" but not "ababab". 

Since there are multiple ways to combine expressions, we need precedence rules for their combination. The or operator, "|", has the lowest precedence and the "*", "?", "+", and "{,}" operators have the highest precedence. For example, "a | b c *" matches "a" or "bcccc", but not "accc" or "bcbcbc". If you wish to match "a" or "b" followed by any number of c's, you need to use "(a | b) c *". 


Overlapping Tokens

Unlike T-Gen, SmaCC can handle overlapping tokens with any problems. For example, the following is a legal SmaCC scanner definition: 
	<variable>	: [a-zA-Z] \w* ;
	<any_character>	: . ;
This definition will match a variable or a single character. A variable can also be a single character [a-zA-Z], so the two tokens overlap. SmaCC handles overlapping characters by preferring the first token specified by the grammar. For example, an "a" could be a <variable> or an <any_character> token, but since <variable> is specified first, SmaCC will use it. 


Matching Methods

If your scanner has a method name that matches the name of the token, (e.g. whitespace), that method will get called upon a match of that type. The SmaCCScanner superclass already has a default implementation of #whitespace and #comment. These methods ignore those tokens by default. Matching methods can also be used to handle overlapping token classes. For example, in the C grammar, a type definition is the same as an identifier. The only way that they can be disambiguated is by looking up the name in the type table. In our example C parser, we have an IDENTIFIER method that is used to determine whether the token is really an IDENTIFIER or whether it is a TYPE_NAME. 


Unreferenced Tokens

If a token is not referenced from a grammar specification, it will not be included in the generated scanner, unless the token's name is also a name of a method (see previous section). This, coupled with the ability to do substitutions, allows you to have the equivalent of macros within your scanner specification. However, be aware that if you are simply trying to generate a scanner, you will have to make sure that you create a dummy parser specification that references all of the tokens that you want in the final scanner. 


Case Insensitive Scanning

You can specify that the scanner should ignore case differences by checking the "Ignore Case" option on the compile tab. If you have a language that is case insensitive and has several keywords, this can be a handy feature to have. For example, if you have "THEN" as a keyword in a case insensitive language, you would need to specify a token for then as "<then> : [tT] [hH] [eE] [nN] ;". This is a pain to enter correctly. When the ignore case option is checked, SmaCC will automatically convert "THEN" into "[tT][hH][eE][nN]". 


Unicode Characters

SmaCC compiles the scanner into a bunch of conditional tests on characters. Normally, it assumes that characters have values between 0 and 255, and it can make some optimizations based on this fact. With the "Allow Unicode Characters" option checked, it will assume that characters have values between 0 and 65535. 

The Parser
Parsing converts the stream of tokens provided by the scanner into some object. Normally, this object will be a parse tree, but it does not have to be a parse tree. For example, the SmaCC tutorial shows a calculator. This calculator does not produce a parse tree; it produces the result, a number. 

In SmaCC the parser is defined by the grammar specification entered in the 'Parser' tab. The grammar specification has two parts, an optional directives section and the production rules. The directives section is used to tell SmaCC how to handle ambiguous grammars as well as how it should generate the code for the parser. The production rules section contains the grammar for the parser and the code that executes when a production rule is matched. 


Directives

The optional directives section consists of a set of directives. The system currently has 5 directives. Each directive begins with a "%" character and the directive keyword, then lists a set of symbols, and finally ends with the semicolon character, ";". 


Ambiguous Grammars and Precedence

SmaCC can handle ambiguous grammars. Given an ambiguous grammar, SmaCC will produce some parser. However, it may not parse correctly. For an LR parser, there are two basic types of ambiguities, reduce/reduce conflicts and shift/reduce conflicts. Reduce/reduce conflicts are bad. SmaCC has no directives to handle them and just picks one of the choices. These conflicts normally require a rewrite of your grammar. 

On the other hand, shift/reduce conflicts can be handled by SmaCC without rewriting your grammar. When SmaCC encounters a shift/reduce conflict it will perform the shift action by default. However, you can control this action with the "%left", "%right", and "%nonassoc" directives. If a token has been declared in a "%left" directive, it means that the token is left-associative. Therefore, the parser will perform a reduce operation. However, if it has been declared as right-associative, it will perform a shift operation. A token defined as %nonassoc will produce an error if that is encountered during parsing. For example, you may want to specify that the equal operator, "=", is non-associative, so "a = b = c" is not parsed as a valid expression. All three directives are followed by a list of tokens. 

Additionally, the %left, %right, and %nonassoc directives allow precedence to be specified. The order of the directives specifies the precedence of the tokens. The higher precedence tokens appear on the higher line numbers. For example, the following directive section gives the precedence for the simple calculator in our tutorial: 
%left "+" "-";
%left "*" "/";
%right "^";
The "+" and "-" symbols appear on the first line and have the lowest precedence. They are also left-associative so "1 + 2 +3" will be evaluated as "(1 + 2) + 3". On the next line are the "*" and "/" symbols. Since they appear on a higher line number, they have higher precedence than the "+" and "-". Finally, on line three we have the "^" symbol. It has the highest precedence. Combining all the rules allows us to parse "1 + 2 * 3 / 4 ^ 2 ^ 3" as "1 + ((2 * 3) / (4 ^ (2 ^ 3)))". 


Start Symbols

By default, the left-hand side of the first grammar rule is the start symbol. If you want to multiple start symbols, then you can specify them by using the "%start" directive followed by the nonterminals that are additional start symbols. This is useful for creating two parsers with two grammars that are similar but slightly different. For example, consider a Smalltalk parser. You can parse methods, and you can parse expressions. These are two different operations, but have very similar grammars. Instead of creating two different parsers for parsing methods and expressions, we can specify one grammar that parses methods and also specify another starting position for parsing expressions. The StParser in the SmaCC Example Parsers package has an example of this. The StParser class>>parseMethod: uses the #startingStateForMethod position to parse methods and the StParser class>>parseExpression: uses the #startingStateForSequenceNode position to parse expressions. 


Id Methods

Internally, the various token types are represented as integers. However, there are times that you need to reference the various token types. For example, in the CScanner and CParser classes, the TYPE_NAME token is identical to the IDENTIFIER token. The IDENTIFIER matching method does a lookup in the type table and if it finds a type definition with the same name as the current IDENTIFIER, it want to return the TYPE_NAME token type. To determine what integer this is, the parser was created with an %id directive for <IDENTIFIER> and <TYPE_NAME>. This generates the IDENTIFIERId and TYPE_NAMEId methods on the scanner. These methods simply return the number representing that token type. See the C sample scanner and parser for a good example of how this is used. 


Production Rules

The production rules contains the grammar for the parser. The first production rule is considered to be the starting rule for the parser. Each production rule consists of a non-terminal symbol name followed by a ":" separator which is followed by a list of possible productions separated by vertical bar, "|", and finally terminated by a semicolon, ";". 

Each production consists of a sequence of non-terminal symbols, tokens, or keywords followed by some optional Smalltalk code enclosed in curly brackets, {}. Non-terminal symbols are valid Smalltalk variable names and must be defined somewhere in the parser definition. Forward references are valid. Tokens are enclosed in angle brackets as they are defined in the scanner (e.g., <token>) and keywords are enclosed in double-quotes (e.g., "then"). Keywords that contain double-quotes need to have two double-quotes per each double-quote in the keyword. For example, if you need a keyword for one double-quote character, you would need to enter """" (four double-quote characters). 

The Smalltalk code is evaluated whenever that production is matched. If the code is a zero or a one argument symbol, then that method is performed. For a one argument symbol, the argument is an OrderedCollection that contains one element for each item in the production. If the code isn't a zero or one argument symbol, then the code is executed and whatever is returned by the code is the result of the production. If no Smalltalk code is specified, then the default action is to execute the #reduceFor: method. This method converts all items into an OrderedCollection. If one of the items is another OrderedCollection, then all of its elements are added to the new collection. 

Inside the Smalltalk code you can refer to the values of each production item by using literal strings. The literal string, '1', refers the to value of the first production item. The values for tokens and keywords will be SmaCCToken objects. The value for all non-terminal symbols will be whatever the Smalltalk code evaluates to for that non-terminal symbol. 


Named Symbols

When entering the Smalltalk code, you can get the value for a symbol by using the literal strings (e.g., '2'). However, this creates difficulties when modifying a grammar. If you insert some symbol at the beginning of a production, then you will need to modify your Smalltalk code changing all literal string numbers. Instead you can name each symbol in the production and then refer to the name in the Smalltalk code. To name a symbol (non-terminal, token, or keyword), you need to add a quoted variable name after the symbol in the grammar. For example, "MySymbol : Expression 'expr' "+" <number> 'num' {expr + num} ;" creates two named variables. One for the non-terminal Expression and one for the <number> token. These variables are then used in the Smalltalk code. 


Extended Syntax

SmaCC also has some extended syntax that makes it easier to enter different grammars. Most of the additions are for the productions, but one change that is not for productions is the addition of "::=" as the separator between the non-terminal and the production. The production syntax enhancements are listed in the following table: 
Symbol ? Makes symbol optional. It is equivalent to defining a new production rule: "Optional_Symbol : Symbol {'1'} | {nil};". 
Symbol * or 
Symbol + Makes a repeating symbol. The "*" repeats zero or more times, and the "+" repeats one or more times. It is equivalent to defining a new production rule: "Repeat_Symbol : | Symbol;" for "*" and "Repeat_Symbol : Symbol | Repeat_Symbol Symbol ;" for "+". 
( Productions ) Groups the items in Productions. By itself it is not that useful, but it can be combined with the "?", "*", or "+". It is equivalent to defining "Group_Productions : Productions ;". 
[ Productions ] Equivalent to "( Productions ) ?". 
<% Productions %> Equivalent to "( Productions ) *" 


Parser Comments

The compile page has three options to generate comments. You should always select the "Generate definition comments". That saves the scanner and parser definition strings into the scanner and parser classes. It allows your grammar to be under the same version control system as your Smalltalk code. 

The other two comment options should not be needed unless you need to debug a parser generated. The "generate symbol comments" option will generate a comment that explains what each symbol is mapped to. When SmaCC compiles a grammar it converts all symbols into integers. This comment gives you the integer for each symbol. You may need this information if you have an incorrect scanner definition. For example, you may have overlapping token definitions and SmaCC is picking the wrong one (by default it picks the first one in your scanner definition). When you debug, you can inspect the SmaCCToken object and validate its "id" with those in the symbol comment. If they are different, then you have a bug in your scanner. 

Finally, the "generate item set comments" option should rarely be needed. It generates a listing of all LR(1) item sets in the parser. If you are familiar with LR parsing, then it might be interesting to look at. However, for a moderate sized grammar (e.g., Java), this comment can be a few MB in size. I would not recommend generating such comments when using ENVY -- you don't want to store a 10MB method in your library. For the calculator example in the tutorial, this comment is 9,000 characters long. 


Error Recovery

Normally, when the parser encounters an error, it raises the SmaCCParserError exception and parsing is immediately stopped. However, there are times when you may wish to try to parse more of the input. For example, if you are highlighting code, you do not want to stop highlighting at the first syntax error. Instead you may wish to attempt to recover after the statement separator -- the period ".". SmaCC uses the error symbol to specify where error recovery should be attempted. For example, we may have the following rule to specify a list of Smalltalk statements: 
	Statements : Expression | Statements "." Expression ;
If we wish to attempt recovery from a syntax error when we encounter a period, we can change our rule to be: 
	Statements : Expression | Statements "." Expression | error "." Expression ;
While the error recovery allows you to proceed parsing after a syntax error, it will not allow you to return a parse tree from the input. Once the input has been parsed with errors, it will raise a non-resumable SmaCCParserError. !

!SmaCCParserGenerator class methodsFor: 'flaps' stamp: 'mga 2/15/2003 13:01'!
flapButton
	| tuple |
	tuple _ {self name asSymbol. #prototypicalToolWindow. 'SmaCC parser generator'. 'UI of squeak SmaCC'}.
	^ IconicButton new
		initializeWithThumbnail: (PartsBin thumbnailForQuad: tuple)
		withLabel: tuple third
		andSend: tuple second
		to: (Smalltalk at: tuple first)! !

!SmaCCParserGenerator class methodsFor: 'class initialization' stamp: 'mga 2/8/2004 22:22'!
initialize
	ShowPrecedenceConflicts:=false.
	(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: [
		TheWorldMenu unregisterOpenCommand: 'SmaCC'.
		TheWorldMenu registerOpenCommand: {'SmaCC Generator'. {self. #open}}].
	self open
! !

!SmaCCParserGenerator class methodsFor: 'instance creation' stamp: 'mga 2/15/2003 13:05'!
new
	
	^super new initialize! !

!SmaCCParserGenerator class methodsFor: 'instance creation' stamp: 'mga 2/15/2003 13:02'!
open
	
	^self new openInWorld! !

!SmaCCParserGenerator class methodsFor: 'flaps' stamp: 'mga 2/15/2003 13:02'!
openFlapButton
	
	^self flapButton openInWorld
! !

!SmaCCParserGenerator class methodsFor: 'instance creation' stamp: 'mga 2/15/2003 13:02'!
prototypicalToolWindow
	
	"Answer an example of myself seen in a tool window, for the 
	benefit of 
	parts-launching tools"
	| aWindow |
	aWindow _ self new mainWindow.
	aWindow applyModelExtent.
	^ aWindow! !

!SmaCCParserGenerator class methodsFor: 'class initialization' stamp: 'mga 2/15/2003 13:03'!
windowColorSpecification
	"Answer a WindowColorSpec object that declares my preference"
	^ WindowColorSpec
		classSymbol: self name asSymbol
		wording: self name asSymbol
		brightColor: #lightBlue
		pastelColor: #paleBlue
		helpMessage: 'Squeak port UI of SmaCC'! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 15:51'!
acceptParserCode: aStringOrAText notifying: aRequestor 
| scannerText |
scannerText _ self scannerCodeHolder contentsMorph text.
	^ [SmaCCGrammarCompiler new buildScanner: scannerText andParser: aStringOrAText.
	true]
		on: SmaCCParserError
		do: [:ex | 
			self tabList selectTabNamed: 'Parser'.
			self
				displayError: ex description
				at: ex tag position
				notifying: aRequestor.
			ex return: false]! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 15:22'!
acceptScannerCode: aStringOrAText notifying: aRequestor 
	SmaCCScannerParser
		parse: aStringOrAText
		onError: [:aString :position | 
			| morph | 
			self tabList selectTabNamed: 'Scanner'.
			self
				displayError: aString
				at: position
				notifying: aRequestor.
			^ false].
	^ true! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/18/2003 19:54'!
acceptTestCode: aStringOrAText notifying: aRequestor 
	| class |
	class _ self parserClass.
	class isNil
		ifTrue: [PopUpMenu inform: 'No parser defined'.
			^ false].
^self parse! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'md 4/3/2003 14:07'!
addButtonsToTestPage: aTestPage 
	| aParserButton aParserInspectButton aParserExploreButton |
	aParserButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #parse.
	aParserButton hResizing: #spaceFill;
		 vResizing: #shrinkWrap;
		 color: Color white;
		 label: 'Parse'.
	aParserInspectButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #parseAndInspect.
	aParserInspectButton hResizing: #spaceFill;
		 vResizing: #shrinkWrap;
		 color: Color white;
		 label: 'Parse and inspect'.
	aParserExploreButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #parseAndExplore.
	aParserExploreButton hResizing: #spaceFill;
		 vResizing: #shrinkWrap;
		 color: Color white;
		 label: 'Parse and explore'.
	aTestPage
		addMorph: aParserButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 0.33 @ 1)
				offsets: (0 @ (1 - 25) corner: 0 @ 0));	
		addMorph: aParserInspectButton
		fullFrame: (LayoutFrame
				fractions: (0.33 @ 1 corner: 0.66 @ 1)
				offsets: (0 @ (1 - 25) corner: 0 @ 0));
		addMorph: aParserExploreButton
		fullFrame: (LayoutFrame
				fractions: (0.66 @ 1 corner: 1 @ 1)
				offsets: (0 @ (1 - 25) corner: 0 @ 0))! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'mga 2/15/2003 12:54'!
addCheckBoxesToCompilePage: aCompilePage
	#(#(#toggleIgnoreCase #ignoreCase 'Ignore Case') #(#toggleGenerateDefinitionComments #generateDefinitionComments 'Generate definition comments') #(#toggleGenerateSymbolComments #generateSymbolComments 'Generate symbol comments') #(#toggleGenerateItemSetComments #generateItemSetComments 'Generate item set comments') )
		withIndexDo: [:each :anIndex | 
			| aButton | 
			aButton _ UpdatingThreePhaseButtonMorph checkBox.
			aButton target: self;
				 actionSelector: each first;
				 arguments: #();
				 getSelector: each second;
				 position: 10 @ 40 + (anIndex * (0 @ 20)).
			aCompilePage addMorph: (each last asMorph position: 30 @ 40 + (anIndex * (0 @ 20));
					 yourself);
				 addMorph: aButton]! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/20/2003 17:57'!
addClassSelectorsToCompilePage: aCompilePage 
	| aScannerLabel aParserLabel |
	aScannerLabel _ 'Scanner class:' asMorph position: 10 @ 10.
	aParserLabel _ 'Parser class:' asMorph position: 10 @ 30.
	findScannerClassButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #findScannerClass.
	findScannerClassButton label: ' ... ';
		 color: Color white;
		 position: 410 @ 6.
	findParserClassButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #findParserClass.
	findParserClassButton label: ' ... ';
		 color: Color white;
		 position: 410 @ 26.
	scannerClassMorph _ TextMorph new newContents: '';
				 borderWidth: 0;
				 extent: 300 @ 70;
				 position: 100 @ 8.
	scannerClassMorph
		on: #keyStroke
		send: #updateWindowLabel
		to: self.
	scannerClassMorph addDependent: self.
	parserClassMorph _ TextMorph new newContents: '';
				 borderWidth: 0;
				 extent: 300 @ 70;
				 position: 100 @ 28.
	parserClassMorph
		on: #keyStroke
		send: #updateWindowLabel
		to: self.
	parserClassMorph addDependent: self.
	{aScannerLabel. aParserLabel. scannerClassMorph. parserClassMorph. findScannerClassButton. findParserClassButton}
		do: [:e | aCompilePage addMorph: e]! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'mga 2/15/2003 12:54'!
addCompileButtonsToCompilePage: aCompilePage 
	| aLALRButton aLR1Button | 
	aLALRButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #compileLALR1.
	aLALRButton label: 'Compile LALR(1)';
		 color: Color white;
		 position: 10 @ 140.
	aCompilePage addMorph: aLALRButton.
	aLR1Button _ PluggableButtonMorph
				on: self
				getState: nil
				action: #compileLR1.
	aLR1Button label: 'Compile LR(1)';
		 color: Color white;
		 position: 150 @ 140.
	aCompilePage addMorph: aLR1Button! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/20/2003 16:23'!
addMessageBoxToCompilePage: aCompilePage 
	aCompilePage addMorph: ('Messages:' asMorph position: 10 @ 180;
			 yourself).
	self conflictTextMorph: (PluggableTextMorph
				on: self
				text: #conflicts
				accept: nil
				readSelection: nil
				menu: nil).
	aCompilePage
		addMorph: (self conflictTextMorph)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (10 @ 200 corner: -10 @ -10))! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 14:20'!
addTextToTestPage: aTestPage 
	| aTestText |
	testCodeHolder _ SmaCCCodeHolder owner: self ownerAcceptSelector: #acceptTestCode:notifying:.
	aTestText _ testCodeHolder contentsMorph.
	aTestText setNameTo: 'Test';
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 color: Color transparent.
	aTestPage
		addMorph: aTestText
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ -25))! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 2/15/2003 12:55'!
choose: aString from: aCollection 
	| choice |
	choice _ (PopUpMenu labelArray: aCollection)
				startUpWithCaption: aString withCRs.
	choice > 0
		ifTrue: [^ aCollection at: choice].
	^ nil ! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 2/15/2003 12:55'!
compileLALR1
	
	self compile: #LALR1! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/18/2003 14:41'!
compileLR1
	self compile: #LR1! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'md 7/9/2005 19:33'!
compile: aSymbol 
	| grammar stream oldIgnoreCase oldCharacterSize parserCompiler |
	(self scannerClassString isEmpty
			or: [self parserClassString isEmpty])
		ifTrue: [^ PopUpMenu inform: 'Both classes are not specified'].
	Cursor read
		showWhile: [self verifySyntax
				ifFalse: [^ self]].
	Cursor wait
		showWhile: [oldIgnoreCase _ SmaCCGrammar ignoreCase.
			oldCharacterSize _ SmaCCGrammar maximumCharacterValue.
			[SmaCCGrammar ignoreCase: self ignoreCase;
				 maximumCharacterValue: 255.
			parserCompiler _ SmaCCGrammarCompiler new.
			parserCompiler buildScanner: self scannerText andParser: self parserText;
				 scannerClass: self scannerClassString;
				 parserClass: self parserClassString.
			grammar _ parserCompiler grammar.
			grammar type: aSymbol.
			stream _ WriteStream on: Text new.
			[parserCompiler createChanges.
			self generateDefinitionComments
				ifTrue: [parserCompiler compileDefinitionComments].
			self generateSymbolComments
				ifTrue: [parserCompiler compileSymbolComment].
			self generateItemSetComments
				ifTrue: [parserCompiler compileItemSetsComment].
			parserCompiler compileChanges]
				on: SmaCCCompilationNotification
				do: [:ex | 
					(ShowPrecedenceConflicts
							or: [('*precedence*' match: ex messageText) not])
						ifTrue: [stream nextPutAll: '-------------------------\' withCRs asText , ex messageText asText allBold;
								 cr;
								 cr;
								 nextPutAll: ex description;
								 cr;
								 nextPutAll: ex tag; cr;
								 cr.].
					ex pass].
			self conflicts: stream contents.
			self testText string withBlanksTrimmed notEmpty ifTrue: [self testCodeHolder hasUnacceptedEdits: true]]
				ensure: [SmaCCGrammar ignoreCase: oldIgnoreCase;
						 maximumCharacterValue: oldCharacterSize]]! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 16:00'!
conflicts
	conflicts isNil ifTrue: [conflicts:=String new].
	^conflicts! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 16:35'!
conflicts: aString 
	conflicts _ aString.
	self changed: #conflicts! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 16:22'!
conflictTextMorph
	^conflictTextMorph! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 16:22'!
conflictTextMorph: anObject
	conflictTextMorph := anObject! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:39'!
createCompilePage
	| aCompilePage |
	aCompilePage := (Morph new)
				layoutPolicy: ProportionalLayout new;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				setNameTo: 'Compile';
				color: Color transparent.
	self tabList addTabFor: aCompilePage font: TextStyle defaultFont.
	self
		addClassSelectorsToCompilePage: aCompilePage;
		addCompileButtonsToCompilePage: aCompilePage;
		addCheckBoxesToCompilePage: aCompilePage;
		addMessageBoxToCompilePage: aCompilePage! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:39'!
createParserPage
	| aParserPage |
	parserCodeHolder := SmaCCCodeHolder owner: self
				ownerAcceptSelector: #acceptParserCode:notifying:.
	aParserPage := parserCodeHolder contentsMorph.
	aParserPage
		setNameTo: 'Parser';
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent.
	self tabList addTabFor: aParserPage font: TextStyle defaultFont! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:39'!
createScannerPage
	| aScannerPage |
	scannerCodeHolder := SmaCCCodeHolder owner: self
				ownerAcceptSelector: #acceptScannerCode:notifying:.
	aScannerPage := scannerCodeHolder contentsMorph.
	aScannerPage
		setNameTo: 'Scanner';
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent.
	self tabList addTabFor: aScannerPage font: TextStyle defaultFont! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:40'!
createTabbedPalette
	self tabList: TabbedPalette new.
	self tabList tabsMorph color: Color white.
	self tabList tabsMorph hResizing: #spaceFill.
	self tabList tabsMorph highlightColor: Color red regularColor: Color blue.
	self mainWindow addMorph: self tabList frame: (0 @ 0 corner: 1 @ 1)! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:40'!
createTestPage
	| aTestPage |
	aTestPage := (Morph new)
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				setNameTo: 'Test';
				layoutPolicy: ProportionalLayout new;
				color: Color transparent;
				yourself.
	self tabList addTabFor: aTestPage font: TextStyle defaultFont.
	self addTextToTestPage: aTestPage.
	self addButtonsToTestPage: aTestPage! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/20/2003 16:01'!
createTutorialPage
	| aPage |
	tutorialTextHolder := SmaCCCodeHolder owner: self ownerAcceptSelector: nil.
	aPage _ tutorialTextHolder contentsMorph.
	tutorialTextHolder acceptContents: self tutorialText.
	tutorialTextHolder changed: #contents.
	aPage setNameTo: 'Tutorial';
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 color: Color transparent.
	self tabList addTabFor: aPage font: TextStyle defaultFont! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 18:20'!
defaultWindowLabelPrefix
	^ 'SmaCCParserGenerator'! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:40'!
delete
	self breakDependents.
	self tabList pages do: [:e | e breakDependents].
	^super delete! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/18/2003 20:22'!
displayError: aString at: position notifying: aRequestor 
	aRequestor selectFrom: position to: position - 1.
	aRequestor
		replaceSelectionWith: (Text string: aString , '->' attribute: TextEmphasis bold).
	aRequestor
		setSelection: (position to: position + aString size + 1)! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 18:09'!
findParserClass
	| className class text |
	self scannerClassString isEmpty
		ifTrue: [^ PopUpMenu inform: 'Undefined scanner class'].
	className _ self choose: 'What class do you want to use?' from: (SmaCCParser allSubclasses
					collect: [:c | c name]) asSortedCollection.
	className notNil
		ifTrue: [parserClassMorph hResizing: #rigid.
			parserClassMorph newContents: '';
				 newContents: className.
			parserClassMorph changed: #updateWindowLabel.
			class _ Smalltalk at: className asSymbol.
			(class class includesSelector: #parserDefinitionComment)
				ifTrue: [(PopUpMenu confirm: 'Do you wish to load the parser definition?')
						ifTrue: [text _ self
										removeCommentedPartOf: (class class sourceCodeAt: #parserDefinitionComment).
							self parserText: text]]]! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 18:09'!
findScannerClass
	| className class text |
	className _ self choose: 'What class do you want to use?' from: (SmaCCScanner allSubclasses
					collect: [:c | c name]) asSortedCollection.
	className notNil
		ifTrue: [scannerClassMorph newContents: '';
				 newContents: className.
			scannerClassMorph changed: #updateWindowLabel.
			class _ Smalltalk at: className asSymbol.
			(class class includesSelector: #scannerDefinitionComment)
				ifTrue: [(PopUpMenu confirm: 'Do you wish to load the scanner definition?')
						ifTrue: [text _ self
										removeCommentedPartOf: (class class sourceCodeAt: #scannerDefinitionComment).
							self scannerText: text]]]! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:27'!
generateDefinitionComments
	generateDefinitionComments isNil ifTrue: [generateDefinitionComments:=true].
	^generateDefinitionComments! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:27'!
generateItemSetComments
	generateItemSetComments isNil ifTrue: [generateItemSetComments:=false].
	^generateItemSetComments! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:27'!
generateSymbolComments
	generateSymbolComments isNil ifTrue: [generateSymbolComments:=false].
	^generateSymbolComments! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:26'!
ignoreCase
	ignoreCase isNil ifTrue: [ignoreCase:=false].
	^ignoreCase! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/20/2003 18:19'!
initialize
	mainWindow _ (SystemWindow labelled: self defaultWindowLabelPrefix)
				model: self.
	self createTabbedPalette.
	self createScannerPage.
	self createParserPage.
	self createCompilePage.
	self createTestPage.
	self createTutorialPage.
	self updateWindowLabel! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 2/15/2003 12:58'!
mainWindow
	
	^mainWindow! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/18/2003 13:40'!
openInWorld
	self mainWindow openInWorld.
	self tabList selectTabNamed: 'Compile'! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/23/2003 09:47'!
paneColorToUse
	^Color blue muchLighter! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/18/2003 20:03'!
parse
	self
		parseAndEvaluate: [:each | 
			PopUpMenu inform: 'Parses without errors'.
			^true]. ^false! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 16:13'!
parseAndEvaluate: aBlock 
	| class |
	self testCodeHolder acceptContents: self testText.
	self testCodeHolder changed: #contents.
	class _ self parserClass.
	class isNil
		ifTrue: [PopUpMenu inform: 'No parser defined'.
			^ false]
		ifFalse: [Cursor wait showWhile: [aBlock
				value: (class
						parse: self testText
						onError: [:aString :position | 
							self
								displayError: aString
								at: position
								notifying: self testCodeHolder contentsMorph.
							self testCodeHolder hasUnacceptedEdits: true.
							^ false])]].
	^ true! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'md 4/3/2003 14:03'!
parseAndExplore
	^self
			parseAndEvaluate: [:each | each explore]
! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/18/2003 20:01'!
parseAndInspect
	^self
			parseAndEvaluate: [:each | each inspect]
! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:47'!
parserClass
	| classname |
	classname := self parserClassString asSymbol.
	^classname notEmpty ifTrue: [Smalltalk at: classname]
! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 12:21'!
parserClassString
	^parserClassMorph contents string! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 10:43'!
parserCodeHolder
	^parserCodeHolder! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 10:43'!
parserCodeHolder: anObject
	parserCodeHolder := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 10:53'!
parserText
	^ self parserCodeHolder contents! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:25'!
parserText: text 
	self parserCodeHolder contents: text.
	self parserCodeHolder contentsMorph setText: text.
! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'mga 1/18/2003 14:42'!
removeCommentedPartOf: aString 
	| inStream outStream |
	inStream _ ReadStream on: aString.
	outStream _ WriteStream on: String new.
	inStream upTo: $".
	[inStream atEnd]
		whileFalse: [(inStream peekFor: $")
				ifTrue: [outStream nextPut: $"].
			outStream
				nextPutAll: (inStream upTo: $")].
	^ outStream contents! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 12:20'!
scannerClassString
	^scannerClassMorph contents string! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/17/2003 15:22'!
scannerCodeHolder
	^scannerCodeHolder! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/17/2003 15:22'!
scannerCodeHolder: anObject
	scannerCodeHolder := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/19/2003 09:55'!
scannerText
	^ self scannerCodeHolder contents! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:43'!
scannerText: text 
	self scannerCodeHolder contents: text.
	self scannerCodeHolder contentsMorph setText: text! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 16:32'!
tabList
	^tabList! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 13:40'!
tabList: anObject
	tabList := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:39'!
testCodeHolder
	^testCodeHolder! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:39'!
testCodeHolder: anObject
	testCodeHolder := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 19:36'!
testText
	^ self testCodeHolder contentsMorph text! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:25'!
toggleGenerateDefinitionComments
	generateDefinitionComments:=self generateDefinitionComments not! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:28'!
toggleGenerateItemSetComments
	generateItemSetComments:=self generateItemSetComments not! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:28'!
toggleGenerateSymbolComments
	generateSymbolComments:=self generateSymbolComments not! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:25'!
toggleIgnoreCase
	ignoreCase:= self ignoreCase not! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/23/2003 11:15'!
tutorialText
	^self class comment! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 18:19'!
updateWindowLabel
	| scannerLabel parserLabel |
	scannerLabel := self scannerClassString isEmpty ifFalse: [self scannerClassString] ifTrue: [' ? '].
	parserLabel := self parserClassString isEmpty ifFalse: [self parserClassString] ifTrue: [' ? '].
	^ self mainWindow setLabel: self defaultWindowLabelPrefix , ': ' ,  scannerLabel , '/' , parserLabel! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 18:14'!
update: anObjectOrASymbol 
	(anObjectOrASymbol isKindOf: Symbol)
		ifTrue: [(self respondsTo: anObjectOrASymbol)
				ifTrue: [self perform: anObjectOrASymbol]].
	super update: anObjectOrASymbol! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/20/2003 16:35'!
verifyParser
	| parserCode |
	parserCode _ self parserCodeHolder contentsMorph text.
	parserCode string withBlanksTrimmed isEmpty
		ifTrue: [PopUpMenu inform: 'Empty Parser code'.
			self tabList selectTabNamed: 'Parser'.
			^ false].
	self parserCodeHolder hasUnacceptedEdits
		ifTrue: [(self acceptParserCode: parserCode notifying: self parserCodeHolder contentsMorph)
				ifTrue: [self parserCodeHolder acceptContents: parserCode.
					self parserCodeHolder changed: #contents]
				ifFalse: [^ false]].
	^ true! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/20/2003 16:36'!
verifyScanner
	| scannerText |
	scannerText _ self scannerCodeHolder contentsMorph text.
	scannerText string withBlanksTrimmed isEmpty
		ifTrue: [PopUpMenu inform: 'Empty Scanner code'.
			self tabList selectTabNamed: 'Scanner'.
			^ false].
	self scannerCodeHolder hasUnacceptedEdits
		ifTrue: [(self acceptScannerCode: scannerText notifying: self scannerCodeHolder contentsMorph)
				ifTrue: [self scannerCodeHolder acceptContents: scannerText.
					self scannerCodeHolder changed: #contents.
					^ true].
			^ false].
	^ true! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/18/2003 10:37'!
verifySyntax
	self verifyScanner
		ifFalse: [^ false].
	self verifyParser ifFalse: [^false].
	^ true! !

Object subclass: #SmaCCRegularExpressionNode
	instanceVariableNames: 'action position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCRegularExpressionNode commentStamp: 'jmb' prior: 0!
SmaCCRegularExpressionNode represents a regular expression. The scanner is represented by a regular expression. These are the initial objects created in producing the scanner. From these nodes, we create a directed graph and then we compile the graph.

Subclasses must implement the following messages:
	accessing
		possibleMatchesSize
	private
		asNFAStartingWith:
		possibleMatchesDo:on:

Instance Variables:
	action	<SequenceableCollection>	the actions to be performed when we find a match
	position	<Integer>	the position of the RE in the scanner. If we have multiple matches, we prefer the ones listed first.!

SmaCCRegularExpressionNode subclass: #SmaCCCharacterRENode
	instanceVariableNames: 'characters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCCharacterRENode commentStamp: 'jmb' prior: 0!
SmaCCCharacterRENode represents a regular expression that matches one of a set of characters.

Instance Variables:
	characters	<SortedCollection of: Character>	The characters that this node can accept. Note that there are no duplicates and all characters are sorted.

!

!SmaCCCharacterRENode class methodsFor: 'instance creation' stamp: ''!
characters: aString 
	^(self new)
		characters: (self sortedCharactersFor: aString);
		yourself! !

!SmaCCCharacterRENode class methodsFor: 'private' stamp: ''!
sortedCharactersFor: aString 
	| characters stream |
	SmaCCGrammar ignoreCase 
		ifTrue: 
			[stream := WriteStream on: String new.
			aString do: 
					[:each | 
					stream
						nextPut: each asUppercase;
						nextPut: each asLowercase]]
		ifFalse: 
			[stream := WriteStream on: (String new: aString size).
			stream nextPutAll: aString].
	characters := stream contents 
				asSortedCollection: [:a :b | a asInteger < b asInteger].
	stream := WriteStream on: String new.
	characters inject: nil
		into: 
			[:sum :each | 
			sum = each ifFalse: [stream nextPut: each].
			each].
	^stream contents! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ''!
asNFAStartingWith: startNode 
	| endNode |
	endNode := SmaCCNode new.
	endNode action: action.
	startNode addEdgeTo: endNode on: characters.
	^endNode! !

!SmaCCCharacterRENode methodsFor: 'testing' stamp: ''!
canMergeWith: aScannerNode 
	^self class = aScannerNode class and: 
			[characters notNil 
				and: [aScannerNode characters notNil and: [self action = aScannerNode action]]]! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ''!
characters
	^characters! !

!SmaCCCharacterRENode methodsFor: 'initialize-release' stamp: ''!
characters: aString 
	characters := aString! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ''!
matchingCharacters
	^SmaCCGrammar ignoreCase 
		ifTrue: [characters reject: [:each | each isLowercase]]
		ifFalse: [characters]! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream 
	self matchingCharacters do: 
			[:each | 
			aStream nextPut: each.
			aBlock value.
			aStream skip: -1]! !

!SmaCCCharacterRENode methodsFor: 'accessing' stamp: ''!
possibleMatchesSize
	^self matchingCharacters size! !

!SmaCCCharacterRENode methodsFor: 'printing' stamp: 'jmb 1/23/2003 15:52'!
printCharacter: aCharacter on: aStream 
	(aCharacter asInteger between: 32 and: 126) 
		ifTrue: [^aStream nextPut: aCharacter].
	aStream nextPutAll: '\x'.
	aCharacter asInteger 
		printOn: aStream
		base: 16! !

!SmaCCCharacterRENode methodsFor: 'printing' stamp: ''!
printOn: aStream 
	| allCharacters |
	characters size = 1 
		ifTrue: [^self printCharacter: characters first on: aStream].
	aStream nextPut: $[.
	allCharacters := characters.
	characters size > 128 
		ifTrue: 
			[aStream nextPut: $^.
			allCharacters := ((0 to: SmaCCGrammar maximumCharacterValue) 
						collect: [:each | Character value: each]) 
							reject: [:each | characters includes: each]].
	allCharacters do: [:each | self printCharacter: each on: aStream].
	aStream nextPut: $]! !

!SmaCCCharacterRENode methodsFor: 'accessing' stamp: ''!
| aScannerNode 
	(self canMergeWith: aScannerNode) ifFalse: [^super | aScannerNode].
	characters := String 
				withAll: ((characters , aScannerNode characters) asSet 
						asSortedCollection: [:a :b | a asInteger < b asInteger]).
	^self! !

SmaCCRegularExpressionNode subclass: #SmaCCOrRENode
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCOrRENode commentStamp: 'jmb' prior: 0!
SmaCCOrRENode is a SmaCCRegularExpressionNode that represents an alternative.

Instance Variables:
	nodes	<Collection of: SmaCCRegularExpressionNode>	our possible choices!

!SmaCCOrRENode class methodsFor: 'instance creation' stamp: ''!
nodes: aCollection 
	^(self new)
		nodes: aCollection;
		yourself! !

!SmaCCOrRENode methodsFor: 'private' stamp: ''!
asNFAStartingWith: startNode 
	| endNode |
	endNode := SmaCCNode new.
	endNode action: action.
	nodes do: 
			[:each | 
			| componentStart |
			componentStart := SmaCCNode new.
			startNode addEdgeTo: componentStart.
			(each asNFAStartingWith: componentStart) addEdgeTo: endNode].
	^endNode! !

!SmaCCOrRENode methodsFor: 'initialize-release' stamp: ''!
nodes: aCollection 
	nodes := aCollection! !

!SmaCCOrRENode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream 
	nodes do: 
			[:each | 
			| pos |
			pos := aStream position.
			each possibleMatchesDo: aBlock on: aStream.
			aStream position: pos]! !

!SmaCCOrRENode methodsFor: 'accessing' stamp: ''!
possibleMatchesSize
	^nodes inject: 0 into: [:sum :each | sum + each possibleMatchesSize]! !

!SmaCCOrRENode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	nodes := nodes copy! !

!SmaCCOrRENode methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPut: $(.
	nodes do: [:each | each printOn: aStream]
		separatedBy: [aStream nextPutAll: ' | '].
	aStream nextPut: $)! !

!SmaCCOrRENode methodsFor: 'accessing' stamp: ''!
| aScannerNode 
	self action = aScannerNode action ifFalse: [^super | aScannerNode].
	nodes add: aScannerNode.
	^self! !

!SmaCCRegularExpressionNode class methodsFor: 'instance creation' stamp: ''!
new
	^(super new)
		initialize;
		yourself! !

!SmaCCRegularExpressionNode methodsFor: 'initialize-release' stamp: ''!
action
	^action! !

!SmaCCRegularExpressionNode methodsFor: 'initialize-release' stamp: ''!
action: aString
	action := aString! !

!SmaCCRegularExpressionNode methodsFor: 'converting' stamp: ''!
asDFA
	| startNode |
	startNode := SmaCCNode new.
	self asNFAStartingWith: startNode.
	^startNode asNFAWithoutEpsilonTransitions asDFA! !

!SmaCCRegularExpressionNode methodsFor: 'private' stamp: ''!
asNFAStartingWith: startNode 
	^self subclassResponsibility! !

!SmaCCRegularExpressionNode methodsFor: 'copying' stamp: 'jmb 1/21/2003 20:59'!
copy
	^(super copy) 
		postCopy; 
		yourself! !

!SmaCCRegularExpressionNode methodsFor: 'initialize-release' stamp: ''!
initialize! !

!SmaCCRegularExpressionNode methodsFor: 'testing' stamp: ''!
isKeywordLiteral
	self possibleMatchesSize < 50 ifFalse: [^false].
	self possibleMatchesDo: 
			[:each | 
			(each allSatisfy: [:char | char isAlphaNumeric or: [char == $_]]) 
				ifFalse: [^false]].
	^true! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
position
	^position! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
position: anInteger
	position := anInteger! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
possibleMatches
	| matches |
	matches := OrderedCollection new.
	self possibleMatchesDo: [:each | matches add: each].
	^matches! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
possibleMatchesDo: aBlock 
	| stream |
	stream := WriteStream on: String new.
	self possibleMatchesDo: [aBlock value: stream contents] on: stream! !

!SmaCCRegularExpressionNode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream 
	self subclassResponsibility! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
possibleMatchesSize
	^self subclassResponsibility! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
repeat
	^SmaCCRepeatingRENode component: self! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
repeatForAtLeast: minimum 
	^SmaCCRepeatingRENode component: self minimum: minimum! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
repeatFor: minimum to: maximum 
	^SmaCCRepeatingRENode 
		component: self
		minimum: minimum
		maximum: maximum! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
, aScannerNode 
	^SmaCCSequenceRENode nodes: (OrderedCollection with: self with: aScannerNode)! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ''!
| aScannerNode 
	^SmaCCOrRENode nodes: (OrderedCollection with: self with: aScannerNode)! !

SmaCCRegularExpressionNode subclass: #SmaCCRepeatingRENode
	instanceVariableNames: 'node minimumMatches maximumMatches'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCRepeatingRENode commentStamp: 'jmb' prior: 0!
SmaCCRepeatingRENode represents a repeating node in a regular expression.

Instance Variables:
	maximumMatches	<Integer>	the minimum number of matches required
	minimumMatches	<Integer>	the maximum number of matches allowed. An infinite amount of matches is represented by (SmaCCRepeatingRENode finiteInfinity).
	node	<SmaCCRegularExpressionNode>	what we need to match!

!SmaCCRepeatingRENode class methodsFor: 'instance creation' stamp: ''!
component: aScannerNode 
	^self component: aScannerNode minimum: 0! !

!SmaCCRepeatingRENode class methodsFor: 'instance creation' stamp: ''!
component: aScannerNode minimum: anInteger 
	^self 
		component: aScannerNode
		minimum: anInteger
		maximum: self finiteInfinity! !

!SmaCCRepeatingRENode class methodsFor: 'instance creation' stamp: ''!
component: aScannerNode minimum: minInteger maximum: maxInteger 
	^(self new)
		component: aScannerNode
			minimum: minInteger
			maximum: maxInteger;
		yourself! !

!SmaCCRepeatingRENode class methodsFor: 'constants' stamp: ''!
finiteInfinity
	"The number that we consider to be 'infinite'"

	^2147483648! !

!SmaCCRepeatingRENode methodsFor: 'private' stamp: ''!
asNFAStartingWith: startNode 
	| endNode start |
	endNode := SmaCCNode new.
	endNode action: action.
	start := startNode.
	minimumMatches timesRepeat: [start := node asNFAStartingWith: start].
	start addEdgeTo: endNode.
	maximumMatches < self class finiteInfinity 
		ifTrue: 
			[maximumMatches - minimumMatches timesRepeat: 
					[start := node asNFAStartingWith: start.
					start addEdgeTo: endNode]]
		ifFalse: [(node asNFAStartingWith: start) addEdgeTo: start].
	^endNode! !

!SmaCCRepeatingRENode methodsFor: 'initialize-release' stamp: ''!
component: aScannerNode minimum: minInteger maximum: maxInteger 
	node := aScannerNode.
	minimumMatches := minInteger.
	maximumMatches := maxInteger! !

!SmaCCRepeatingRENode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream 
	self 
		possibleMatchesDo: aBlock
		on: aStream
		startingAt: 1! !

!SmaCCRepeatingRENode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream startingAt: anInteger 
	(anInteger between: minimumMatches and: maximumMatches) 
		ifTrue: [aBlock value].
	anInteger = maximumMatches 
		ifTrue: [node possibleMatchesDo: aBlock on: aStream]
		ifFalse: 
			[node possibleMatchesDo: 
					[self 
						possibleMatchesDo: aBlock
						on: aStream
						startingAt: anInteger + 1]
				on: aStream]! !

!SmaCCRepeatingRENode methodsFor: 'accessing' stamp: ''!
possibleMatchesSize
	^node possibleMatchesSize * (maximumMatches - minimumMatches + 1)! !

!SmaCCRepeatingRENode methodsFor: 'printing' stamp: ''!
printOn: aStream 
	node printOn: aStream.
	maximumMatches = (1 bitShift: 31) 
		ifTrue: 
			[minimumMatches = 0 ifTrue: [^aStream nextPut: $*].
			minimumMatches = 1 ifTrue: [^aStream nextPut: $+].
			^aStream
				nextPut: ${;
				nextPutAll: minimumMatches printString;
				nextPutAll: ',}'].
	aStream
		nextPut: ${;
		nextPutAll: minimumMatches printString;
		nextPut: $,;
		nextPutAll: maximumMatches printString;
		nextPut: $}! !

SmaCCRegularExpressionNode subclass: #SmaCCSequenceRENode
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCSequenceRENode commentStamp: 'jmb' prior: 0!
SmaCCSequenceRENode represents a regular expression that is made up of several other regular expressions concatenated together.

Instance Variables:
	nodes	<Collection of: SmaCCRegularExpressionNode>	our children nodes in left-to-right order!

!SmaCCSequenceRENode class methodsFor: 'instance creation' stamp: ''!
nodes: aCollection 
	^(self new)
		nodes: aCollection;
		yourself! !

!SmaCCSequenceRENode methodsFor: 'private' stamp: ''!
asNFAStartingWith: startNode 
	| endNode |
	endNode := SmaCCNode new.
	endNode action: action.
	(nodes inject: startNode into: [:sum :each | each asNFAStartingWith: sum]) 
		addEdgeTo: endNode.
	^endNode! !

!SmaCCSequenceRENode methodsFor: 'initialize-release' stamp: ''!
nodes: aCollection 
	nodes := aCollection! !

!SmaCCSequenceRENode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream 
	self 
		possibleMatchesDo: aBlock
		on: aStream
		startingAt: 1! !

!SmaCCSequenceRENode methodsFor: 'private' stamp: ''!
possibleMatchesDo: aBlock on: aStream startingAt: anInteger 
	| node |
	node := nodes at: anInteger.
	nodes size = anInteger 
		ifTrue: [node possibleMatchesDo: aBlock on: aStream]
		ifFalse: 
			[node possibleMatchesDo: 
					[self 
						possibleMatchesDo: aBlock
						on: aStream
						startingAt: anInteger + 1]
				on: aStream]! !

!SmaCCSequenceRENode methodsFor: 'accessing' stamp: ''!
possibleMatchesSize
	^nodes inject: 1 into: [:sum :each | sum * each possibleMatchesSize]! !

!SmaCCSequenceRENode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	nodes := nodes copy! !

!SmaCCSequenceRENode methodsFor: 'printing' stamp: ''!
printOn: aStream 
	nodes do: [:each | each printOn: aStream] separatedBy: [aStream space]! !

!SmaCCSequenceRENode methodsFor: 'accessing' stamp: ''!
, aScannerNode 
	self action = aScannerNode action ifFalse: [^super , aScannerNode].
	nodes add: aScannerNode.
	^self! !

Object subclass: #SmaCCRHS
	instanceVariableNames: 'collection reduceAction variableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCRHS commentStamp: 'jmb' prior: 0!
SmaCCRHS represents the right hand side of the production.

Instance variables:
	collection	<OrderedCollection of: SmaCCSymbol> the collection of symbols that represent the rhs
	grammar <SmaCCGrammar> the grammar that the production is in
	variableNames	<Dictionary key: String value: Integer>	the name of each symbol in the rhs. These names can be used in the {} code blocks.!

!SmaCCRHS class methodsFor: 'instance creation' stamp: ''!
new
	^(super new)
		initialize;
		yourself! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
add: aGrammarSymbol 
	collection add: aGrammarSymbol! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
at: anInteger 
	^collection at: anInteger! !

!SmaCCRHS methodsFor: 'private' stamp: ''!
collection
	^collection! !

!SmaCCRHS methodsFor: 'reduction table' stamp: ''!
compileSourceFor: aGrammarSymbol in: aClass 
	| action rewriter parseTree methodName |
	action := self reduceAction.
	action isNil ifTrue: [^self defaultReduceAction].
	parseTree := RBParser parseExpression: action
				onError: 
					[:s :p | 
					SmaCCCompilationNotification 
						raiseRequestWith: aGrammarSymbol name , ' : ' , self printString 
								, '\\' withCRs , action
						errorString: 'Invalid Smalltalk code in reduction rule'.
					^self defaultReduceAction].
	(parseTree isLiteral and: 
			[parseTree value isSymbol and: 
					[parseTree value numArgs <= 1 and: [aClass definesMethod: parseTree value]]]) 
		ifTrue: [^parseTree value].
	rewriter := self parseTreeRewriter.
	rewriter executeTree: parseTree.
	parseTree := rewriter tree.
	methodName := ('reduceActionFor' 
				, (self safeMethodNameFor: aGrammarSymbol) 
					, (aGrammarSymbol positionOf: self) printString , ':') 
				asSymbol.
	parseTree isSequence 
		ifFalse: [parseTree := RBSequenceNode statements: (Array with: parseTree)].
	parseTree := RBMethodNode 
				selector: methodName
				arguments: (Array with: (RBVariableNode named: 'nodes'))
				body: parseTree.
	parseTree addReturn.
	aClass compile: parseTree formattedCode
		classified: 'generated-reduction actions'.
	^methodName! !

!SmaCCRHS methodsFor: 'private' stamp: ''!
defaultReduceAction
	^#reduceFor:! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
do: aBlock
	collection do: aBlock! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
firstTerminals
	| items |
	collection isEmpty ifTrue: [^Set with: SmaCCSymbol empty].
	items := Set new.
	1 to: collection size
		do: 
			[:index | 
			items addAll: (collection at: index) firstTerminals.
			(items includes: SmaCCSymbol empty) 
				ifTrue: [index < collection size ifTrue: [items remove: SmaCCSymbol empty]]
				ifFalse: [^items]].
	^items! !

!SmaCCRHS methodsFor: 'comparing' stamp: ''!
hash
	^self class hash bitXor: (collection hash bitShift: 14)! !

!SmaCCRHS methodsFor: 'initialize-release' stamp: ''!
initialize
	collection := OrderedCollection new.
	reduceAction := nil.
	variableNames := Dictionary new! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
nameLastItem: aString 
	variableNames at: aString put: collection size! !

!SmaCCRHS methodsFor: 'reduction table' stamp: ''!
parseTreeRewriter
	| rewriter |
	rewriter := ParseTreeRewriter new.
	1 to: self size
		do: 
			[:i | 
			rewriter replace: i printString storeString
				with: '(nodes at: ' , i printString , ')'].
	variableNames keysAndValuesDo: 
			[:key :value | 
			rewriter replace: key with: '(nodes at: ' , value printString , ')'].
	^rewriter! !

!SmaCCRHS methodsFor: 'printing' stamp: ''!
printOn: aStream 
	^collection do: [:each | each printOn: aStream]
		separatedBy: [aStream space]! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
reduceAction
	^reduceAction! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
reduceAction: anObject
	reduceAction := anObject! !

!SmaCCRHS methodsFor: 'reduction table' stamp: ''!
safeMethodNameFor: aGrammarSymbol 
	^aGrammarSymbol printString 
		collect: [:each | each isAlphaNumeric ifTrue: [each] ifFalse: [$X]]! !

!SmaCCRHS methodsFor: 'accessing' stamp: ''!
size
	^collection size! !

!SmaCCRHS methodsFor: 'comparing' stamp: ''!
= aRHS 
	^self class = aRHS class and: [collection = aRHS collection]! !

Object subclass: #SmaCCScannerCompiler
	instanceVariableNames: 'grammar scannerClass scannerDefinitionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCScannerCompiler commentStamp: 'jmb' prior: 0!
SmaCCScannerCompiler represents the compiler for the scanner part of the parser.

Instance Variables:
	grammar	<SmaCCGrammar>	the grammar that defines the scanner
	scannerClass	<RBAbstractClass>	the class to compile the scanner into
	scannerDefinitionString	<String>	the string that defines the scanner!

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'jmb 1/20/2003 21:22'!
addActionsForSymbols
	| selectorMap |
	selectorMap := Dictionary new.
	(1 to: self symbols size) with: self symbols
		do: 
			[:index :each | 
			each regularExpression ifNotNil: 
					[(self scannerActionFor: each name) 
						ifNotNil: [selectorMap at: index put: (self scannerActionFor: each name)].
					each regularExpression action: index].
			each createIdMethod ifTrue: [self compileTokenIdMethodFor: each]].
	^selectorMap! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
addSpecialSymbols
	grammar tokens keysDo: 
			[:each | 
			(self scannerActionFor: each) notNil 
				ifTrue: [grammar terminalSymbolNamed: each]]! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
compileEmptySymbolTokenId
	| stream |
	stream := WriteStream on: (String new: 100).
	stream
		nextPutAll: 'emptySymbolTokenId';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: (self symbols indexOf: SmaCCSymbol empty) printString.
	self scannerClass compile: stream contents classified: #'generated-tokens'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
compileErrorSymbolTokenId
	| stream |
	stream := WriteStream on: (String new: 100).
	stream
		nextPutAll: 'errorTokenId';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: (self symbols indexOf: SmaCCSymbol error) printString.
	self scannerClass compile: stream contents classified: #'generated-tokens'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
compileKeywordInitializerUsing: aDictionary selectorMap: selectorMapDictionary 
	| stream dataStream |
	aDictionary isEmpty ifTrue: [^self].
	stream := WriteStream on: String new.
	stream nextPutAll: 'initializeKeywordMap'.
	stream nextPutAll: ' keywordMap :=  Dictionary new. '.
	dataStream := WriteStream on: Array new.
	aDictionary keysAndValuesDo: 
			[:key :value | 
			value keys asSortedCollection do: 
					[:each | 
					dataStream nextPut: (Array 
								with: (selectorMapDictionary at: key ifAbsent: [key])
								with: each
								with: (selectorMapDictionary at: (value at: each) ifAbsent: [value at: each]))]].
	stream
		nextPutAll: '#(';
		cr.
	dataStream contents do: 
			[:each | 
			stream nextPutAll: '#('.
			each do: [:item | item storeOn: stream] separatedBy: [stream nextPut: $ ].
			stream nextPut: $)]
		separatedBy: [stream cr].
	stream nextPut: $).
	stream 
		nextPutAll: ' do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last]. ^keywordMap'.
	scannerClass metaclass 
		compile: (RBParser parseMethod: stream contents) formattedCode
		classified: #'generated-initialization'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
compileScanner
	| regex selectorMap regexPartition dfa keywordmap |
	regex := nil.
	self addSpecialSymbols.
	grammar 
		symbols: (self symbols asSortedCollection: 
					[:a :b | 
					| aRegex bRegex |
					aRegex := a regularExpression.
					bRegex := b regularExpression.
					bRegex isNil or: 
							[aRegex notNil 
								and: [(aRegex position ifNil: [0]) < (bRegex position ifNil: [0])]]]).
	selectorMap := self addActionsForSymbols.
	regexPartition := self regularExpressionsPartitionedByIsKeyword.
	regex := self generalRegexesFrom: regexPartition.
	dfa := regex asDFA.
	keywordmap := Dictionary new.
	(regexPartition at: true ifAbsent: [#()]) do: 
			[:each | 
			| action strings newAction |
			strings := each possibleMatches.
			1 to: strings size
				do: 
					[:i | 
					newAction := dfa simulate: (ReadStream on: (strings at: i)).
					i = 1 
						ifTrue: [action := newAction]
						ifFalse: [action = newAction ifFalse: [action := nil]]].
			action isNil 
				ifTrue: [regex := regex | each]
				ifFalse: 
					[action do: 
							[:state | 
							strings do: 
									[:string | 
									(keywordmap at: state ifAbsentPut: [Dictionary new]) at: string
										put: each action]]]].
	self compileKeywordInitializerUsing: keywordmap selectorMap: selectorMap.
	regex asDFA compileInto: scannerClass usingSelectorMap: selectorMap.
	self compileEmptySymbolTokenId.
	self compileErrorSymbolTokenId.
	SmaCCGrammar ignoreCase 
		ifTrue: 
			[scannerClass compile: 'keywordFor: aString 
	^aString asUppercase'
				classified: #'generated-scanner']! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
compileScannerDefinitionComment
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: 'scannerDefinitionComment';
		cr;
		cr;
		tab;
		nextPut: $";
		nextPutAll: (scannerDefinitionString copyReplaceAll: '"' with: '""');
		nextPut: $".
	self scannerClass metaclass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
compileTokenIdMethodFor: aTerminalSymbol 
	| stream |
	stream := WriteStream on: (String new: 1000).
	stream
		nextPutAll: (aTerminalSymbol name copyFrom: 2
					to: aTerminalSymbol name size - 1);
		nextPutAll: 'Id';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: (self symbols indexOf: aTerminalSymbol) printString.
	scannerClass compile: stream contents classified: #'generated-tokens'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
generalRegexesFrom: regexPartition 
	| regexs combinedRegex |
	regexs := regexPartition at: false ifAbsent: [regexPartition at: true].
	combinedRegex := regexs first.
	2 to: regexs size
		do: [:i | combinedRegex := combinedRegex | (regexs at: i)].
	^combinedRegex! !

!SmaCCScannerCompiler methodsFor: 'initialize-release' stamp: ''!
grammar: aGrammar
	grammar := aGrammar! !

!SmaCCScannerCompiler methodsFor: 'initialize-release' stamp: ''!
parseTokens
	grammar tokens: (SmaCCScannerParser parse: scannerDefinitionString)! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'jmb 1/20/2003 21:22'!
regularExpressionsPartitionedByIsKeyword
	| regexPartition |
	regexPartition := Dictionary new.
	self symbols do: 
			[:each | 
			each regularExpression ifNotNil: 
					[(regexPartition at: each regularExpression isKeywordLiteral
						ifAbsentPut: [OrderedCollection new]) add: each regularExpression]].
	^regexPartition! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ''!
scannerActionFor: aString 
	| selector |
	aString size > 2 ifFalse: [^nil].
	selector := (aString copyFrom: 2 to: aString size - 1) asSymbol.
	^((scannerClass definesMethod: selector) 
		and: [(Object canUnderstand: selector) not and: [selector numArgs = 0]]) 
			ifTrue: [selector]
			ifFalse: [nil]! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ''!
scannerClass
	^scannerClass! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ''!
scannerClass: anObject
	scannerClass := anObject! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ''!
scannerDefinitionString: aString
	scannerDefinitionString := aString! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ''!
symbols
	^grammar symbols! !

Object subclass: #SmaCCSymbol
	instanceVariableNames: 'name precedence firstItems'
	classVariableNames: 'ErrorSymbol EmptySymbol SentinelSymbol'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCSymbol commentStamp: 'jmb' prior: 0!
SmaCCSymbol is an abstract class that represents a symbol in the grammar.

Subclasses must implement the following messages:
	accessing
		calculateFirstTerminals
	testing
		isTerminal

Instance Variables:
	firstItems	<Collection of: SmaCCTerminalSymbol>	the first terminals that can be produced from us
	name	<String>	our name
	precedence	<Integer>	our precedence (in case of shift/reduce conflicts)

!

SmaCCSymbol subclass: #SmaCCNonTerminalSymbol
	instanceVariableNames: 'productions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCNonTerminalSymbol commentStamp: 'jmb' prior: 0!
SmaCCNonTerminalSymbol represents a non-terminal symbol in our grammar.

Instance Variables:
	productions	<SequenceableCollection of: SmaCCRHS>	our rhs' for the symbol!

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ''!
addProduction: aRHS
	productions add: aRHS! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ''!
calculateFirstTerminals
	| initialSize |
	initialSize := firstItems size.
	productions isEmpty 
		ifTrue: [firstItems add: self class empty]
		ifFalse: [productions do: [:each | firstItems addAll: each firstTerminals]].
	^initialSize ~= firstItems size! !

!SmaCCNonTerminalSymbol methodsFor: 'testing' stamp: ''!
isEmpty
	^productions isEmpty! !

!SmaCCNonTerminalSymbol methodsFor: 'testing' stamp: ''!
isTerminal
	^false! !

!SmaCCNonTerminalSymbol methodsFor: 'initialize-release' stamp: ''!
name: aString 
	super name: aString.
	productions := OrderedCollection new! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ''!
positionOf: aRHS 
	^productions indexOf: aRHS! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ''!
productionsDo: aBlock 
	productions do: aBlock! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ''!
size
	^productions size! !

SmaCCNonTerminalSymbol subclass: #SmaCCStartingSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCStartingSymbol commentStamp: 'jmb' prior: 0!
SmaCCStartingSymbol is the starting symbol in the grammar. A grammar can only have one starting symbol, but it can have may different starting item sets.!

!SmaCCStartingSymbol methodsFor: 'accessing' stamp: ''!
asLRItemSet
	| itemSet |
	itemSet := SmaCCItemSet new.
	productions do: 
			[:each | 
			itemSet add: (SmaCCLR1Item 
						symbol: self
						rhs: each
						follow: ((SmaCCSymbolSet new)
								add: self class empty;
								yourself))].
	^itemSet! !

!SmaCCStartingSymbol methodsFor: 'accessing' stamp: ''!
compileName
	^(productions first at: 1) name copy replaceAll: $_ with: $X! !

!SmaCCStartingSymbol methodsFor: 'testing' stamp: ''!
isStartingSymbol
	^true! !

!SmaCCSymbol class methodsFor: 'instance creation' stamp: ''!
empty
	EmptySymbol isNil 
		ifTrue: [EmptySymbol := SmaCCTerminalSymbol name: 'E O F'].
	^EmptySymbol! !

!SmaCCSymbol class methodsFor: 'instance creation' stamp: ''!
error
	ErrorSymbol isNil 
		ifTrue: [ErrorSymbol := SmaCCTerminalSymbol name: 'error'].
	^ErrorSymbol! !

!SmaCCSymbol class methodsFor: 'instance creation' stamp: ''!
name: aString 
	^(self new)
		name: aString;
		yourself! !

!SmaCCSymbol class methodsFor: 'instance creation' stamp: ''!
releaseObjects
	EmptySymbol := nil.
	SentinelSymbol := nil! !

!SmaCCSymbol class methodsFor: 'instance creation' stamp: ''!
sentinel
	SentinelSymbol isNil 
		ifTrue: [SentinelSymbol := SmaCCTerminalSymbol name: 'S e n t i n e l'].
	^SentinelSymbol! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
calculateFirstTerminals
	^self subclassResponsibility! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
createIdMethod
	^false! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
firstTerminals
	^firstItems! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
isEmptySymbol
	^self = self class empty! !

!SmaCCSymbol methodsFor: 'testing' stamp: ''!
isStartingSymbol
	^false! !

!SmaCCSymbol methodsFor: 'testing' stamp: ''!
isTerminal
	^self subclassResponsibility! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
name
	^name! !

!SmaCCSymbol methodsFor: 'initialize-release' stamp: ''!
name: aString 
	name := aString.
	firstItems := Set new! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
precedence
	^precedence! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
precedence: anInteger
	precedence := anInteger! !

!SmaCCSymbol methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: name! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
productionsDo: aBlock! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ''!
regularExpression
	^nil! !

!SmaCCSymbol methodsFor: 'accessing' stamp: 'jmb 1/21/2003 17:11'!
size
	^0! !

SmaCCSymbol subclass: #SmaCCTerminalSymbol
	instanceVariableNames: 'regularExpression createIdMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCTerminalSymbol commentStamp: 'jmb' prior: 0!
SmaCCTerminalSymbol represents a terminal symbol in our grammar.

Instance Variables:
	createIdMethod	<Boolean>	should we create a symbolNameId method for this symbol.
	regularExpression	<SmaCCRegularExpression>	our regular expression that we must match for this terminal symbol!

!SmaCCTerminalSymbol methodsFor: 'private' stamp: ''!
calculateFirstTerminals
	^false! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ''!
createIdMethod
	^createIdMethod! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ''!
createIdMethod: aBoolean
	createIdMethod := aBoolean! !

!SmaCCTerminalSymbol methodsFor: 'testing' stamp: ''!
isTerminal
	^true! !

!SmaCCTerminalSymbol methodsFor: 'initialize-release' stamp: ''!
name: aString 
	super name: aString.
	firstItems add: self.
	createIdMethod := false! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ''!
regularExpression
	^regularExpression! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ''!
regularExpression: aScannerNode
	regularExpression := aScannerNode! !

Model subclass: #SmaCCSymbolSet
	instanceVariableNames: 'symbols components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCSymbolSet commentStamp: 'jmb' prior: 0!
SmaCCSymbolSet represents a set of follow symbols in the LALR(1) item sets.

Instance Variables:
	components	<Collection of: SmaCCSymbolSet>	other SmaCCSymbolSets that we depend on, we include all items in these sets also
	symbols	<Collection of: SmaCCTerminalSymbol>	our follow symbols!

!SmaCCSymbolSet class methodsFor: 'instance creation' stamp: ''!
basedOn: aSymbolSet 
	^(self new)
		baseOn: aSymbolSet;
		yourself! !

!SmaCCSymbolSet class methodsFor: 'instance creation' stamp: ''!
new
	^(super new)
		initialize;
		yourself! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ''!
addAll: aCollection 
	| oldSize |
	oldSize := symbols size.
	symbols addAll: aCollection.
	oldSize ~= symbols size ifTrue: [self changed]! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ''!
addComponentsFrom: aSymbolSet 
	aSymbolSet components do: [:each | self addComponent: each]! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ''!
addComponent: each 
	(each = self or: [components includes: each]) ifTrue: [^self].
	components add: each.
	each addDependent: self.
	self addAll: each symbols! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ''!
add: aSymbol 
	(symbols includes: aSymbol) ifTrue: [^self].
	symbols add: aSymbol.
	self changed! !

!SmaCCSymbolSet methodsFor: 'testing' stamp: ''!
allSatisfy: aBlock 
	^symbols allSatisfy: aBlock! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ''!
baseOn: aSymbolSet 
	self addComponent: aSymbolSet.
	self addAll: aSymbolSet symbols! !

!SmaCCSymbolSet methodsFor: 'updating' stamp: 'jmb 1/21/2003 17:17'!
changed
	self dependents do: 
			[:each | 
			each 
				update: nil
				with: nil
				from: self]! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ''!
components
	^components! !

!SmaCCSymbolSet methodsFor: 'testing' stamp: ''!
includes: aSymbol 
	^symbols includes: aSymbol! !

!SmaCCSymbolSet methodsFor: 'initialize-release' stamp: ''!
initialize
	symbols := Set new.
	components := Set new! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ''!
mergeWith: aSymbolSet 
	self addAll: aSymbolSet symbols.
	self addComponentsFrom: aSymbolSet! !

!SmaCCSymbolSet methodsFor: 'printing' stamp: ''!
printOn: aStream 
	symbols do: [:each | aStream nextPutAll: each printString]
		separatedBy: [aStream space]! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: 'jmb 1/21/2003 17:06'!
size
	^symbols size! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ''!
symbols
	^symbols! !

!SmaCCSymbolSet methodsFor: 'updating' stamp: ''!
update: anAspectSymbol with: aParameter from: aSender 
	(components includes: aSender) ifTrue: [self addAll: aSender symbols]! !

Notification subclass: #SmaCCCompilationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCCompilationNotification commentStamp: 'jmb' prior: 0!
SmaCCCompilationNotification is a notification that is raised when we discover a problem with the parser. For example, a shift/reduce conflict will raise this notification.!

!SmaCCCompilationNotification class methodsFor: 'as yet unclassified' stamp: 'md 7/9/2005 19:29'!
raiseRequestWith: tag errorString: aString
	self new
		tag: tag; 
		signal: aString.! !

TestCase subclass: #LineNumberStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!LineNumberStreamTest methodsFor: 'private' stamp: ''!
addCRLFsTo: aString 
	^aString copyReplaceAll: '\'
		with: (String with: Character cr with: Character lf)! !

!LineNumberStreamTest methodsFor: 'private' stamp: ''!
addCRsTo: aString 
	^aString copyReplaceAll: '\' with: (String with: Character cr)! !

!LineNumberStreamTest methodsFor: 'private' stamp: ''!
addLFsTo: aString 
	^aString copyReplaceAll: '\' with: (String with: Character lf)! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testCRLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRLFsTo: '1\2\3\4')).
	1 to: 4
		do: 
			[:each | 
			self assert: stream lineNumber = each.
			stream upTo: Character lf]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testCRLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRsTo: '1\2\3\4')).
	1 to: 4
		do: 
			[:each | 
			self assert: stream lineNumber = each.
			stream upTo: Character cr]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testEmptyLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRsTo: '\\\')).
	1 to: 4
		do: 
			[:each | 
			self assert: stream lineNumber = each.
			stream upTo: Character cr]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testForwardPositionCRLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRLFsTo: '1\2\3\4')).
	stream position: 3.
	self assert: stream lineNumber = 2! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addLFsTo: '1\2\3\4')).
	1 to: 4
		do: 
			[:each | 
			self assert: stream lineNumber = each.
			stream upTo: Character lf]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testNoLines
	| stream |
	stream := SmaCCLineNumberStream on: (ReadStream on: 'this is a test').
	self assert: stream lineNumber = 1.
	stream do: [:each | self assert: stream lineNumber = 1]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testPositionCRLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRLFsTo: '1\2\3\4')).
	self assert: stream lineNumber = 1.
	stream upTo: $5.
	self assert: stream lineNumber = 4.
	stream position: 0.
	self assert: stream lineNumber = 1.
	stream position: 3.
	self assert: stream lineNumber = 2! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ''!
testPositionCRLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRsTo: '1\2\3\4')).
	self assert: stream lineNumber = 1.
	stream upTo: $5.
	self assert: stream lineNumber = 4.
	stream skip: -1.
	self assert: stream lineNumber = 4.
	stream position: 0.
	self assert: stream lineNumber = 1.
	stream position: 2.
	self assert: stream lineNumber = 2! !

TestCase subclass: #ParserGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
expressionParserString
	^'
%left "+" "-" ;
%left "*" "/" ;
%right "^" ;

Expression: Expression ''first'' "+" Expression ''last'' {first + last}
	| Expression "-" Expression {''1'' - ''3''}
	| Expression "*" Expression {''1'' * ''3''}
	| Expression "/" Expression {''1'' / ''3''}
	| Expression "^" Expression {''1'' raisedTo: ''3''} 
	| "(" Expression ")" {''2''}
	| <number> {''1'' value asNumber};'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
expressionScannerString
	^'
<number>	:	[0-9]+ (\. [0-9]+) ? ;
<whitespace>	:	\s+;'! !

!ParserGeneratorTest methodsFor: 'private' stamp: ''!
removeAllSelectorsFrom: class 
	class selectors do: [:each | class removeSelector: each]! !

!ParserGeneratorTest methodsFor: 'private' stamp: ''!
supportsUnicodeStrings
	^
	[String with: (Character value: 16rFF00).
	true] on: Error
			do: [:ex | ex return: false]! !

!ParserGeneratorTest methodsFor: 'initialize-release' stamp: 'jmb 1/20/2003 21:34'!
tearDown
	self
		removeAllSelectorsFrom: TestParser;
		removeAllSelectorsFrom: TestParser class;
		removeAllSelectorsFrom: TestScanner;
		removeAllSelectorsFrom: TestScanner class.
	super tearDown! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testBadCharacterBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	self should: 
			[parserCompiler buildScanner: '<foo> : [a-] ;' andParser: 'Start : <foo>;'.
			parserCompiler compileInto: TestScanner andParser: TestParser]
		raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testBadSmalltalkBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	self should: 
			[parserCompiler buildScanner: '<foo> : foo ;' andParser: 'Start : <foo> {self printOn: };'.
			parserCompiler compileInto: TestScanner andParser: TestParser]
		raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testBraceRepeatToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <%<IDENTIFIER>%>;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self 
		assert: ((TestParser parse: 'a b c') collect: [:each | each value]) asArray 
				= #('a' 'b' 'c').
	self assert: (TestParser parse: '') size = 0! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testBracketOptionalToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> [":"] begin {''1'' value , ''3''} | <IDENTIFIER> {''1'' value};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileDefinitionComments;
		compileItemSetsComment;
		compileSymbolComment.
	self assert: (TestParser parse: 'a b : c') = 'abc'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testErrors
	| parserCompiler position |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: self expressionScannerString
		andParser: self expressionParserString.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	TestParser parse: '+3*4' onError: [:str :pos | position := pos].
	self assert: position = 1.
	TestParser parseStream: (ReadStream on: '1+a+4')
		onError: [:str :pos | position := pos].
	self assert: position = 3! !

!ParserGeneratorTest methodsFor: 'testing' stamp: 'jmb 1/21/2003 14:37'!
testErrorToken
	| parserCompiler countingBlock |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<name> : [a-zA-Z]+; <whitespace>: \s+;'
		andParser: '%left "+"; Expression : <name> | Expression "+" Expression {[Notification signal] on: Error do: [:ex | ex return: (Notification raise)]} | error "+" Expression ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	countingBlock := 
			[:string | 
			| count |
			count := 0.
			
			[[TestParser parse: string] on: Notification
				do: 
					[:ex | 
					count := count + 1.
					ex resume]] 
					on: SmaCCParserError
					do: [:ex | ex return].
			count].
	#(#('a + b + c' 2) #('+ a + b + c' 2) #('a + b +' 1) #('a + 1 / 2 + b + c + 3' 2) #('1 + 1 / 2 + b + c + 3' 1)) 
		do: [:each | self assert: (countingBlock value: each first) = each last]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testExpressions
	#(#LR1 #LALR1) do: 
			[:each | 
			| parserCompiler |
			parserCompiler := SmaCCGrammarCompiler new.
			parserCompiler grammar type: each.
			parserCompiler buildScanner: self expressionScannerString
				andParser: self expressionParserString.
			parserCompiler compileInto: TestScanner andParser: TestParser.
			self assert: (TestParser parse: '2 + 3 * 4 / 5 ^ 3 ^ 2') 
						= (2 + (3 * 4 / (5 raisedTo: (3 raisedTo: 2)))).
			self assert: (TestParser parse: '1.0*2/3+4.0^2^3+3') 
						= (1.0 * 2 / 3 + (4.0 raisedTo: (2 raisedTo: 3)) + 3).
			self assert: (TestParser parse: '(((1 + 2) * 3) ^ 2) ^ 3') 
						= (((1 + 2) * 3 raisedTo: 2) raisedTo: 3)]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testIgnoreCaseKeywords
	| parserCompiler case |
	case := SmaCCGrammar ignoreCase.
	SmaCCGrammar ignoreCase: true.
	
	[parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<identifier> : [a-z_]+ ; <whitespace> : \s+ ;'
		andParser: 'Start ::= "Foo" {true} | <identifier> <identifier> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'FOo').
	self deny: (TestParser parse: 'FoObAr ASDS')] 
			ensure: [SmaCCGrammar ignoreCase: case]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testInvertedCharactersBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<A> : a{1,3} ;
						<ID> : [^a]+ ;
						<comment> : \s+ ;'
		andParser: 'begin : {0} | begin <A> {''1'' + 1} | begin <ID> {''1'' - 1};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'aa') = 1.
	self assert: (TestParser parse: 'aaaa') = 2.
	self assert: (TestParser parse: 'a bab') = 0! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testKeywords
	| parserCompiler size case |
	size := SmaCCGrammar maximumCharacterValue.
	case := SmaCCGrammar ignoreCase.
	SmaCCGrammar ignoreCase: true.
	self supportsUnicodeStrings 
		ifTrue: [SmaCCGrammar maximumCharacterValue: (2 raisedTo: 16) - 1].
	
	[parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '' andParser: 'Start ::= "Foo" "bar";'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	TestParser parse: 'FoObAr'] 
			ensure: 
				[SmaCCGrammar
					ignoreCase: case;
					maximumCharacterValue: size]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testLALRErrorHandler
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<whitespace> : \s+ ;'
		andParser: 'Start : Foo "]" Foo ")";
					Foo : "a" Bar ;
					Bar : "b" | error ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: 'a ] a b )'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a ) a b )'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a b ] a  ]'] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testMultipleStartingPositions
	| parserCompiler position |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<name> : \w+;'
		andParser: '%start plus ;

					multiply: plus "*" plus {true};
					plus: <name> {false} | <name> "+" <name> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'a*a').
	self assert: (TestParser parse: 'a+a*a').
	self should: [TestParser parse: 'a+a'] raise: SmaCCParserError.
	self 
		deny: (TestParser parse: 'a+a' startingAt: TestParser startingStateForplus).
	TestParser 
		parse: 'a*a'
		startingAt: TestParser startingStateForplus
		onError: [:str :pos | position := pos].
	self assert: position = 2! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testNonAssociativeTokens
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<IDENTIFIER> : \w+ ; <whitespace> : \s+ ;'
		andParser: '%left "and" ;
					%nonassoc "=" "<=";
					%left "+" ;

					expr : expr "=" expr {true} | expr "<=" expr {true} | expr "and" expr {true} | expr "+" expr {true} | <IDENTIFIER> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: 'a=b=c'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a=b<=c'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a=b+c=d'] raise: SmaCCParserError.
	self assert: (TestParser parse: 'a=b and c=d')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testOptionalToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> ":" ? begin {''1'' value , ''3''} | <IDENTIFIER> {''1'' value};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self assert: (TestParser parse: 'a b : c') = 'abc'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testParenthesesOptionalToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> (":" | "|") begin {''1'' value , ''3''} | <IDENTIFIER> {''1'' value};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self assert: (TestParser parse: 'a | b : c') = 'abc'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testPriority
	| parserCompiler |
	TestScanner 
		compile: 'all self recordAndReportMatch: (Array with: self allId)'.
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : \{ | \< \% ;
						<all> : .;'
		andParser: '%id <all> <a>;  begin : A {true}
							| All {false};
					A : <a> ;
					All: <all>;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: '{').
	self assert: (TestParser parse: '<%').
	self deny: (TestParser parse: '}')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testRecursiveRule
	#(#LR1 #LALR1) do: 
			[:each | 
			| parserCompiler |
			parserCompiler := SmaCCGrammarCompiler new.
			parserCompiler grammar type: each.
			parserCompiler buildScanner: self expressionScannerString
				andParser: 'Test: Test1 Recursive;
							Test1: <number> {''1'' value};
							Recursive: | Recursive "|" <number> {''1'' add: ''3'' value; yourself};'.
			parserCompiler compileInto: TestScanner andParser: TestParser.
			self 
				assert: ((parserCompiler grammar nonTerminalSymbolNamed: 'Recursive') 
						firstTerminals 
							includes: (parserCompiler grammar keywordTerminalNamed: '"|"')).
			self 
				assert: (TestParser parse: '2|3|4') = (OrderedCollection 
								with: '2'
								with: '3'
								with: '4')]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testReduceReduceConflict
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<letter> : \w ;
						<whitespace>: \s+	;'
		andParser: 'begin : Foo <letter> {true} | Bar <letter> {false};
					Foo :  ;
					Bar : ;'.
	self 
		assert: (
			[parserCompiler compileInto: TestScanner andParser: TestParser.
			false] 
					on: SmaCCCompilationNotification
					do: 
						[:ex | 
						('*Reduce/Reduce*' match: ex messageText) 
							ifTrue: [ex return: true]
							ifFalse: [ex resume: nil]])! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testRepeatingCharactersBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<A> : a{1,3} ;
						<ID> : \w+ ;
						<whitespace> : \s+ ;'
		andParser: 'begin : {true} | begin <A> {''1''} | begin <ID> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'aa').
	self deny: (TestParser parse: 'aaaa')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testRepeatMultipleToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>){1,2}	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> + ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self 
		assert: ((TestParser parse: 'a1 bb c44') collect: [:each | each value]) 
				asArray = #('a1' 'bb' 'c44').
	self 
		assert: ((TestParser parse: 'aaaaa') collect: [:each | each value]) asArray 
				= #('aaa' 'aa').
	self should: [TestParser parse: ''] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testRepeatToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> * ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self 
		assert: ((TestParser parse: 'a b c') collect: [:each | each value]) asArray 
				= #('a' 'b' 'c').
	self assert: (TestParser parse: '') size = 0! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testReuseCompositeToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTERDIGIT> : [a-zA-Z_] \d ;
						<AAorBB> :  aa | bb;
						<IDENTIFIER>: <LETTERDIGIT> | <AAorBB>	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> begin {false} | <IDENTIFIER> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: '2'] raise: SmaCCParserError.
	self assert: (TestParser parse: 'aa').
	self assert: (TestParser parse: 'bb').
	self assert: (TestParser parse: 'a4').
	self should: [TestParser parse: 'ab'] raise: SmaCCParserError.
	self should: [TestParser parse: '4b'] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testReuseSimpleToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_\\] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> begin {false} | <IDENTIFIER> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: '2'] raise: SmaCCParserError.
	self assert: (TestParser parse: '\')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testSimple
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : a ;' andParser: 'begin : <a> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: '2'] raise: SmaCCParserError.
	self assert: (TestParser parse: 'a')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ''!
testSpecialCharacters
	| parserCompiler |
	[String with: (Character value: 16rFF00)] on: Error do: [:ex | ^self].	"Unicode characters not supported"
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<name> : \x3g \x20 \xFF \xFF1 \xFF00 \cC;'
		andParser: 'begin ::= <name> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser 
				parse: (String withAll: (#(3 103 16r20 16rFF 16rFF1 16rFF00 2) 
								collect: [:each | Character value: each])))! !

Set variableSubclass: #SmaCCItemSet
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCItemSet commentStamp: 'jmb' prior: 0!
SmaCCItemSet represents a LALR(1) or a LR(1) item set.

Instance Variables:
	type	<Symbol>	#LALR1 or #LR1

!

!SmaCCItemSet class methodsFor: 'instance creation' stamp: ''!
new: anInteger 
	^(super new: anInteger)
		initialize;
		yourself! !

!SmaCCItemSet methodsFor: 'accessing' stamp: ''!
action: aGrammarSymbol prefer: aClass 
	| action actionItem eachAction |
	action := SmaCCRejectAction new.
	self do: 
			[:each | 
			eachAction := each action: aGrammarSymbol.
			action class = SmaCCRejectAction 
				ifTrue: 
					[action := eachAction.
					actionItem := each]
				ifFalse: 
					[(eachAction = action or: [eachAction class = SmaCCRejectAction]) 
						ifFalse: 
							[eachAction class = SmaCCShiftAction | (action class = SmaCCShiftAction) 
								ifTrue: 
									["Shift/Reduce conflict -- check precedence"

									(aGrammarSymbol precedence isNil 
										or: [each precedence isNil or: [actionItem precedence isNil]]) 
											ifTrue: 
												["No precedence, choose shift"

												eachAction class = SmaCCShiftAction 
													ifTrue: 
														[self 
															raiseXReduceNotification: each
															with: actionItem
															type: 'Shift/Reduce Conflict'.
														action := eachAction.
														actionItem := each]
													ifFalse: 
														[self 
															raiseXReduceNotification: actionItem
															with: each
															type: 'Shift/Reduce Conflict']]
											ifFalse: 
												[(each precedence > actionItem precedence 
													or: [each precedence = actionItem precedence and: [eachAction class = aClass]]) 
														ifTrue: 
															[self 
																raiseXReduceNotification: each
																with: actionItem
																type: 'Shift/Reduce Conflict (handled by precedence rules)'.
															action := eachAction.
															actionItem := each]
														ifFalse: 
															[(each precedence = actionItem precedence and: [SmaCCRejectAction = aClass]) 
																ifTrue: 
																	[self 
																		raiseXReduceNotificationWithNoPreferredItem: actionItem
																		with: each
																		type: 'Shift/Reduce Conflict (handled by precedence rules)'.
																	^aClass new]
																ifFalse: 
																	[self 
																		raiseXReduceNotification: actionItem
																		with: each
																		type: 'Shift/Reduce Conflict (handled by precedence rules)']]]]
								ifFalse: 
									["Reduce/Reduce conflict -- just pick one and proceed"

									self 
										raiseXReduceNotification: actionItem
										with: each
										type: 'Reduce/Reduce Conflict']]]].
	^action! !

!SmaCCItemSet methodsFor: 'adding' stamp: 'jmb 1/20/2003 21:57'!
add: aLR1Item 
	| index item |
	aLR1Item == nil ifTrue: [^aLR1Item].
	index := self findElementOrNil: aLR1Item.
	item := array basicAt: index.
	item == nil 
		ifTrue: 
			[self atNewIndex: index put: aLR1Item.
			self performClosureOn: aLR1Item]
		ifFalse: [item mergeWith: aLR1Item].
	^aLR1Item! !

!SmaCCItemSet methodsFor: 'copying' stamp: ''!
copyEmpty: aSize 
	^(super copyEmpty: aSize)
		type: type;
		yourself! !

!SmaCCItemSet methodsFor: 'comparing' stamp: ''!
hash
	^self inject: self class hash into: [:sum :each | sum bitXor: each hash]! !

!SmaCCItemSet methodsFor: 'initialize-release' stamp: ''!
initialize
	(self class superclass canUnderstand: #initialize) 
		ifTrue: [super initialize].
	type := #LALR1! !

!SmaCCItemSet methodsFor: 'testing' stamp: ''!
isLALREqualTo: anItemSet 
	^anItemSet size = self size 
		and: [self allSatisfy: [:each | anItemSet includes: each]]! !

!SmaCCItemSet methodsFor: 'testing' stamp: ''!
isLREqualTo: anItemSet 
	^anItemSet size = self size and: 
			[self allSatisfy: 
					[:each | 
					| item |
					(item := anItemSet itemFor: each) notNil and: [each isLR1EqualTo: item]]]! !

!SmaCCItemSet methodsFor: 'private' stamp: 'jmb 1/20/2003 22:09'!
itemFor: anObject 
	^array basicAt: (self findElementOrNil: anObject)! !

!SmaCCItemSet methodsFor: 'accessing' stamp: ''!
mergeWith: anItemSet 
	self == anItemSet ifTrue: [^self].
	anItemSet do: [:each | self add: each]! !

!SmaCCItemSet methodsFor: 'accessing' stamp: ''!
moveOn: aGrammarSymbol 
	| anItemSet |
	anItemSet := self class new.
	anItemSet type: type.
	self 
		do: [:each | each nextSymbol == aGrammarSymbol ifTrue: [anItemSet add: each moveNext]].
	^anItemSet! !

!SmaCCItemSet methodsFor: 'private' stamp: ''!
performClosureOn: aLR1Item 
	| nextSymbol rest first followers |
	nextSymbol := aLR1Item nextSymbol.
	nextSymbol isTerminal ifTrue: [^self].
	rest := aLR1Item rest.
	first := rest firstTerminals.
	followers := SmaCCSymbolSet new.
	(first includes: SmaCCSymbol empty) 
		ifTrue: 
			[first remove: SmaCCSymbol empty.
			followers baseOn: aLR1Item followers].
	followers addAll: first.
	nextSymbol productionsDo: 
			[:each | 
			self add: (SmaCCLR1Item 
						symbol: nextSymbol
						rhs: each
						follow: followers)]! !

!SmaCCItemSet methodsFor: 'printing' stamp: ''!
printOn: aStream 
	self do: 
			[:each | 
			aStream
				tab;
				nextPutAll: each printString;
				cr]! !

!SmaCCItemSet methodsFor: 'accessing' stamp: 'jmb 1/20/2003 22:04'!
raiseXReduceNotificationWithNoPreferredItem: firstItem with: secondItem type: aString 
	| stream |
	stream := WriteStream on: (String new: 200).
	stream
		nextPutAll: firstItem printString;
		cr;
		nextPutAll: secondItem printString.
	SmaCCCompilationNotification new
		tag: stream contents;
		signal: aString! !

!SmaCCItemSet methodsFor: 'accessing' stamp: 'jmb 1/20/2003 22:03'!
raiseXReduceNotification: preferredItem with: otherItem type: aString 
	| stream |
	stream := WriteStream on: (String new: 200).
	stream
		nextPutAll: preferredItem printString;
		nextPutAll: '	*****';
		cr;
		nextPutAll: otherItem printString.
	(SmaCCCompilationNotification new) 
		tag: stream contents; 
		signal: aString! !

!SmaCCItemSet methodsFor: 'initialize-release' stamp: ''!
type: aSymbol 
	type := aSymbol! !

!SmaCCItemSet methodsFor: 'comparing' stamp: ''!
= anItemSet 
	self class = anItemSet class 
		ifTrue: 
			[type == #LALR1
				ifTrue: [^self isLALREqualTo: anItemSet]
				ifFalse: [^self isLREqualTo: anItemSet]].
	^false! !
SmaCCRejectAction initialize!
SmaCCShiftAction initialize!
SmaCCGrammar initialize!
SmaCCNode initialize!
SmaCCParserGenerator initialize!
